/* esm-bundle - @angular/material/autocomplete@15.2.9 - Ivy - system format - es2015 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/core', '@angular/material/core', '@angular/common', '@angular/cdk/scrolling', '@angular/cdk/overlay', '@angular/cdk/a11y', '@angular/cdk/coercion', '@angular/animations', 'rxjs', '@angular/cdk/platform', '@angular/cdk/keycodes', '@angular/cdk/portal', '@angular/forms', '@angular/material/form-field', 'rxjs/operators', '@angular/cdk/bidi'], (function (exports) {
    'use strict';
    var InjectionToken, i0, TemplateRef, Directive, Inject, ViewChild, Input, Output, Component, ViewEncapsulation, ChangeDetectionStrategy, ContentChildren, forwardRef, Optional, Host, NgModule, EventEmitter, mixinDisableRipple, MAT_OPTGROUP, MatOption, MAT_OPTION_PARENT_COMPONENT, MatOptionModule, MatCommonModule, MatOptionSelectionChange, _countGroupLabelsBeforeOption, _getOptionScrollPosition, i2, DOCUMENT, CommonModule, i3, CdkScrollableModule, i1$1, OverlayModule, Overlay, OverlayConfig, ActiveDescendantKeyManager, coerceBooleanProperty, coerceStringArray, trigger, state, style, transition, group, animate, Subscription, Subject, defer, merge, of, fromEvent, i1, _getEventTarget, hasModifierKey, ESCAPE, ENTER, TAB, UP_ARROW, DOWN_ARROW, TemplatePortal, NG_VALUE_ACCESSOR, i4, MAT_FORM_FIELD, startWith, switchMap, take, filter, map, tap, delay, i2$1;
    return {
        setters: [function (module) {
            InjectionToken = module.InjectionToken;
            i0 = module;
            TemplateRef = module.TemplateRef;
            Directive = module.Directive;
            Inject = module.Inject;
            ViewChild = module.ViewChild;
            Input = module.Input;
            Output = module.Output;
            Component = module.Component;
            ViewEncapsulation = module.ViewEncapsulation;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            ContentChildren = module.ContentChildren;
            forwardRef = module.forwardRef;
            Optional = module.Optional;
            Host = module.Host;
            NgModule = module.NgModule;
            EventEmitter = module.EventEmitter;
        }, function (module) {
            mixinDisableRipple = module.mixinDisableRipple;
            MAT_OPTGROUP = module.MAT_OPTGROUP;
            MatOption = module.MatOption;
            MAT_OPTION_PARENT_COMPONENT = module.MAT_OPTION_PARENT_COMPONENT;
            MatOptionModule = module.MatOptionModule;
            MatCommonModule = module.MatCommonModule;
            MatOptionSelectionChange = module.MatOptionSelectionChange;
            _countGroupLabelsBeforeOption = module._countGroupLabelsBeforeOption;
            _getOptionScrollPosition = module._getOptionScrollPosition;
        }, function (module) {
            i2 = module;
            DOCUMENT = module.DOCUMENT;
            CommonModule = module.CommonModule;
        }, function (module) {
            i3 = module;
            CdkScrollableModule = module.CdkScrollableModule;
        }, function (module) {
            i1$1 = module;
            OverlayModule = module.OverlayModule;
            Overlay = module.Overlay;
            OverlayConfig = module.OverlayConfig;
        }, function (module) {
            ActiveDescendantKeyManager = module.ActiveDescendantKeyManager;
        }, function (module) {
            coerceBooleanProperty = module.coerceBooleanProperty;
            coerceStringArray = module.coerceStringArray;
        }, function (module) {
            trigger = module.trigger;
            state = module.state;
            style = module.style;
            transition = module.transition;
            group = module.group;
            animate = module.animate;
        }, function (module) {
            Subscription = module.Subscription;
            Subject = module.Subject;
            defer = module.defer;
            merge = module.merge;
            of = module.of;
            fromEvent = module.fromEvent;
        }, function (module) {
            i1 = module;
            _getEventTarget = module._getEventTarget;
        }, function (module) {
            hasModifierKey = module.hasModifierKey;
            ESCAPE = module.ESCAPE;
            ENTER = module.ENTER;
            TAB = module.TAB;
            UP_ARROW = module.UP_ARROW;
            DOWN_ARROW = module.DOWN_ARROW;
        }, function (module) {
            TemplatePortal = module.TemplatePortal;
        }, function (module) {
            NG_VALUE_ACCESSOR = module.NG_VALUE_ACCESSOR;
        }, function (module) {
            i4 = module;
            MAT_FORM_FIELD = module.MAT_FORM_FIELD;
        }, function (module) {
            startWith = module.startWith;
            switchMap = module.switchMap;
            take = module.take;
            filter = module.filter;
            map = module.map;
            tap = module.tap;
            delay = module.delay;
        }, function (module) {
            i2$1 = module;
        }],
        execute: (function () {

            exports({
                MAT_AUTOCOMPLETE_DEFAULT_OPTIONS_FACTORY: MAT_AUTOCOMPLETE_DEFAULT_OPTIONS_FACTORY,
                MAT_AUTOCOMPLETE_SCROLL_STRATEGY_FACTORY: MAT_AUTOCOMPLETE_SCROLL_STRATEGY_FACTORY,
                getMatAutocompleteMissingPanelError: getMatAutocompleteMissingPanelError
            });

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            // Animation values come from
            // https://github.com/material-components/material-components-web/blob/master/packages/mdc-menu-surface/_mixins.scss
            // TODO(mmalerba): Ideally find a way to import the values from MDC's code.
            const _c0 = ["panel"];
            function MatAutocomplete_ng_template_0_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 0, 1);
                i0.ɵɵprojection(2);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const formFieldId_r1 = ctx.id;
                const ctx_r0 = i0.ɵɵnextContext();
                i0.ɵɵproperty("id", ctx_r0.id)("ngClass", ctx_r0._classList)("@panelAnimation", ctx_r0.isOpen ? "visible" : "hidden");
                i0.ɵɵattribute("aria-label", ctx_r0.ariaLabel || null)("aria-labelledby", ctx_r0._getPanelAriaLabelledby(formFieldId_r1));
              }
            }
            const _c1 = ["*"];
            const panelAnimation = trigger('panelAnimation', [state('void, hidden', style({
              opacity: 0,
              transform: 'scaleY(0.8)'
            })), transition(':enter, hidden => visible', [group([animate('0.03s linear', style({
              opacity: 1
            })), animate('0.12s cubic-bezier(0, 0, 0.2, 1)', style({
              transform: 'scaleY(1)'
            }))])]), transition(':leave, visible => hidden', [animate('0.075s linear', style({
              opacity: 0
            }))])]);

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Autocomplete IDs need to be unique across components, so this counter exists outside of
             * the component definition.
             */
            let _uniqueAutocompleteIdCounter = 0;
            /** Event object that is emitted when an autocomplete option is selected. */
            class MatAutocompleteSelectedEvent {
              constructor( /** Reference to the autocomplete panel that emitted the event. */
              source, /** Option that was selected. */
              option) {
                this.source = source;
                this.option = option;
              }
            } exports('MatAutocompleteSelectedEvent', MatAutocompleteSelectedEvent);
            // Boilerplate for applying mixins to MatAutocomplete.
            /** @docs-private */
            const _MatAutocompleteMixinBase = mixinDisableRipple(class {});
            /** Injection token to be used to override the default options for `mat-autocomplete`. */
            const MAT_AUTOCOMPLETE_DEFAULT_OPTIONS = exports('MAT_AUTOCOMPLETE_DEFAULT_OPTIONS', new InjectionToken('mat-autocomplete-default-options', {
              providedIn: 'root',
              factory: MAT_AUTOCOMPLETE_DEFAULT_OPTIONS_FACTORY
            }));
            /** @docs-private */
            function MAT_AUTOCOMPLETE_DEFAULT_OPTIONS_FACTORY() {
              return {
                autoActiveFirstOption: false,
                autoSelectActiveOption: false,
                hideSingleSelectionIndicator: false
              };
            }
            /** Base class with all of the `MatAutocomplete` functionality. */
            class _MatAutocompleteBase extends _MatAutocompleteMixinBase {
              /** Whether the autocomplete panel is open. */
              get isOpen() {
                return this._isOpen && this.showPanel;
              }
              /** @docs-private Sets the theme color of the panel. */
              _setColor(value) {
                this._color = value;
                this._setThemeClasses(this._classList);
              }
              /**
               * Whether the first option should be highlighted when the autocomplete panel is opened.
               * Can be configured globally through the `MAT_AUTOCOMPLETE_DEFAULT_OPTIONS` token.
               */
              get autoActiveFirstOption() {
                return this._autoActiveFirstOption;
              }
              set autoActiveFirstOption(value) {
                this._autoActiveFirstOption = coerceBooleanProperty(value);
              }
              /** Whether the active option should be selected as the user is navigating. */
              get autoSelectActiveOption() {
                return this._autoSelectActiveOption;
              }
              set autoSelectActiveOption(value) {
                this._autoSelectActiveOption = coerceBooleanProperty(value);
              }
              /**
               * Takes classes set on the host mat-autocomplete element and applies them to the panel
               * inside the overlay container to allow for easy styling.
               */
              set classList(value) {
                if (value && value.length) {
                  this._classList = coerceStringArray(value).reduce((classList, className) => {
                    classList[className] = true;
                    return classList;
                  }, {});
                } else {
                  this._classList = {};
                }
                this._setVisibilityClasses(this._classList);
                this._setThemeClasses(this._classList);
                this._elementRef.nativeElement.className = '';
              }
              constructor(_changeDetectorRef, _elementRef, _defaults, platform) {
                super();
                this._changeDetectorRef = _changeDetectorRef;
                this._elementRef = _elementRef;
                this._defaults = _defaults;
                this._activeOptionChanges = Subscription.EMPTY;
                /** Whether the autocomplete panel should be visible, depending on option length. */
                this.showPanel = false;
                this._isOpen = false;
                /** Function that maps an option's control value to its display value in the trigger. */
                this.displayWith = null;
                this._autoActiveFirstOption = !!this._defaults.autoActiveFirstOption;
                this._autoSelectActiveOption = !!this._defaults.autoSelectActiveOption;
                /** Event that is emitted whenever an option from the list is selected. */
                this.optionSelected = new EventEmitter();
                /** Event that is emitted when the autocomplete panel is opened. */
                this.opened = new EventEmitter();
                /** Event that is emitted when the autocomplete panel is closed. */
                this.closed = new EventEmitter();
                /** Emits whenever an option is activated. */
                this.optionActivated = new EventEmitter();
                this._classList = {};
                /** Unique ID to be used by autocomplete trigger's "aria-owns" property. */
                this.id = `mat-autocomplete-${_uniqueAutocompleteIdCounter++}`;
                // TODO(crisbeto): the problem that the `inertGroups` option resolves is only present on
                // Safari using VoiceOver. We should occasionally check back to see whether the bug
                // wasn't resolved in VoiceOver, and if it has, we can remove this and the `inertGroups`
                // option altogether.
                this.inertGroups = (platform === null || platform === void 0 ? void 0 : platform.SAFARI) || false;
              }
              ngAfterContentInit() {
                this._keyManager = new ActiveDescendantKeyManager(this.options).withWrap();
                this._activeOptionChanges = this._keyManager.change.subscribe(index => {
                  if (this.isOpen) {
                    this.optionActivated.emit({
                      source: this,
                      option: this.options.toArray()[index] || null
                    });
                  }
                });
                // Set the initial visibility state.
                this._setVisibility();
              }
              ngOnDestroy() {
                var _a;
                (_a = this._keyManager) === null || _a === void 0 ? void 0 : _a.destroy();
                this._activeOptionChanges.unsubscribe();
              }
              /**
               * Sets the panel scrollTop. This allows us to manually scroll to display options
               * above or below the fold, as they are not actually being focused when active.
               */
              _setScrollTop(scrollTop) {
                if (this.panel) {
                  this.panel.nativeElement.scrollTop = scrollTop;
                }
              }
              /** Returns the panel's scrollTop. */
              _getScrollTop() {
                return this.panel ? this.panel.nativeElement.scrollTop : 0;
              }
              /** Panel should hide itself when the option list is empty. */
              _setVisibility() {
                this.showPanel = !!this.options.length;
                this._setVisibilityClasses(this._classList);
                this._changeDetectorRef.markForCheck();
              }
              /** Emits the `select` event. */
              _emitSelectEvent(option) {
                const event = new MatAutocompleteSelectedEvent(this, option);
                this.optionSelected.emit(event);
              }
              /** Gets the aria-labelledby for the autocomplete panel. */
              _getPanelAriaLabelledby(labelId) {
                if (this.ariaLabel) {
                  return null;
                }
                const labelExpression = labelId ? labelId + ' ' : '';
                return this.ariaLabelledby ? labelExpression + this.ariaLabelledby : labelId;
              }
              /** Sets the autocomplete visibility classes on a classlist based on the panel is visible. */
              _setVisibilityClasses(classList) {
                classList[this._visibleClass] = this.showPanel;
                classList[this._hiddenClass] = !this.showPanel;
              }
              /** Sets the theming classes on a classlist based on the theme of the panel. */
              _setThemeClasses(classList) {
                classList['mat-primary'] = this._color === 'primary';
                classList['mat-warn'] = this._color === 'warn';
                classList['mat-accent'] = this._color === 'accent';
              }
            } exports('_MatAutocompleteBase', _MatAutocompleteBase);
            _MatAutocompleteBase.ɵfac = function _MatAutocompleteBase_Factory(t) {
              return new (t || _MatAutocompleteBase)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(MAT_AUTOCOMPLETE_DEFAULT_OPTIONS), i0.ɵɵdirectiveInject(i1.Platform));
            };
            _MatAutocompleteBase.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: _MatAutocompleteBase,
              viewQuery: function _MatAutocompleteBase_Query(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵviewQuery(TemplateRef, 7);
                  i0.ɵɵviewQuery(_c0, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.template = _t.first);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.panel = _t.first);
                }
              },
              inputs: {
                ariaLabel: ["aria-label", "ariaLabel"],
                ariaLabelledby: ["aria-labelledby", "ariaLabelledby"],
                displayWith: "displayWith",
                autoActiveFirstOption: "autoActiveFirstOption",
                autoSelectActiveOption: "autoSelectActiveOption",
                panelWidth: "panelWidth",
                classList: ["class", "classList"]
              },
              outputs: {
                optionSelected: "optionSelected",
                opened: "opened",
                closed: "closed",
                optionActivated: "optionActivated"
              },
              features: [i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(_MatAutocompleteBase, [{
                type: Directive
              }], function () {
                return [{
                  type: i0.ChangeDetectorRef
                }, {
                  type: i0.ElementRef
                }, {
                  type: undefined,
                  decorators: [{
                    type: Inject,
                    args: [MAT_AUTOCOMPLETE_DEFAULT_OPTIONS]
                  }]
                }, {
                  type: i1.Platform
                }];
              }, {
                template: [{
                  type: ViewChild,
                  args: [TemplateRef, {
                    static: true
                  }]
                }],
                panel: [{
                  type: ViewChild,
                  args: ['panel']
                }],
                ariaLabel: [{
                  type: Input,
                  args: ['aria-label']
                }],
                ariaLabelledby: [{
                  type: Input,
                  args: ['aria-labelledby']
                }],
                displayWith: [{
                  type: Input
                }],
                autoActiveFirstOption: [{
                  type: Input
                }],
                autoSelectActiveOption: [{
                  type: Input
                }],
                panelWidth: [{
                  type: Input
                }],
                optionSelected: [{
                  type: Output
                }],
                opened: [{
                  type: Output
                }],
                closed: [{
                  type: Output
                }],
                optionActivated: [{
                  type: Output
                }],
                classList: [{
                  type: Input,
                  args: ['class']
                }]
              });
            })();
            class MatAutocomplete extends _MatAutocompleteBase {
              constructor() {
                var _a;
                super(...arguments);
                this._visibleClass = 'mat-mdc-autocomplete-visible';
                this._hiddenClass = 'mat-mdc-autocomplete-hidden';
                this._hideSingleSelectionIndicator = (_a = this._defaults.hideSingleSelectionIndicator) !== null && _a !== void 0 ? _a : false;
              }
              /** Whether checkmark indicator for single-selection options is hidden. */
              get hideSingleSelectionIndicator() {
                return this._hideSingleSelectionIndicator;
              }
              set hideSingleSelectionIndicator(value) {
                this._hideSingleSelectionIndicator = coerceBooleanProperty(value);
                this._syncParentProperties();
              }
              /** Syncs the parent state with the individual options. */
              _syncParentProperties() {
                if (this.options) {
                  for (const option of this.options) {
                    option._changeDetectorRef.markForCheck();
                  }
                }
              }
            } exports('MatAutocomplete', MatAutocomplete);
            MatAutocomplete.ɵfac = /* @__PURE__ */function () {
              let ɵMatAutocomplete_BaseFactory;
              return function MatAutocomplete_Factory(t) {
                return (ɵMatAutocomplete_BaseFactory || (ɵMatAutocomplete_BaseFactory = i0.ɵɵgetInheritedFactory(MatAutocomplete)))(t || MatAutocomplete);
              };
            }();
            MatAutocomplete.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatAutocomplete,
              selectors: [["mat-autocomplete"]],
              contentQueries: function MatAutocomplete_ContentQueries(rf, ctx, dirIndex) {
                if (rf & 1) {
                  i0.ɵɵcontentQuery(dirIndex, MAT_OPTGROUP, 5);
                  i0.ɵɵcontentQuery(dirIndex, MatOption, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.optionGroups = _t);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.options = _t);
                }
              },
              hostAttrs: [1, "mat-mdc-autocomplete"],
              inputs: {
                disableRipple: "disableRipple",
                hideSingleSelectionIndicator: "hideSingleSelectionIndicator"
              },
              exportAs: ["matAutocomplete"],
              features: [i0.ɵɵProvidersFeature([{
                provide: MAT_OPTION_PARENT_COMPONENT,
                useExisting: MatAutocomplete
              }]), i0.ɵɵInheritDefinitionFeature],
              ngContentSelectors: _c1,
              decls: 1,
              vars: 0,
              consts: [["role", "listbox", 1, "mat-mdc-autocomplete-panel", "mdc-menu-surface", "mdc-menu-surface--open", 3, "id", "ngClass"], ["panel", ""]],
              template: function MatAutocomplete_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵprojectionDef();
                  i0.ɵɵtemplate(0, MatAutocomplete_ng_template_0_Template, 3, 5, "ng-template");
                }
              },
              dependencies: [i2.NgClass],
              styles: [".mdc-menu-surface{display:none;position:absolute;box-sizing:border-box;max-width:calc(100vw - 32px);max-width:var(--mdc-menu-max-width, calc(100vw - 32px));max-height:calc(100vh - 32px);max-height:var(--mdc-menu-max-height, calc(100vh - 32px));margin:0;padding:0;transform:scale(1);transform-origin:top left;opacity:0;overflow:auto;will-change:transform,opacity;z-index:8;border-radius:4px;border-radius:var(--mdc-shape-medium, 4px);transform-origin-left:top left;transform-origin-right:top right}.mdc-menu-surface:focus{outline:none}.mdc-menu-surface--animating-open{display:inline-block;transform:scale(0.8);opacity:0}.mdc-menu-surface--open{display:inline-block;transform:scale(1);opacity:1}.mdc-menu-surface--animating-closed{display:inline-block;opacity:0}[dir=rtl] .mdc-menu-surface,.mdc-menu-surface[dir=rtl]{transform-origin-left:top right;transform-origin-right:top left}.mdc-menu-surface--anchor{position:relative;overflow:visible}.mdc-menu-surface--fixed{position:fixed}.mdc-menu-surface--fullwidth{width:100%}.mdc-menu-surface.mat-mdc-autocomplete-panel{width:100%;max-height:256px;position:static;visibility:hidden;transform-origin:center top;margin:0;padding:8px 0;list-style-type:none}.mdc-menu-surface.mat-mdc-autocomplete-panel:focus{outline:none}.cdk-high-contrast-active .mdc-menu-surface.mat-mdc-autocomplete-panel{outline:solid 1px}.cdk-overlay-pane:not(.mat-mdc-autocomplete-panel-above) .mdc-menu-surface.mat-mdc-autocomplete-panel{border-top-left-radius:0;border-top-right-radius:0}.mat-mdc-autocomplete-panel-above .mdc-menu-surface.mat-mdc-autocomplete-panel{border-bottom-left-radius:0;border-bottom-right-radius:0;transform-origin:center bottom}.mdc-menu-surface.mat-mdc-autocomplete-panel.mat-mdc-autocomplete-visible{visibility:visible}.mdc-menu-surface.mat-mdc-autocomplete-panel.mat-mdc-autocomplete-hidden{visibility:hidden}mat-autocomplete{display:none}"],
              encapsulation: 2,
              data: {
                animation: [panelAnimation]
              },
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatAutocomplete, [{
                type: Component,
                args: [{
                  selector: 'mat-autocomplete',
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  exportAs: 'matAutocomplete',
                  inputs: ['disableRipple'],
                  host: {
                    'class': 'mat-mdc-autocomplete'
                  },
                  providers: [{
                    provide: MAT_OPTION_PARENT_COMPONENT,
                    useExisting: MatAutocomplete
                  }],
                  animations: [panelAnimation],
                  template: "<ng-template let-formFieldId=\"id\">\n  <div\n    class=\"mat-mdc-autocomplete-panel mdc-menu-surface mdc-menu-surface--open\"\n    role=\"listbox\"\n    [id]=\"id\"\n    [ngClass]=\"_classList\"\n    [attr.aria-label]=\"ariaLabel || null\"\n    [attr.aria-labelledby]=\"_getPanelAriaLabelledby(formFieldId)\"\n    [@panelAnimation]=\"isOpen ? 'visible' : 'hidden'\"\n    #panel>\n    <ng-content></ng-content>\n  </div>\n</ng-template>\n",
                  styles: [".mdc-menu-surface{display:none;position:absolute;box-sizing:border-box;max-width:calc(100vw - 32px);max-width:var(--mdc-menu-max-width, calc(100vw - 32px));max-height:calc(100vh - 32px);max-height:var(--mdc-menu-max-height, calc(100vh - 32px));margin:0;padding:0;transform:scale(1);transform-origin:top left;opacity:0;overflow:auto;will-change:transform,opacity;z-index:8;border-radius:4px;border-radius:var(--mdc-shape-medium, 4px);transform-origin-left:top left;transform-origin-right:top right}.mdc-menu-surface:focus{outline:none}.mdc-menu-surface--animating-open{display:inline-block;transform:scale(0.8);opacity:0}.mdc-menu-surface--open{display:inline-block;transform:scale(1);opacity:1}.mdc-menu-surface--animating-closed{display:inline-block;opacity:0}[dir=rtl] .mdc-menu-surface,.mdc-menu-surface[dir=rtl]{transform-origin-left:top right;transform-origin-right:top left}.mdc-menu-surface--anchor{position:relative;overflow:visible}.mdc-menu-surface--fixed{position:fixed}.mdc-menu-surface--fullwidth{width:100%}.mdc-menu-surface.mat-mdc-autocomplete-panel{width:100%;max-height:256px;position:static;visibility:hidden;transform-origin:center top;margin:0;padding:8px 0;list-style-type:none}.mdc-menu-surface.mat-mdc-autocomplete-panel:focus{outline:none}.cdk-high-contrast-active .mdc-menu-surface.mat-mdc-autocomplete-panel{outline:solid 1px}.cdk-overlay-pane:not(.mat-mdc-autocomplete-panel-above) .mdc-menu-surface.mat-mdc-autocomplete-panel{border-top-left-radius:0;border-top-right-radius:0}.mat-mdc-autocomplete-panel-above .mdc-menu-surface.mat-mdc-autocomplete-panel{border-bottom-left-radius:0;border-bottom-right-radius:0;transform-origin:center bottom}.mdc-menu-surface.mat-mdc-autocomplete-panel.mat-mdc-autocomplete-visible{visibility:visible}.mdc-menu-surface.mat-mdc-autocomplete-panel.mat-mdc-autocomplete-hidden{visibility:hidden}mat-autocomplete{display:none}"]
                }]
              }], null, {
                optionGroups: [{
                  type: ContentChildren,
                  args: [MAT_OPTGROUP, {
                    descendants: true
                  }]
                }],
                options: [{
                  type: ContentChildren,
                  args: [MatOption, {
                    descendants: true
                  }]
                }],
                hideSingleSelectionIndicator: [{
                  type: Input
                }]
              });
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Provider that allows the autocomplete to register as a ControlValueAccessor.
             * @docs-private
             */
            const MAT_AUTOCOMPLETE_VALUE_ACCESSOR = exports('MAT_AUTOCOMPLETE_VALUE_ACCESSOR', {
              provide: NG_VALUE_ACCESSOR,
              useExisting: forwardRef(() => MatAutocompleteTrigger),
              multi: true
            });
            /**
             * Creates an error to be thrown when attempting to use an autocomplete trigger without a panel.
             * @docs-private
             */
            function getMatAutocompleteMissingPanelError() {
              return Error('Attempting to open an undefined instance of `mat-autocomplete`. ' + 'Make sure that the id passed to the `matAutocomplete` is correct and that ' + "you're attempting to open it after the ngAfterContentInit hook.");
            }
            /** Injection token that determines the scroll handling while the autocomplete panel is open. */
            const MAT_AUTOCOMPLETE_SCROLL_STRATEGY = exports('MAT_AUTOCOMPLETE_SCROLL_STRATEGY', new InjectionToken('mat-autocomplete-scroll-strategy'));
            /** @docs-private */
            function MAT_AUTOCOMPLETE_SCROLL_STRATEGY_FACTORY(overlay) {
              return () => overlay.scrollStrategies.reposition();
            }
            /** @docs-private */
            const MAT_AUTOCOMPLETE_SCROLL_STRATEGY_FACTORY_PROVIDER = exports('MAT_AUTOCOMPLETE_SCROLL_STRATEGY_FACTORY_PROVIDER', {
              provide: MAT_AUTOCOMPLETE_SCROLL_STRATEGY,
              deps: [Overlay],
              useFactory: MAT_AUTOCOMPLETE_SCROLL_STRATEGY_FACTORY
            });
            /** Base class with all of the `MatAutocompleteTrigger` functionality. */
            class _MatAutocompleteTriggerBase {
              /**
               * Whether the autocomplete is disabled. When disabled, the element will
               * act as a regular input and the user won't be able to open the panel.
               */
              get autocompleteDisabled() {
                return this._autocompleteDisabled;
              }
              set autocompleteDisabled(value) {
                this._autocompleteDisabled = coerceBooleanProperty(value);
              }
              constructor(_element, _overlay, _viewContainerRef, _zone, _changeDetectorRef, scrollStrategy, _dir, _formField, _document, _viewportRuler, _defaults) {
                this._element = _element;
                this._overlay = _overlay;
                this._viewContainerRef = _viewContainerRef;
                this._zone = _zone;
                this._changeDetectorRef = _changeDetectorRef;
                this._dir = _dir;
                this._formField = _formField;
                this._document = _document;
                this._viewportRuler = _viewportRuler;
                this._defaults = _defaults;
                this._componentDestroyed = false;
                this._autocompleteDisabled = false;
                /** Whether or not the label state is being overridden. */
                this._manuallyFloatingLabel = false;
                /** Subscription to viewport size changes. */
                this._viewportSubscription = Subscription.EMPTY;
                /**
                 * Whether the autocomplete can open the next time it is focused. Used to prevent a focused,
                 * closed autocomplete from being reopened if the user switches to another browser tab and then
                 * comes back.
                 */
                this._canOpenOnNextFocus = true;
                /** Stream of keyboard events that can close the panel. */
                this._closeKeyEventStream = new Subject();
                /**
                 * Event handler for when the window is blurred. Needs to be an
                 * arrow function in order to preserve the context.
                 */
                this._windowBlurHandler = () => {
                  // If the user blurred the window while the autocomplete is focused, it means that it'll be
                  // refocused when they come back. In this case we want to skip the first focus event, if the
                  // pane was closed, in order to avoid reopening it unintentionally.
                  this._canOpenOnNextFocus = this._document.activeElement !== this._element.nativeElement || this.panelOpen;
                };
                /** `View -> model callback called when value changes` */
                this._onChange = () => {};
                /** `View -> model callback called when autocomplete has been touched` */
                this._onTouched = () => {};
                /**
                 * Position of the autocomplete panel relative to the trigger element. A position of `auto`
                 * will render the panel underneath the trigger if there is enough space for it to fit in
                 * the viewport, otherwise the panel will be shown above it. If the position is set to
                 * `above` or `below`, the panel will always be shown above or below the trigger. no matter
                 * whether it fits completely in the viewport.
                 */
                this.position = 'auto';
                /**
                 * `autocomplete` attribute to be set on the input element.
                 * @docs-private
                 */
                this.autocompleteAttribute = 'off';
                this._overlayAttached = false;
                /** Stream of changes to the selection state of the autocomplete options. */
                this.optionSelections = defer(() => {
                  const options = this.autocomplete ? this.autocomplete.options : null;
                  if (options) {
                    return options.changes.pipe(startWith(options), switchMap(() => merge(...options.map(option => option.onSelectionChange))));
                  }
                  // If there are any subscribers before `ngAfterViewInit`, the `autocomplete` will be undefined.
                  // Return a stream that we'll replace with the real one once everything is in place.
                  return this._zone.onStable.pipe(take(1), switchMap(() => this.optionSelections));
                });
                this._scrollStrategy = scrollStrategy;
              }
              ngAfterViewInit() {
                const window = this._getWindow();
                if (typeof window !== 'undefined') {
                  this._zone.runOutsideAngular(() => window.addEventListener('blur', this._windowBlurHandler));
                }
              }
              ngOnChanges(changes) {
                if (changes['position'] && this._positionStrategy) {
                  this._setStrategyPositions(this._positionStrategy);
                  if (this.panelOpen) {
                    this._overlayRef.updatePosition();
                  }
                }
              }
              ngOnDestroy() {
                const window = this._getWindow();
                if (typeof window !== 'undefined') {
                  window.removeEventListener('blur', this._windowBlurHandler);
                }
                this._viewportSubscription.unsubscribe();
                this._componentDestroyed = true;
                this._destroyPanel();
                this._closeKeyEventStream.complete();
              }
              /** Whether or not the autocomplete panel is open. */
              get panelOpen() {
                return this._overlayAttached && this.autocomplete.showPanel;
              }
              /** Opens the autocomplete suggestion panel. */
              openPanel() {
                this._attachOverlay();
                this._floatLabel();
              }
              /** Closes the autocomplete suggestion panel. */
              closePanel() {
                this._resetLabel();
                if (!this._overlayAttached) {
                  return;
                }
                if (this.panelOpen) {
                  // Only emit if the panel was visible.
                  // The `NgZone.onStable` always emits outside of the Angular zone,
                  // so all the subscriptions from `_subscribeToClosingActions()` are also outside of the Angular zone.
                  // We should manually run in Angular zone to update UI after panel closing.
                  this._zone.run(() => {
                    this.autocomplete.closed.emit();
                  });
                }
                this.autocomplete._isOpen = this._overlayAttached = false;
                this._pendingAutoselectedOption = null;
                if (this._overlayRef && this._overlayRef.hasAttached()) {
                  this._overlayRef.detach();
                  this._closingActionsSubscription.unsubscribe();
                }
                // Note that in some cases this can end up being called after the component is destroyed.
                // Add a check to ensure that we don't try to run change detection on a destroyed view.
                if (!this._componentDestroyed) {
                  // We need to trigger change detection manually, because
                  // `fromEvent` doesn't seem to do it at the proper time.
                  // This ensures that the label is reset when the
                  // user clicks outside.
                  this._changeDetectorRef.detectChanges();
                }
              }
              /**
               * Updates the position of the autocomplete suggestion panel to ensure that it fits all options
               * within the viewport.
               */
              updatePosition() {
                if (this._overlayAttached) {
                  this._overlayRef.updatePosition();
                }
              }
              /**
               * A stream of actions that should close the autocomplete panel, including
               * when an option is selected, on blur, and when TAB is pressed.
               */
              get panelClosingActions() {
                return merge(this.optionSelections, this.autocomplete._keyManager.tabOut.pipe(filter(() => this._overlayAttached)), this._closeKeyEventStream, this._getOutsideClickStream(), this._overlayRef ? this._overlayRef.detachments().pipe(filter(() => this._overlayAttached)) : of()).pipe(
                // Normalize the output so we return a consistent type.
                map(event => event instanceof MatOptionSelectionChange ? event : null));
              }
              /** The currently active option, coerced to MatOption type. */
              get activeOption() {
                if (this.autocomplete && this.autocomplete._keyManager) {
                  return this.autocomplete._keyManager.activeItem;
                }
                return null;
              }
              /** Stream of clicks outside of the autocomplete panel. */
              _getOutsideClickStream() {
                return merge(fromEvent(this._document, 'click'), fromEvent(this._document, 'auxclick'), fromEvent(this._document, 'touchend')).pipe(filter(event => {
                  // If we're in the Shadow DOM, the event target will be the shadow root, so we have to
                  // fall back to check the first element in the path of the click event.
                  const clickTarget = _getEventTarget(event);
                  const formField = this._formField ? this._formField._elementRef.nativeElement : null;
                  const customOrigin = this.connectedTo ? this.connectedTo.elementRef.nativeElement : null;
                  return this._overlayAttached && clickTarget !== this._element.nativeElement &&
                  // Normally focus moves inside `mousedown` so this condition will almost always be
                  // true. Its main purpose is to handle the case where the input is focused from an
                  // outside click which propagates up to the `body` listener within the same sequence
                  // and causes the panel to close immediately (see #3106).
                  this._document.activeElement !== this._element.nativeElement && (!formField || !formField.contains(clickTarget)) && (!customOrigin || !customOrigin.contains(clickTarget)) && !!this._overlayRef && !this._overlayRef.overlayElement.contains(clickTarget);
                }));
              }
              // Implemented as part of ControlValueAccessor.
              writeValue(value) {
                Promise.resolve(null).then(() => this._assignOptionValue(value));
              }
              // Implemented as part of ControlValueAccessor.
              registerOnChange(fn) {
                this._onChange = fn;
              }
              // Implemented as part of ControlValueAccessor.
              registerOnTouched(fn) {
                this._onTouched = fn;
              }
              // Implemented as part of ControlValueAccessor.
              setDisabledState(isDisabled) {
                this._element.nativeElement.disabled = isDisabled;
              }
              _handleKeydown(event) {
                const keyCode = event.keyCode;
                const hasModifier = hasModifierKey(event);
                // Prevent the default action on all escape key presses. This is here primarily to bring IE
                // in line with other browsers. By default, pressing escape on IE will cause it to revert
                // the input value to the one that it had on focus, however it won't dispatch any events
                // which means that the model value will be out of sync with the view.
                if (keyCode === ESCAPE && !hasModifier) {
                  event.preventDefault();
                }
                if (this.activeOption && keyCode === ENTER && this.panelOpen && !hasModifier) {
                  this.activeOption._selectViaInteraction();
                  this._resetActiveItem();
                  event.preventDefault();
                } else if (this.autocomplete) {
                  const prevActiveItem = this.autocomplete._keyManager.activeItem;
                  const isArrowKey = keyCode === UP_ARROW || keyCode === DOWN_ARROW;
                  if (keyCode === TAB || isArrowKey && !hasModifier && this.panelOpen) {
                    this.autocomplete._keyManager.onKeydown(event);
                  } else if (isArrowKey && this._canOpen()) {
                    this.openPanel();
                  }
                  if (isArrowKey || this.autocomplete._keyManager.activeItem !== prevActiveItem) {
                    this._scrollToOption(this.autocomplete._keyManager.activeItemIndex || 0);
                    if (this.autocomplete.autoSelectActiveOption && this.activeOption) {
                      if (!this._pendingAutoselectedOption) {
                        this._valueBeforeAutoSelection = this._element.nativeElement.value;
                      }
                      this._pendingAutoselectedOption = this.activeOption;
                      this._assignOptionValue(this.activeOption.value);
                    }
                  }
                }
              }
              _handleInput(event) {
                let target = event.target;
                let value = target.value;
                // Based on `NumberValueAccessor` from forms.
                if (target.type === 'number') {
                  value = value == '' ? null : parseFloat(value);
                }
                // If the input has a placeholder, IE will fire the `input` event on page load,
                // focus and blur, in addition to when the user actually changed the value. To
                // filter out all of the extra events, we save the value on focus and between
                // `input` events, and we check whether it changed.
                // See: https://connect.microsoft.com/IE/feedback/details/885747/
                if (this._previousValue !== value) {
                  this._previousValue = value;
                  this._pendingAutoselectedOption = null;
                  this._onChange(value);
                  if (this._canOpen() && this._document.activeElement === event.target) {
                    this.openPanel();
                  }
                }
              }
              _handleFocus() {
                if (!this._canOpenOnNextFocus) {
                  this._canOpenOnNextFocus = true;
                } else if (this._canOpen()) {
                  this._previousValue = this._element.nativeElement.value;
                  this._attachOverlay();
                  this._floatLabel(true);
                }
              }
              _handleClick() {
                if (this._canOpen() && !this.panelOpen) {
                  this.openPanel();
                }
              }
              /**
               * In "auto" mode, the label will animate down as soon as focus is lost.
               * This causes the value to jump when selecting an option with the mouse.
               * This method manually floats the label until the panel can be closed.
               * @param shouldAnimate Whether the label should be animated when it is floated.
               */
              _floatLabel(shouldAnimate = false) {
                if (this._formField && this._formField.floatLabel === 'auto') {
                  if (shouldAnimate) {
                    this._formField._animateAndLockLabel();
                  } else {
                    this._formField.floatLabel = 'always';
                  }
                  this._manuallyFloatingLabel = true;
                }
              }
              /** If the label has been manually elevated, return it to its normal state. */
              _resetLabel() {
                if (this._manuallyFloatingLabel) {
                  if (this._formField) {
                    this._formField.floatLabel = 'auto';
                  }
                  this._manuallyFloatingLabel = false;
                }
              }
              /**
               * This method listens to a stream of panel closing actions and resets the
               * stream every time the option list changes.
               */
              _subscribeToClosingActions() {
                const firstStable = this._zone.onStable.pipe(take(1));
                const optionChanges = this.autocomplete.options.changes.pipe(tap(() => this._positionStrategy.reapplyLastPosition()),
                // Defer emitting to the stream until the next tick, because changing
                // bindings in here will cause "changed after checked" errors.
                delay(0));
                // When the zone is stable initially, and when the option list changes...
                return merge(firstStable, optionChanges).pipe(
                // create a new stream of panelClosingActions, replacing any previous streams
                // that were created, and flatten it so our stream only emits closing events...
                switchMap(() => {
                  // The `NgZone.onStable` always emits outside of the Angular zone, thus we have to re-enter
                  // the Angular zone. This will lead to change detection being called outside of the Angular
                  // zone and the `autocomplete.opened` will also emit outside of the Angular.
                  this._zone.run(() => {
                    const wasOpen = this.panelOpen;
                    this._resetActiveItem();
                    this.autocomplete._setVisibility();
                    this._changeDetectorRef.detectChanges();
                    if (this.panelOpen) {
                      this._overlayRef.updatePosition();
                    }
                    if (wasOpen !== this.panelOpen) {
                      // If the `panelOpen` state changed, we need to make sure to emit the `opened` or
                      // `closed` event, because we may not have emitted it. This can happen
                      // - if the users opens the panel and there are no options, but the
                      //   options come in slightly later or as a result of the value changing,
                      // - if the panel is closed after the user entered a string that did not match any
                      //   of the available options,
                      // - if a valid string is entered after an invalid one.
                      if (this.panelOpen) {
                        this.autocomplete.opened.emit();
                      } else {
                        this.autocomplete.closed.emit();
                      }
                    }
                  });
                  return this.panelClosingActions;
                }),
                // when the first closing event occurs...
                take(1))
                // set the value, close the panel, and complete.
                .subscribe(event => this._setValueAndClose(event));
              }
              /** Destroys the autocomplete suggestion panel. */
              _destroyPanel() {
                if (this._overlayRef) {
                  this.closePanel();
                  this._overlayRef.dispose();
                  this._overlayRef = null;
                }
              }
              _assignOptionValue(value) {
                const toDisplay = this.autocomplete && this.autocomplete.displayWith ? this.autocomplete.displayWith(value) : value;
                // Simply falling back to an empty string if the display value is falsy does not work properly.
                // The display value can also be the number zero and shouldn't fall back to an empty string.
                this._updateNativeInputValue(toDisplay != null ? toDisplay : '');
              }
              _updateNativeInputValue(value) {
                // If it's used within a `MatFormField`, we should set it through the property so it can go
                // through change detection.
                if (this._formField) {
                  this._formField._control.value = value;
                } else {
                  this._element.nativeElement.value = value;
                }
                this._previousValue = value;
              }
              /**
               * This method closes the panel, and if a value is specified, also sets the associated
               * control to that value. It will also mark the control as dirty if this interaction
               * stemmed from the user.
               */
              _setValueAndClose(event) {
                const toSelect = event ? event.source : this._pendingAutoselectedOption;
                if (toSelect) {
                  this._clearPreviousSelectedOption(toSelect);
                  this._assignOptionValue(toSelect.value);
                  this._onChange(toSelect.value);
                  this.autocomplete._emitSelectEvent(toSelect);
                  this._element.nativeElement.focus();
                }
                this.closePanel();
              }
              /**
               * Clear any previous selected option and emit a selection change event for this option
               */
              _clearPreviousSelectedOption(skip) {
                this.autocomplete.options.forEach(option => {
                  if (option !== skip && option.selected) {
                    option.deselect();
                  }
                });
              }
              _attachOverlay() {
                var _a, _b;
                if (!this.autocomplete && (typeof ngDevMode === 'undefined' || ngDevMode)) {
                  throw getMatAutocompleteMissingPanelError();
                }
                let overlayRef = this._overlayRef;
                if (!overlayRef) {
                  this._portal = new TemplatePortal(this.autocomplete.template, this._viewContainerRef, {
                    id: (_a = this._formField) === null || _a === void 0 ? void 0 : _a.getLabelId()
                  });
                  overlayRef = this._overlay.create(this._getOverlayConfig());
                  this._overlayRef = overlayRef;
                  this._handleOverlayEvents(overlayRef);
                  this._viewportSubscription = this._viewportRuler.change().subscribe(() => {
                    if (this.panelOpen && overlayRef) {
                      overlayRef.updateSize({
                        width: this._getPanelWidth()
                      });
                    }
                  });
                } else {
                  // Update the trigger, panel width and direction, in case anything has changed.
                  this._positionStrategy.setOrigin(this._getConnectedElement());
                  overlayRef.updateSize({
                    width: this._getPanelWidth()
                  });
                }
                if (overlayRef && !overlayRef.hasAttached()) {
                  overlayRef.attach(this._portal);
                  this._closingActionsSubscription = this._subscribeToClosingActions();
                }
                const wasOpen = this.panelOpen;
                this.autocomplete._setVisibility();
                this.autocomplete._isOpen = this._overlayAttached = true;
                this.autocomplete._setColor((_b = this._formField) === null || _b === void 0 ? void 0 : _b.color);
                // We need to do an extra `panelOpen` check in here, because the
                // autocomplete won't be shown if there are no options.
                if (this.panelOpen && wasOpen !== this.panelOpen) {
                  this.autocomplete.opened.emit();
                }
              }
              _getOverlayConfig() {
                var _a, _b;
                return new OverlayConfig({
                  positionStrategy: this._getOverlayPosition(),
                  scrollStrategy: this._scrollStrategy(),
                  width: this._getPanelWidth(),
                  direction: (_a = this._dir) !== null && _a !== void 0 ? _a : undefined,
                  panelClass: (_b = this._defaults) === null || _b === void 0 ? void 0 : _b.overlayPanelClass
                });
              }
              _getOverlayPosition() {
                const strategy = this._overlay.position().flexibleConnectedTo(this._getConnectedElement()).withFlexibleDimensions(false).withPush(false);
                this._setStrategyPositions(strategy);
                this._positionStrategy = strategy;
                return strategy;
              }
              /** Sets the positions on a position strategy based on the directive's input state. */
              _setStrategyPositions(positionStrategy) {
                // Note that we provide horizontal fallback positions, even though by default the dropdown
                // width matches the input, because consumers can override the width. See #18854.
                const belowPositions = [{
                  originX: 'start',
                  originY: 'bottom',
                  overlayX: 'start',
                  overlayY: 'top'
                }, {
                  originX: 'end',
                  originY: 'bottom',
                  overlayX: 'end',
                  overlayY: 'top'
                }];
                // The overlay edge connected to the trigger should have squared corners, while
                // the opposite end has rounded corners. We apply a CSS class to swap the
                // border-radius based on the overlay position.
                const panelClass = this._aboveClass;
                const abovePositions = [{
                  originX: 'start',
                  originY: 'top',
                  overlayX: 'start',
                  overlayY: 'bottom',
                  panelClass
                }, {
                  originX: 'end',
                  originY: 'top',
                  overlayX: 'end',
                  overlayY: 'bottom',
                  panelClass
                }];
                let positions;
                if (this.position === 'above') {
                  positions = abovePositions;
                } else if (this.position === 'below') {
                  positions = belowPositions;
                } else {
                  positions = [...belowPositions, ...abovePositions];
                }
                positionStrategy.withPositions(positions);
              }
              _getConnectedElement() {
                if (this.connectedTo) {
                  return this.connectedTo.elementRef;
                }
                return this._formField ? this._formField.getConnectedOverlayOrigin() : this._element;
              }
              _getPanelWidth() {
                return this.autocomplete.panelWidth || this._getHostWidth();
              }
              /** Returns the width of the input element, so the panel width can match it. */
              _getHostWidth() {
                return this._getConnectedElement().nativeElement.getBoundingClientRect().width;
              }
              /**
               * Resets the active item to -1 so arrow events will activate the
               * correct options, or to 0 if the consumer opted into it.
               */
              _resetActiveItem() {
                const autocomplete = this.autocomplete;
                if (autocomplete.autoActiveFirstOption) {
                  // Note that we go through `setFirstItemActive`, rather than `setActiveItem(0)`, because
                  // the former will find the next enabled option, if the first one is disabled.
                  autocomplete._keyManager.setFirstItemActive();
                } else {
                  autocomplete._keyManager.setActiveItem(-1);
                }
              }
              /** Determines whether the panel can be opened. */
              _canOpen() {
                const element = this._element.nativeElement;
                return !element.readOnly && !element.disabled && !this._autocompleteDisabled;
              }
              /** Use defaultView of injected document if available or fallback to global window reference */
              _getWindow() {
                var _a;
                return ((_a = this._document) === null || _a === void 0 ? void 0 : _a.defaultView) || window;
              }
              /** Scrolls to a particular option in the list. */
              _scrollToOption(index) {
                // Given that we are not actually focusing active options, we must manually adjust scroll
                // to reveal options below the fold. First, we find the offset of the option from the top
                // of the panel. If that offset is below the fold, the new scrollTop will be the offset -
                // the panel height + the option height, so the active option will be just visible at the
                // bottom of the panel. If that offset is above the top of the visible panel, the new scrollTop
                // will become the offset. If that offset is visible within the panel already, the scrollTop is
                // not adjusted.
                const autocomplete = this.autocomplete;
                const labelCount = _countGroupLabelsBeforeOption(index, autocomplete.options, autocomplete.optionGroups);
                if (index === 0 && labelCount === 1) {
                  // If we've got one group label before the option and we're at the top option,
                  // scroll the list to the top. This is better UX than scrolling the list to the
                  // top of the option, because it allows the user to read the top group's label.
                  autocomplete._setScrollTop(0);
                } else if (autocomplete.panel) {
                  const option = autocomplete.options.toArray()[index];
                  if (option) {
                    const element = option._getHostElement();
                    const newScrollPosition = _getOptionScrollPosition(element.offsetTop, element.offsetHeight, autocomplete._getScrollTop(), autocomplete.panel.nativeElement.offsetHeight);
                    autocomplete._setScrollTop(newScrollPosition);
                  }
                }
              }
              /** Handles keyboard events coming from the overlay panel. */
              _handleOverlayEvents(overlayRef) {
                // Use the `keydownEvents` in order to take advantage of
                // the overlay event targeting provided by the CDK overlay.
                overlayRef.keydownEvents().subscribe(event => {
                  var _a;
                  // Close when pressing ESCAPE or ALT + UP_ARROW, based on the a11y guidelines.
                  // See: https://www.w3.org/TR/wai-aria-practices-1.1/#textbox-keyboard-interaction
                  if (event.keyCode === ESCAPE && !hasModifierKey(event) || event.keyCode === UP_ARROW && hasModifierKey(event, 'altKey')) {
                    // If the user had typed something in before we autoselected an option, and they decided
                    // to cancel the selection, restore the input value to the one they had typed in.
                    if (this._pendingAutoselectedOption) {
                      this._updateNativeInputValue((_a = this._valueBeforeAutoSelection) !== null && _a !== void 0 ? _a : '');
                      this._pendingAutoselectedOption = null;
                    }
                    this._closeKeyEventStream.next();
                    this._resetActiveItem();
                    // We need to stop propagation, otherwise the event will eventually
                    // reach the input itself and cause the overlay to be reopened.
                    event.stopPropagation();
                    event.preventDefault();
                  }
                });
                // Subscribe to the pointer events stream so that it doesn't get picked up by other overlays.
                // TODO(crisbeto): we should switch `_getOutsideClickStream` eventually to use this stream,
                // but the behvior isn't exactly the same and it ends up breaking some internal tests.
                overlayRef.outsidePointerEvents().subscribe();
              }
            } exports('_MatAutocompleteTriggerBase', _MatAutocompleteTriggerBase);
            _MatAutocompleteTriggerBase.ɵfac = function _MatAutocompleteTriggerBase_Factory(t) {
              return new (t || _MatAutocompleteTriggerBase)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1$1.Overlay), i0.ɵɵdirectiveInject(i0.ViewContainerRef), i0.ɵɵdirectiveInject(i0.NgZone), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(MAT_AUTOCOMPLETE_SCROLL_STRATEGY), i0.ɵɵdirectiveInject(i2$1.Directionality, 8), i0.ɵɵdirectiveInject(MAT_FORM_FIELD, 9), i0.ɵɵdirectiveInject(DOCUMENT, 8), i0.ɵɵdirectiveInject(i3.ViewportRuler), i0.ɵɵdirectiveInject(MAT_AUTOCOMPLETE_DEFAULT_OPTIONS, 8));
            };
            _MatAutocompleteTriggerBase.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: _MatAutocompleteTriggerBase,
              inputs: {
                autocomplete: ["matAutocomplete", "autocomplete"],
                position: ["matAutocompletePosition", "position"],
                connectedTo: ["matAutocompleteConnectedTo", "connectedTo"],
                autocompleteAttribute: ["autocomplete", "autocompleteAttribute"],
                autocompleteDisabled: ["matAutocompleteDisabled", "autocompleteDisabled"]
              },
              features: [i0.ɵɵNgOnChangesFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(_MatAutocompleteTriggerBase, [{
                type: Directive
              }], function () {
                return [{
                  type: i0.ElementRef
                }, {
                  type: i1$1.Overlay
                }, {
                  type: i0.ViewContainerRef
                }, {
                  type: i0.NgZone
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: undefined,
                  decorators: [{
                    type: Inject,
                    args: [MAT_AUTOCOMPLETE_SCROLL_STRATEGY]
                  }]
                }, {
                  type: i2$1.Directionality,
                  decorators: [{
                    type: Optional
                  }]
                }, {
                  type: i4.MatFormField,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_FORM_FIELD]
                  }, {
                    type: Host
                  }]
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [DOCUMENT]
                  }]
                }, {
                  type: i3.ViewportRuler
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_AUTOCOMPLETE_DEFAULT_OPTIONS]
                  }]
                }];
              }, {
                autocomplete: [{
                  type: Input,
                  args: ['matAutocomplete']
                }],
                position: [{
                  type: Input,
                  args: ['matAutocompletePosition']
                }],
                connectedTo: [{
                  type: Input,
                  args: ['matAutocompleteConnectedTo']
                }],
                autocompleteAttribute: [{
                  type: Input,
                  args: ['autocomplete']
                }],
                autocompleteDisabled: [{
                  type: Input,
                  args: ['matAutocompleteDisabled']
                }]
              });
            })();
            class MatAutocompleteTrigger extends _MatAutocompleteTriggerBase {
              constructor() {
                super(...arguments);
                this._aboveClass = 'mat-mdc-autocomplete-panel-above';
              }
            } exports('MatAutocompleteTrigger', MatAutocompleteTrigger);
            MatAutocompleteTrigger.ɵfac = /* @__PURE__ */function () {
              let ɵMatAutocompleteTrigger_BaseFactory;
              return function MatAutocompleteTrigger_Factory(t) {
                return (ɵMatAutocompleteTrigger_BaseFactory || (ɵMatAutocompleteTrigger_BaseFactory = i0.ɵɵgetInheritedFactory(MatAutocompleteTrigger)))(t || MatAutocompleteTrigger);
              };
            }();
            MatAutocompleteTrigger.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatAutocompleteTrigger,
              selectors: [["input", "matAutocomplete", ""], ["textarea", "matAutocomplete", ""]],
              hostAttrs: [1, "mat-mdc-autocomplete-trigger"],
              hostVars: 7,
              hostBindings: function MatAutocompleteTrigger_HostBindings(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵlistener("focusin", function MatAutocompleteTrigger_focusin_HostBindingHandler() {
                    return ctx._handleFocus();
                  })("blur", function MatAutocompleteTrigger_blur_HostBindingHandler() {
                    return ctx._onTouched();
                  })("input", function MatAutocompleteTrigger_input_HostBindingHandler($event) {
                    return ctx._handleInput($event);
                  })("keydown", function MatAutocompleteTrigger_keydown_HostBindingHandler($event) {
                    return ctx._handleKeydown($event);
                  })("click", function MatAutocompleteTrigger_click_HostBindingHandler() {
                    return ctx._handleClick();
                  });
                }
                if (rf & 2) {
                  i0.ɵɵattribute("autocomplete", ctx.autocompleteAttribute)("role", ctx.autocompleteDisabled ? null : "combobox")("aria-autocomplete", ctx.autocompleteDisabled ? null : "list")("aria-activedescendant", ctx.panelOpen && ctx.activeOption ? ctx.activeOption.id : null)("aria-expanded", ctx.autocompleteDisabled ? null : ctx.panelOpen.toString())("aria-owns", ctx.autocompleteDisabled || !ctx.panelOpen ? null : ctx.autocomplete == null ? null : ctx.autocomplete.id)("aria-haspopup", ctx.autocompleteDisabled ? null : "listbox");
                }
              },
              exportAs: ["matAutocompleteTrigger"],
              features: [i0.ɵɵProvidersFeature([MAT_AUTOCOMPLETE_VALUE_ACCESSOR]), i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatAutocompleteTrigger, [{
                type: Directive,
                args: [{
                  selector: `input[matAutocomplete], textarea[matAutocomplete]`,
                  host: {
                    'class': 'mat-mdc-autocomplete-trigger',
                    '[attr.autocomplete]': 'autocompleteAttribute',
                    '[attr.role]': 'autocompleteDisabled ? null : "combobox"',
                    '[attr.aria-autocomplete]': 'autocompleteDisabled ? null : "list"',
                    '[attr.aria-activedescendant]': '(panelOpen && activeOption) ? activeOption.id : null',
                    '[attr.aria-expanded]': 'autocompleteDisabled ? null : panelOpen.toString()',
                    '[attr.aria-owns]': '(autocompleteDisabled || !panelOpen) ? null : autocomplete?.id',
                    '[attr.aria-haspopup]': 'autocompleteDisabled ? null : "listbox"',
                    // Note: we use `focusin`, as opposed to `focus`, in order to open the panel
                    // a little earlier. This avoids issues where IE delays the focusing of the input.
                    '(focusin)': '_handleFocus()',
                    '(blur)': '_onTouched()',
                    '(input)': '_handleInput($event)',
                    '(keydown)': '_handleKeydown($event)',
                    '(click)': '_handleClick()'
                  },
                  exportAs: 'matAutocompleteTrigger',
                  providers: [MAT_AUTOCOMPLETE_VALUE_ACCESSOR]
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /** Base class containing all of the functionality for `MatAutocompleteOrigin`. */
            class _MatAutocompleteOriginBase {
              constructor( /** Reference to the element on which the directive is applied. */
              elementRef) {
                this.elementRef = elementRef;
              }
            } exports('_MatAutocompleteOriginBase', _MatAutocompleteOriginBase);
            _MatAutocompleteOriginBase.ɵfac = function _MatAutocompleteOriginBase_Factory(t) {
              return new (t || _MatAutocompleteOriginBase)(i0.ɵɵdirectiveInject(i0.ElementRef));
            };
            _MatAutocompleteOriginBase.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: _MatAutocompleteOriginBase
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(_MatAutocompleteOriginBase, [{
                type: Directive
              }], function () {
                return [{
                  type: i0.ElementRef
                }];
              }, null);
            })();
            /**
             * Directive applied to an element to make it usable
             * as a connection point for an autocomplete panel.
             */
            class MatAutocompleteOrigin extends _MatAutocompleteOriginBase {} exports('MatAutocompleteOrigin', MatAutocompleteOrigin);
            MatAutocompleteOrigin.ɵfac = /* @__PURE__ */function () {
              let ɵMatAutocompleteOrigin_BaseFactory;
              return function MatAutocompleteOrigin_Factory(t) {
                return (ɵMatAutocompleteOrigin_BaseFactory || (ɵMatAutocompleteOrigin_BaseFactory = i0.ɵɵgetInheritedFactory(MatAutocompleteOrigin)))(t || MatAutocompleteOrigin);
              };
            }();
            MatAutocompleteOrigin.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatAutocompleteOrigin,
              selectors: [["", "matAutocompleteOrigin", ""]],
              exportAs: ["matAutocompleteOrigin"],
              features: [i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatAutocompleteOrigin, [{
                type: Directive,
                args: [{
                  selector: '[matAutocompleteOrigin]',
                  exportAs: 'matAutocompleteOrigin'
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            class MatAutocompleteModule {} exports('MatAutocompleteModule', MatAutocompleteModule);
            MatAutocompleteModule.ɵfac = function MatAutocompleteModule_Factory(t) {
              return new (t || MatAutocompleteModule)();
            };
            MatAutocompleteModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatAutocompleteModule
            });
            MatAutocompleteModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              providers: [MAT_AUTOCOMPLETE_SCROLL_STRATEGY_FACTORY_PROVIDER],
              imports: [OverlayModule, MatOptionModule, MatCommonModule, CommonModule, CdkScrollableModule, MatOptionModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatAutocompleteModule, [{
                type: NgModule,
                args: [{
                  imports: [OverlayModule, MatOptionModule, MatCommonModule, CommonModule],
                  exports: [CdkScrollableModule, MatAutocomplete, MatOptionModule, MatCommonModule, MatAutocompleteTrigger, MatAutocompleteOrigin],
                  declarations: [MatAutocomplete, MatAutocompleteTrigger, MatAutocompleteOrigin],
                  providers: [MAT_AUTOCOMPLETE_SCROLL_STRATEGY_FACTORY_PROVIDER]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-autocomplete.js.map
