/* esm-bundle - @angular/material/legacy-dialog@15.2.9 - Ivy - system format - es2015 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/cdk/dialog', '@angular/cdk/overlay', '@angular/cdk/portal', '@angular/core', '@angular/material/core', '@angular/common', '@angular/material/dialog', '@angular/cdk/a11y', '@angular/platform-browser/animations'], (function (exports) {
    'use strict';
    var DialogModule, i1$1, OverlayModule, Overlay, i4, PortalModule, i0, Component, ViewEncapsulation, ChangeDetectionStrategy, Optional, Inject, InjectionToken, Injectable, SkipSelf, Directive, Input, NgModule, MatCommonModule, DOCUMENT, i2, matDialogAnimations, MatDialogConfig, _defaultParams, _MatDialogContainerBase, MatDialogRef, _MatDialogBase, _closeDialogVia, i1, ANIMATION_MODULE_TYPE;
    return {
        setters: [function (module) {
            DialogModule = module.DialogModule;
        }, function (module) {
            i1$1 = module;
            OverlayModule = module.OverlayModule;
            Overlay = module.Overlay;
        }, function (module) {
            i4 = module;
            PortalModule = module.PortalModule;
        }, function (module) {
            i0 = module;
            Component = module.Component;
            ViewEncapsulation = module.ViewEncapsulation;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            Optional = module.Optional;
            Inject = module.Inject;
            InjectionToken = module.InjectionToken;
            Injectable = module.Injectable;
            SkipSelf = module.SkipSelf;
            Directive = module.Directive;
            Input = module.Input;
            NgModule = module.NgModule;
        }, function (module) {
            MatCommonModule = module.MatCommonModule;
        }, function (module) {
            DOCUMENT = module.DOCUMENT;
            i2 = module;
        }, function (module) {
            matDialogAnimations = module.matDialogAnimations;
            MatDialogConfig = module.MatDialogConfig;
            _defaultParams = module._defaultParams;
            _MatDialogContainerBase = module._MatDialogContainerBase;
            MatDialogRef = module.MatDialogRef;
            _MatDialogBase = module._MatDialogBase;
            _closeDialogVia = module._closeDialogVia;
            exports({ MAT_LEGACY_DIALOG_SCROLL_STRATEGY_FACTORY: module.MAT_DIALOG_SCROLL_STRATEGY_FACTORY, _MatLegacyDialogBase: module._MatDialogBase, _MatLegacyDialogContainerBase: module._MatDialogContainerBase, _closeLegacyDialogVia: module._closeDialogVia, matLegacyDialogAnimations: module.matDialogAnimations });
        }, function (module) {
            i1 = module;
        }, function (module) {
            ANIMATION_MODULE_TYPE = module.ANIMATION_MODULE_TYPE;
        }],
        execute: (function () {

            exports('MAT_LEGACY_DIALOG_SCROLL_STRATEGY_PROVIDER_FACTORY', MAT_LEGACY_DIALOG_SCROLL_STRATEGY_PROVIDER_FACTORY);

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Default parameters for the animation for backwards compatibility.
             * @docs-private
             * @deprecated Use `defaultParams` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            function MatLegacyDialogContainer_ng_template_0_Template(rf, ctx) {}
            const defaultParams = {
              params: {
                enterAnimationDuration: '150ms',
                exitAnimationDuration: '75ms'
              }
            };

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * @deprecated Use `MatDialogConfig` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyDialogConfig extends MatDialogConfig {
              constructor() {
                super(...arguments);
                /** Duration of the enter animation. Has to be a valid CSS value (e.g. 100ms). */
                this.enterAnimationDuration = _defaultParams.params.enterAnimationDuration;
                /** Duration of the exit animation. Has to be a valid CSS value (e.g. 50ms). */
                this.exitAnimationDuration = _defaultParams.params.exitAnimationDuration;
              }
            } exports('MatLegacyDialogConfig', MatLegacyDialogConfig);

            /**
             * Internal component that wraps user-provided dialog content.
             * Animation is based on https://material.io/guidelines/motion/choreography.html.
             * @docs-private
             * @deprecated Use `MatDialogContainer` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyDialogContainer extends _MatDialogContainerBase {
              /** Callback, invoked whenever an animation on the host completes. */
              _onAnimationDone({
                toState,
                totalTime
              }) {
                if (toState === 'enter') {
                  this._openAnimationDone(totalTime);
                } else if (toState === 'exit') {
                  this._animationStateChanged.next({
                    state: 'closed',
                    totalTime
                  });
                }
              }
              /** Callback, invoked when an animation on the host starts. */
              _onAnimationStart({
                toState,
                totalTime
              }) {
                if (toState === 'enter') {
                  this._animationStateChanged.next({
                    state: 'opening',
                    totalTime
                  });
                } else if (toState === 'exit' || toState === 'void') {
                  this._animationStateChanged.next({
                    state: 'closing',
                    totalTime
                  });
                }
              }
              /** Starts the dialog exit animation. */
              _startExitAnimation() {
                this._state = 'exit';
                // Mark the container for check so it can react if the
                // view container is using OnPush change detection.
                this._changeDetectorRef.markForCheck();
              }
              constructor(elementRef, focusTrapFactory, document, dialogConfig, checker, ngZone, overlayRef, _changeDetectorRef, focusMonitor) {
                super(elementRef, focusTrapFactory, document, dialogConfig, checker, ngZone, overlayRef, focusMonitor);
                this._changeDetectorRef = _changeDetectorRef;
                /** State of the dialog animation. */
                this._state = 'enter';
              }
              _getAnimationState() {
                return {
                  value: this._state,
                  params: {
                    'enterAnimationDuration': this._config.enterAnimationDuration || defaultParams.params.enterAnimationDuration,
                    'exitAnimationDuration': this._config.exitAnimationDuration || defaultParams.params.exitAnimationDuration
                  }
                };
              }
            } exports('MatLegacyDialogContainer', MatLegacyDialogContainer);
            MatLegacyDialogContainer.ɵfac = function MatLegacyDialogContainer_Factory(t) {
              return new (t || MatLegacyDialogContainer)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1.FocusTrapFactory), i0.ɵɵdirectiveInject(DOCUMENT, 8), i0.ɵɵdirectiveInject(MatLegacyDialogConfig), i0.ɵɵdirectiveInject(i1.InteractivityChecker), i0.ɵɵdirectiveInject(i0.NgZone), i0.ɵɵdirectiveInject(i1$1.OverlayRef), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i1.FocusMonitor));
            };
            MatLegacyDialogContainer.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatLegacyDialogContainer,
              selectors: [["mat-dialog-container"]],
              hostAttrs: ["tabindex", "-1", 1, "mat-dialog-container"],
              hostVars: 7,
              hostBindings: function MatLegacyDialogContainer_HostBindings(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵsyntheticHostListener("@dialogContainer.start", function MatLegacyDialogContainer_animation_dialogContainer_start_HostBindingHandler($event) {
                    return ctx._onAnimationStart($event);
                  })("@dialogContainer.done", function MatLegacyDialogContainer_animation_dialogContainer_done_HostBindingHandler($event) {
                    return ctx._onAnimationDone($event);
                  });
                }
                if (rf & 2) {
                  i0.ɵɵhostProperty("id", ctx._config.id);
                  i0.ɵɵattribute("aria-modal", ctx._config.ariaModal)("role", ctx._config.role)("aria-labelledby", ctx._config.ariaLabel ? null : ctx._ariaLabelledBy)("aria-label", ctx._config.ariaLabel)("aria-describedby", ctx._config.ariaDescribedBy || null);
                  i0.ɵɵsyntheticHostProperty("@dialogContainer", ctx._getAnimationState());
                }
              },
              features: [i0.ɵɵInheritDefinitionFeature],
              decls: 1,
              vars: 0,
              consts: [["cdkPortalOutlet", ""]],
              template: function MatLegacyDialogContainer_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵtemplate(0, MatLegacyDialogContainer_ng_template_0_Template, 0, 0, "ng-template", 0);
                }
              },
              dependencies: [i4.CdkPortalOutlet],
              styles: [".mat-dialog-container{display:block;padding:24px;border-radius:4px;box-sizing:border-box;overflow:auto;outline:0;width:100%;height:100%;min-height:inherit;max-height:inherit}.cdk-high-contrast-active .mat-dialog-container{outline:solid 1px}.mat-dialog-content{display:block;margin:0 -24px;padding:0 24px;max-height:65vh;overflow:auto;-webkit-overflow-scrolling:touch}.mat-dialog-title{margin:0 0 20px;display:block}.mat-dialog-actions{padding:8px 0;display:flex;flex-wrap:wrap;min-height:52px;align-items:center;box-sizing:content-box;margin-bottom:-24px}.mat-dialog-actions.mat-dialog-actions-align-center,.mat-dialog-actions[align=center]{justify-content:center}.mat-dialog-actions.mat-dialog-actions-align-end,.mat-dialog-actions[align=end]{justify-content:flex-end}.mat-dialog-actions .mat-button-base+.mat-button-base,.mat-dialog-actions .mat-mdc-button-base+.mat-mdc-button-base{margin-left:8px}[dir=rtl] .mat-dialog-actions .mat-button-base+.mat-button-base,[dir=rtl] .mat-dialog-actions .mat-mdc-button-base+.mat-mdc-button-base{margin-left:0;margin-right:8px}"],
              encapsulation: 2,
              data: {
                animation: [matDialogAnimations.dialogContainer]
              }
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyDialogContainer, [{
                type: Component,
                args: [{
                  selector: 'mat-dialog-container',
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.Default,
                  animations: [matDialogAnimations.dialogContainer],
                  host: {
                    'class': 'mat-dialog-container',
                    'tabindex': '-1',
                    '[attr.aria-modal]': '_config.ariaModal',
                    '[id]': '_config.id',
                    '[attr.role]': '_config.role',
                    '[attr.aria-labelledby]': '_config.ariaLabel ? null : _ariaLabelledBy',
                    '[attr.aria-label]': '_config.ariaLabel',
                    '[attr.aria-describedby]': '_config.ariaDescribedBy || null',
                    '[@dialogContainer]': `_getAnimationState()`,
                    '(@dialogContainer.start)': '_onAnimationStart($event)',
                    '(@dialogContainer.done)': '_onAnimationDone($event)'
                  },
                  template: "<ng-template cdkPortalOutlet></ng-template>\n",
                  styles: [".mat-dialog-container{display:block;padding:24px;border-radius:4px;box-sizing:border-box;overflow:auto;outline:0;width:100%;height:100%;min-height:inherit;max-height:inherit}.cdk-high-contrast-active .mat-dialog-container{outline:solid 1px}.mat-dialog-content{display:block;margin:0 -24px;padding:0 24px;max-height:65vh;overflow:auto;-webkit-overflow-scrolling:touch}.mat-dialog-title{margin:0 0 20px;display:block}.mat-dialog-actions{padding:8px 0;display:flex;flex-wrap:wrap;min-height:52px;align-items:center;box-sizing:content-box;margin-bottom:-24px}.mat-dialog-actions.mat-dialog-actions-align-center,.mat-dialog-actions[align=center]{justify-content:center}.mat-dialog-actions.mat-dialog-actions-align-end,.mat-dialog-actions[align=end]{justify-content:flex-end}.mat-dialog-actions .mat-button-base+.mat-button-base,.mat-dialog-actions .mat-mdc-button-base+.mat-mdc-button-base{margin-left:8px}[dir=rtl] .mat-dialog-actions .mat-button-base+.mat-button-base,[dir=rtl] .mat-dialog-actions .mat-mdc-button-base+.mat-mdc-button-base{margin-left:0;margin-right:8px}"]
                }]
              }], function () {
                return [{
                  type: i0.ElementRef
                }, {
                  type: i1.FocusTrapFactory
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [DOCUMENT]
                  }]
                }, {
                  type: MatLegacyDialogConfig
                }, {
                  type: i1.InteractivityChecker
                }, {
                  type: i0.NgZone
                }, {
                  type: i1$1.OverlayRef
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: i1.FocusMonitor
                }];
              }, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Reference to a dialog opened via the MatDialog service.
             * @deprecated Use `MatDialogRef` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyDialogRef extends MatDialogRef {} exports('MatLegacyDialogRef', MatLegacyDialogRef);

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Injection token that can be used to access the data that was passed in to a dialog.
             * @deprecated Use `MAT_DIALOG_DATA` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            const MAT_LEGACY_DIALOG_DATA = exports('MAT_LEGACY_DIALOG_DATA', new InjectionToken('MatDialogData'));
            /**
             * Injection token that can be used to specify default dialog options.
             * @deprecated Use `MAT_DIALOG_DEFAULT_OPTIONS` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            const MAT_LEGACY_DIALOG_DEFAULT_OPTIONS = exports('MAT_LEGACY_DIALOG_DEFAULT_OPTIONS', new InjectionToken('mat-dialog-default-options'));
            /**
             * Injection token that determines the scroll handling while the dialog is open.
             * @deprecated Use `MAT_DIALOG_SCROLL_STRATEGY` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            const MAT_LEGACY_DIALOG_SCROLL_STRATEGY = exports('MAT_LEGACY_DIALOG_SCROLL_STRATEGY', new InjectionToken('mat-dialog-scroll-strategy'));
            /**
             * @docs-private
             * @deprecated Use `MAT_DIALOG_SCROLL_STRATEGY_PROVIDER_FACTORY` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            function MAT_LEGACY_DIALOG_SCROLL_STRATEGY_PROVIDER_FACTORY(overlay) {
              return () => overlay.scrollStrategies.block();
            }
            /**
             * @docs-private
             * @deprecated Use `MAT_DIALOG_SCROLL_STRATEGY_PROVIDER` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            const MAT_LEGACY_DIALOG_SCROLL_STRATEGY_PROVIDER = exports('MAT_LEGACY_DIALOG_SCROLL_STRATEGY_PROVIDER', {
              provide: MAT_LEGACY_DIALOG_SCROLL_STRATEGY,
              deps: [Overlay],
              useFactory: MAT_LEGACY_DIALOG_SCROLL_STRATEGY_PROVIDER_FACTORY
            });
            /**
             * Service to open Material Design modal dialogs.
             * @deprecated Use `MatDialog` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyDialog extends _MatDialogBase {
              constructor(overlay, injector,
              /**
               * @deprecated `_location` parameter to be removed.
               * @breaking-change 10.0.0
               */
              _location, defaultOptions, scrollStrategy, parentDialog,
              /**
               * @deprecated No longer used. To be removed.
               * @breaking-change 15.0.0
               */
              overlayContainer,
              /**
               * @deprecated No longer used. To be removed.
               * @breaking-change 14.0.0
               */
              animationMode) {
                super(overlay, injector, defaultOptions, parentDialog, overlayContainer, scrollStrategy, MatLegacyDialogRef, MatLegacyDialogContainer, MAT_LEGACY_DIALOG_DATA, animationMode);
                this.dialogConfigClass = MatLegacyDialogConfig;
              }
            } exports('MatLegacyDialog', MatLegacyDialog);
            MatLegacyDialog.ɵfac = function MatLegacyDialog_Factory(t) {
              return new (t || MatLegacyDialog)(i0.ɵɵinject(i1$1.Overlay), i0.ɵɵinject(i0.Injector), i0.ɵɵinject(i2.Location, 8), i0.ɵɵinject(MAT_LEGACY_DIALOG_DEFAULT_OPTIONS, 8), i0.ɵɵinject(MAT_LEGACY_DIALOG_SCROLL_STRATEGY), i0.ɵɵinject(MatLegacyDialog, 12), i0.ɵɵinject(i1$1.OverlayContainer), i0.ɵɵinject(ANIMATION_MODULE_TYPE, 8));
            };
            MatLegacyDialog.ɵprov = /* @__PURE__ */i0.ɵɵdefineInjectable({
              token: MatLegacyDialog,
              factory: MatLegacyDialog.ɵfac
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyDialog, [{
                type: Injectable
              }], function () {
                return [{
                  type: i1$1.Overlay
                }, {
                  type: i0.Injector
                }, {
                  type: i2.Location,
                  decorators: [{
                    type: Optional
                  }]
                }, {
                  type: MatLegacyDialogConfig,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_LEGACY_DIALOG_DEFAULT_OPTIONS]
                  }]
                }, {
                  type: undefined,
                  decorators: [{
                    type: Inject,
                    args: [MAT_LEGACY_DIALOG_SCROLL_STRATEGY]
                  }]
                }, {
                  type: MatLegacyDialog,
                  decorators: [{
                    type: Optional
                  }, {
                    type: SkipSelf
                  }]
                }, {
                  type: i1$1.OverlayContainer
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [ANIMATION_MODULE_TYPE]
                  }]
                }];
              }, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /** Counter used to generate unique IDs for dialog elements. */
            let dialogElementUid = 0;
            /**
             * Button that will close the current dialog.
             * @deprecated Use `MatDialogClose` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyDialogClose {
              constructor(
              /**
               * Reference to the containing dialog.
               * @deprecated `dialogRef` property to become private.
               * @breaking-change 13.0.0
               */
              // The dialog title directive is always used in combination with a `MatDialogRef`.
              // tslint:disable-next-line: lightweight-tokens
              dialogRef, _elementRef, _dialog) {
                this.dialogRef = dialogRef;
                this._elementRef = _elementRef;
                this._dialog = _dialog;
                /** Default to "button" to prevents accidental form submits. */
                this.type = 'button';
              }
              ngOnInit() {
                if (!this.dialogRef) {
                  // When this directive is included in a dialog via TemplateRef (rather than being
                  // in a Component), the DialogRef isn't available via injection because embedded
                  // views cannot be given a custom injector. Instead, we look up the DialogRef by
                  // ID. This must occur in `onInit`, as the ID binding for the dialog container won't
                  // be resolved at constructor time.
                  this.dialogRef = getClosestDialog(this._elementRef, this._dialog.openDialogs);
                }
              }
              ngOnChanges(changes) {
                const proxiedChange = changes['_matDialogClose'] || changes['_matDialogCloseResult'];
                if (proxiedChange) {
                  this.dialogResult = proxiedChange.currentValue;
                }
              }
              _onButtonClick(event) {
                // Determinate the focus origin using the click event, because using the FocusMonitor will
                // result in incorrect origins. Most of the time, close buttons will be auto focused in the
                // dialog, and therefore clicking the button won't result in a focus change. This means that
                // the FocusMonitor won't detect any origin change, and will always output `program`.
                _closeDialogVia(this.dialogRef, event.screenX === 0 && event.screenY === 0 ? 'keyboard' : 'mouse', this.dialogResult);
              }
            } exports('MatLegacyDialogClose', MatLegacyDialogClose);
            MatLegacyDialogClose.ɵfac = function MatLegacyDialogClose_Factory(t) {
              return new (t || MatLegacyDialogClose)(i0.ɵɵdirectiveInject(MatLegacyDialogRef, 8), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(MatLegacyDialog));
            };
            MatLegacyDialogClose.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyDialogClose,
              selectors: [["", "mat-dialog-close", ""], ["", "matDialogClose", ""]],
              hostVars: 2,
              hostBindings: function MatLegacyDialogClose_HostBindings(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵlistener("click", function MatLegacyDialogClose_click_HostBindingHandler($event) {
                    return ctx._onButtonClick($event);
                  });
                }
                if (rf & 2) {
                  i0.ɵɵattribute("aria-label", ctx.ariaLabel || null)("type", ctx.type);
                }
              },
              inputs: {
                ariaLabel: ["aria-label", "ariaLabel"],
                type: "type",
                dialogResult: ["mat-dialog-close", "dialogResult"],
                _matDialogClose: ["matDialogClose", "_matDialogClose"]
              },
              exportAs: ["matDialogClose"],
              features: [i0.ɵɵNgOnChangesFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyDialogClose, [{
                type: Directive,
                args: [{
                  selector: '[mat-dialog-close], [matDialogClose]',
                  exportAs: 'matDialogClose',
                  host: {
                    '(click)': '_onButtonClick($event)',
                    '[attr.aria-label]': 'ariaLabel || null',
                    '[attr.type]': 'type'
                  }
                }]
              }], function () {
                return [{
                  type: MatLegacyDialogRef,
                  decorators: [{
                    type: Optional
                  }]
                }, {
                  type: i0.ElementRef
                }, {
                  type: MatLegacyDialog
                }];
              }, {
                ariaLabel: [{
                  type: Input,
                  args: ['aria-label']
                }],
                type: [{
                  type: Input
                }],
                dialogResult: [{
                  type: Input,
                  args: ['mat-dialog-close']
                }],
                _matDialogClose: [{
                  type: Input,
                  args: ['matDialogClose']
                }]
              });
            })();
            /**
             * Title of a dialog element. Stays fixed to the top of the dialog when scrolling.
             * @deprecated Use `MatDialogTitle` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyDialogTitle {
              constructor(
              // The dialog title directive is always used in combination with a `MatDialogRef`.
              // tslint:disable-next-line: lightweight-tokens
              _dialogRef, _elementRef, _dialog) {
                this._dialogRef = _dialogRef;
                this._elementRef = _elementRef;
                this._dialog = _dialog;
                /** Unique id for the dialog title. If none is supplied, it will be auto-generated. */
                this.id = `mat-dialog-title-${dialogElementUid++}`;
              }
              ngOnInit() {
                if (!this._dialogRef) {
                  this._dialogRef = getClosestDialog(this._elementRef, this._dialog.openDialogs);
                }
                if (this._dialogRef) {
                  Promise.resolve().then(() => {
                    const container = this._dialogRef._containerInstance;
                    if (container && !container._ariaLabelledBy) {
                      container._ariaLabelledBy = this.id;
                    }
                  });
                }
              }
            } exports('MatLegacyDialogTitle', MatLegacyDialogTitle);
            MatLegacyDialogTitle.ɵfac = function MatLegacyDialogTitle_Factory(t) {
              return new (t || MatLegacyDialogTitle)(i0.ɵɵdirectiveInject(MatLegacyDialogRef, 8), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(MatLegacyDialog));
            };
            MatLegacyDialogTitle.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyDialogTitle,
              selectors: [["", "mat-dialog-title", ""], ["", "matDialogTitle", ""]],
              hostAttrs: [1, "mat-dialog-title"],
              hostVars: 1,
              hostBindings: function MatLegacyDialogTitle_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵhostProperty("id", ctx.id);
                }
              },
              inputs: {
                id: "id"
              },
              exportAs: ["matDialogTitle"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyDialogTitle, [{
                type: Directive,
                args: [{
                  selector: '[mat-dialog-title], [matDialogTitle]',
                  exportAs: 'matDialogTitle',
                  host: {
                    'class': 'mat-dialog-title',
                    '[id]': 'id'
                  }
                }]
              }], function () {
                return [{
                  type: MatLegacyDialogRef,
                  decorators: [{
                    type: Optional
                  }]
                }, {
                  type: i0.ElementRef
                }, {
                  type: MatLegacyDialog
                }];
              }, {
                id: [{
                  type: Input
                }]
              });
            })();
            /**
             * Scrollable content container of a dialog.
             * @deprecated Use `MatDialogContent` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyDialogContent {} exports('MatLegacyDialogContent', MatLegacyDialogContent);
            MatLegacyDialogContent.ɵfac = function MatLegacyDialogContent_Factory(t) {
              return new (t || MatLegacyDialogContent)();
            };
            MatLegacyDialogContent.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyDialogContent,
              selectors: [["", "mat-dialog-content", ""], ["mat-dialog-content"], ["", "matDialogContent", ""]],
              hostAttrs: [1, "mat-dialog-content"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyDialogContent, [{
                type: Directive,
                args: [{
                  selector: `[mat-dialog-content], mat-dialog-content, [matDialogContent]`,
                  host: {
                    'class': 'mat-dialog-content'
                  }
                }]
              }], null, null);
            })();
            /**
             * Container for the bottom action buttons in a dialog.
             * Stays fixed to the bottom when scrolling.
             * @deprecated Use `MatDialogActions` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyDialogActions {
              constructor() {
                /**
                 * Horizontal alignment of action buttons.
                 */
                this.align = 'start';
              }
            } exports('MatLegacyDialogActions', MatLegacyDialogActions);
            MatLegacyDialogActions.ɵfac = function MatLegacyDialogActions_Factory(t) {
              return new (t || MatLegacyDialogActions)();
            };
            MatLegacyDialogActions.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyDialogActions,
              selectors: [["", "mat-dialog-actions", ""], ["mat-dialog-actions"], ["", "matDialogActions", ""]],
              hostAttrs: [1, "mat-dialog-actions"],
              hostVars: 4,
              hostBindings: function MatLegacyDialogActions_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵclassProp("mat-dialog-actions-align-center", ctx.align === "center")("mat-dialog-actions-align-end", ctx.align === "end");
                }
              },
              inputs: {
                align: "align"
              }
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyDialogActions, [{
                type: Directive,
                args: [{
                  selector: `[mat-dialog-actions], mat-dialog-actions, [matDialogActions]`,
                  host: {
                    'class': 'mat-dialog-actions',
                    '[class.mat-dialog-actions-align-center]': 'align === "center"',
                    '[class.mat-dialog-actions-align-end]': 'align === "end"'
                  }
                }]
              }], null, {
                align: [{
                  type: Input
                }]
              });
            })();
            // TODO(crisbeto): this utility shouldn't be necessary anymore, because the dialog ref is provided
            // both to component and template dialogs through DI. We need to keep it around, because there are
            // some internal wrappers around `MatDialog` that happened to work by accident, because we had this
            // fallback logic in place.
            /**
             * Finds the closest MatDialogRef to an element by looking at the DOM.
             * @param element Element relative to which to look for a dialog.
             * @param openDialogs References to the currently-open dialogs.
             */
            function getClosestDialog(element, openDialogs) {
              let parent = element.nativeElement.parentElement;
              while (parent && !parent.classList.contains('mat-dialog-container')) {
                parent = parent.parentElement;
              }
              return parent ? openDialogs.find(dialog => dialog.id === parent.id) : null;
            }

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * @deprecated Use `MatDialogModule` from `@angular/material/dialog` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyDialogModule {} exports('MatLegacyDialogModule', MatLegacyDialogModule);
            MatLegacyDialogModule.ɵfac = function MatLegacyDialogModule_Factory(t) {
              return new (t || MatLegacyDialogModule)();
            };
            MatLegacyDialogModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatLegacyDialogModule
            });
            MatLegacyDialogModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              providers: [MatLegacyDialog, MAT_LEGACY_DIALOG_SCROLL_STRATEGY_PROVIDER],
              imports: [DialogModule, OverlayModule, PortalModule, MatCommonModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyDialogModule, [{
                type: NgModule,
                args: [{
                  imports: [DialogModule, OverlayModule, PortalModule, MatCommonModule],
                  exports: [MatLegacyDialogContainer, MatLegacyDialogClose, MatLegacyDialogTitle, MatLegacyDialogContent, MatLegacyDialogActions, MatCommonModule],
                  declarations: [MatLegacyDialogContainer, MatLegacyDialogClose, MatLegacyDialogTitle, MatLegacyDialogActions, MatLegacyDialogContent],
                  providers: [MatLegacyDialog, MAT_LEGACY_DIALOG_SCROLL_STRATEGY_PROVIDER]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-legacy-dialog.js.map
