/* esm-bundle - @angular/material/paginator@15.2.9 - Ivy - system format - es2015 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/common', '@angular/core', 'rxjs', '@angular/material/button', '@angular/material/select', '@angular/material/tooltip', '@angular/material/core', '@angular/cdk/coercion', '@angular/material/form-field'], (function (exports) {
    'use strict';
    var i2, CommonModule, i0, Injectable, Optional, SkipSelf, InjectionToken, Directive, Input, Output, Component, ChangeDetectionStrategy, ViewEncapsulation, Inject, NgModule, EventEmitter, Subject, i3, MatButtonModule, i5, MatSelectModule, i7, MatTooltipModule, mixinDisabled, mixinInitialized, i6, coerceNumberProperty, coerceBooleanProperty, i4;
    return {
        setters: [function (module) {
            i2 = module;
            CommonModule = module.CommonModule;
        }, function (module) {
            i0 = module;
            Injectable = module.Injectable;
            Optional = module.Optional;
            SkipSelf = module.SkipSelf;
            InjectionToken = module.InjectionToken;
            Directive = module.Directive;
            Input = module.Input;
            Output = module.Output;
            Component = module.Component;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            ViewEncapsulation = module.ViewEncapsulation;
            Inject = module.Inject;
            NgModule = module.NgModule;
            EventEmitter = module.EventEmitter;
        }, function (module) {
            Subject = module.Subject;
        }, function (module) {
            i3 = module;
            MatButtonModule = module.MatButtonModule;
        }, function (module) {
            i5 = module;
            MatSelectModule = module.MatSelectModule;
        }, function (module) {
            i7 = module;
            MatTooltipModule = module.MatTooltipModule;
        }, function (module) {
            mixinDisabled = module.mixinDisabled;
            mixinInitialized = module.mixinInitialized;
            i6 = module;
        }, function (module) {
            coerceNumberProperty = module.coerceNumberProperty;
            coerceBooleanProperty = module.coerceBooleanProperty;
        }, function (module) {
            i4 = module;
        }],
        execute: (function () {

            exports('MAT_PAGINATOR_INTL_PROVIDER_FACTORY', MAT_PAGINATOR_INTL_PROVIDER_FACTORY);

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * To modify the labels and text displayed, create a new instance of MatPaginatorIntl and
             * include it in a custom provider
             */
            function MatPaginator_div_2_mat_form_field_3_mat_option_2_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "mat-option", 19);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const pageSizeOption_r6 = ctx.$implicit;
                i0.ɵɵproperty("value", pageSizeOption_r6);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate1(" ", pageSizeOption_r6, " ");
              }
            }
            function MatPaginator_div_2_mat_form_field_3_Template(rf, ctx) {
              if (rf & 1) {
                const _r8 = i0.ɵɵgetCurrentView();
                i0.ɵɵelementStart(0, "mat-form-field", 16)(1, "mat-select", 17);
                i0.ɵɵlistener("selectionChange", function MatPaginator_div_2_mat_form_field_3_Template_mat_select_selectionChange_1_listener($event) {
                  i0.ɵɵrestoreView(_r8);
                  const ctx_r7 = i0.ɵɵnextContext(2);
                  return i0.ɵɵresetView(ctx_r7._changePageSize($event.value));
                });
                i0.ɵɵtemplate(2, MatPaginator_div_2_mat_form_field_3_mat_option_2_Template, 2, 2, "mat-option", 18);
                i0.ɵɵelementEnd()();
              }
              if (rf & 2) {
                const ctx_r3 = i0.ɵɵnextContext(2);
                i0.ɵɵproperty("appearance", ctx_r3._formFieldAppearance)("color", ctx_r3.color);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("value", ctx_r3.pageSize)("disabled", ctx_r3.disabled)("aria-labelledby", ctx_r3._pageSizeLabelId)("panelClass", ctx_r3.selectConfig.panelClass || "")("disableOptionCentering", ctx_r3.selectConfig.disableOptionCentering);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngForOf", ctx_r3._displayedPageSizeOptions);
              }
            }
            function MatPaginator_div_2_div_4_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 20);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r4 = i0.ɵɵnextContext(2);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r4.pageSize);
              }
            }
            function MatPaginator_div_2_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 12)(1, "div", 13);
                i0.ɵɵtext(2);
                i0.ɵɵelementEnd();
                i0.ɵɵtemplate(3, MatPaginator_div_2_mat_form_field_3_Template, 3, 8, "mat-form-field", 14);
                i0.ɵɵtemplate(4, MatPaginator_div_2_div_4_Template, 2, 1, "div", 15);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r0 = i0.ɵɵnextContext();
                i0.ɵɵadvance(1);
                i0.ɵɵpropertyInterpolate("id", ctx_r0._pageSizeLabelId);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate1(" ", ctx_r0._intl.itemsPerPageLabel, " ");
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngIf", ctx_r0._displayedPageSizeOptions.length > 1);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngIf", ctx_r0._displayedPageSizeOptions.length <= 1);
              }
            }
            function MatPaginator_button_6_Template(rf, ctx) {
              if (rf & 1) {
                const _r10 = i0.ɵɵgetCurrentView();
                i0.ɵɵelementStart(0, "button", 21);
                i0.ɵɵlistener("click", function MatPaginator_button_6_Template_button_click_0_listener() {
                  i0.ɵɵrestoreView(_r10);
                  const ctx_r9 = i0.ɵɵnextContext();
                  return i0.ɵɵresetView(ctx_r9.firstPage());
                });
                i0.ɵɵnamespaceSVG();
                i0.ɵɵelementStart(1, "svg", 7);
                i0.ɵɵelement(2, "path", 22);
                i0.ɵɵelementEnd()();
              }
              if (rf & 2) {
                const ctx_r1 = i0.ɵɵnextContext();
                i0.ɵɵproperty("matTooltip", ctx_r1._intl.firstPageLabel)("matTooltipDisabled", ctx_r1._previousButtonsDisabled())("matTooltipPosition", "above")("disabled", ctx_r1._previousButtonsDisabled());
                i0.ɵɵattribute("aria-label", ctx_r1._intl.firstPageLabel);
              }
            }
            function MatPaginator_button_13_Template(rf, ctx) {
              if (rf & 1) {
                const _r12 = i0.ɵɵgetCurrentView();
                i0.ɵɵnamespaceSVG();
                i0.ɵɵnamespaceHTML();
                i0.ɵɵelementStart(0, "button", 23);
                i0.ɵɵlistener("click", function MatPaginator_button_13_Template_button_click_0_listener() {
                  i0.ɵɵrestoreView(_r12);
                  const ctx_r11 = i0.ɵɵnextContext();
                  return i0.ɵɵresetView(ctx_r11.lastPage());
                });
                i0.ɵɵnamespaceSVG();
                i0.ɵɵelementStart(1, "svg", 7);
                i0.ɵɵelement(2, "path", 24);
                i0.ɵɵelementEnd()();
              }
              if (rf & 2) {
                const ctx_r2 = i0.ɵɵnextContext();
                i0.ɵɵproperty("matTooltip", ctx_r2._intl.lastPageLabel)("matTooltipDisabled", ctx_r2._nextButtonsDisabled())("matTooltipPosition", "above")("disabled", ctx_r2._nextButtonsDisabled());
                i0.ɵɵattribute("aria-label", ctx_r2._intl.lastPageLabel);
              }
            }
            class MatPaginatorIntl {
              constructor() {
                /**
                 * Stream to emit from when labels are changed. Use this to notify components when the labels have
                 * changed after initialization.
                 */
                this.changes = new Subject();
                /** A label for the page size selector. */
                this.itemsPerPageLabel = 'Items per page:';
                /** A label for the button that increments the current page. */
                this.nextPageLabel = 'Next page';
                /** A label for the button that decrements the current page. */
                this.previousPageLabel = 'Previous page';
                /** A label for the button that moves to the first page. */
                this.firstPageLabel = 'First page';
                /** A label for the button that moves to the last page. */
                this.lastPageLabel = 'Last page';
                /** A label for the range of items within the current page and the length of the whole list. */
                this.getRangeLabel = (page, pageSize, length) => {
                  if (length == 0 || pageSize == 0) {
                    return `0 of ${length}`;
                  }
                  length = Math.max(length, 0);
                  const startIndex = page * pageSize;
                  // If the start index exceeds the list length, do not try and fix the end index to the end.
                  const endIndex = startIndex < length ? Math.min(startIndex + pageSize, length) : startIndex + pageSize;
                  return `${startIndex + 1} – ${endIndex} of ${length}`;
                };
              }
            } exports('MatPaginatorIntl', MatPaginatorIntl);
            MatPaginatorIntl.ɵfac = function MatPaginatorIntl_Factory(t) {
              return new (t || MatPaginatorIntl)();
            };
            MatPaginatorIntl.ɵprov = /* @__PURE__ */i0.ɵɵdefineInjectable({
              token: MatPaginatorIntl,
              factory: MatPaginatorIntl.ɵfac,
              providedIn: 'root'
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatPaginatorIntl, [{
                type: Injectable,
                args: [{
                  providedIn: 'root'
                }]
              }], null, null);
            })();
            /** @docs-private */
            function MAT_PAGINATOR_INTL_PROVIDER_FACTORY(parentIntl) {
              return parentIntl || new MatPaginatorIntl();
            }
            /** @docs-private */
            const MAT_PAGINATOR_INTL_PROVIDER = exports('MAT_PAGINATOR_INTL_PROVIDER', {
              // If there is already an MatPaginatorIntl available, use that. Otherwise, provide a new one.
              provide: MatPaginatorIntl,
              deps: [[new Optional(), new SkipSelf(), MatPaginatorIntl]],
              useFactory: MAT_PAGINATOR_INTL_PROVIDER_FACTORY
            });

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /** The default page size if there is no page size and there are no provided page size options. */
            const DEFAULT_PAGE_SIZE = 50;
            /**
             * Change event object that is emitted when the user selects a
             * different page size or navigates to another page.
             */
            class PageEvent {} exports('PageEvent', PageEvent);
            /** Injection token that can be used to provide the default options for the paginator module. */
            const MAT_PAGINATOR_DEFAULT_OPTIONS = exports('MAT_PAGINATOR_DEFAULT_OPTIONS', new InjectionToken('MAT_PAGINATOR_DEFAULT_OPTIONS'));
            // Boilerplate for applying mixins to _MatPaginatorBase.
            /** @docs-private */
            const _MatPaginatorMixinBase = mixinDisabled(mixinInitialized(class {}));
            /**
             * Base class with all of the `MatPaginator` functionality.
             * @docs-private
             */
            class _MatPaginatorBase extends _MatPaginatorMixinBase {
              /** The zero-based page index of the displayed list of items. Defaulted to 0. */
              get pageIndex() {
                return this._pageIndex;
              }
              set pageIndex(value) {
                this._pageIndex = Math.max(coerceNumberProperty(value), 0);
                this._changeDetectorRef.markForCheck();
              }
              /** The length of the total number of items that are being paginated. Defaulted to 0. */
              get length() {
                return this._length;
              }
              set length(value) {
                this._length = coerceNumberProperty(value);
                this._changeDetectorRef.markForCheck();
              }
              /** Number of items to display on a page. By default set to 50. */
              get pageSize() {
                return this._pageSize;
              }
              set pageSize(value) {
                this._pageSize = Math.max(coerceNumberProperty(value), 0);
                this._updateDisplayedPageSizeOptions();
              }
              /** The set of provided page size options to display to the user. */
              get pageSizeOptions() {
                return this._pageSizeOptions;
              }
              set pageSizeOptions(value) {
                this._pageSizeOptions = (value || []).map(p => coerceNumberProperty(p));
                this._updateDisplayedPageSizeOptions();
              }
              /** Whether to hide the page size selection UI from the user. */
              get hidePageSize() {
                return this._hidePageSize;
              }
              set hidePageSize(value) {
                this._hidePageSize = coerceBooleanProperty(value);
              }
              /** Whether to show the first/last buttons UI to the user. */
              get showFirstLastButtons() {
                return this._showFirstLastButtons;
              }
              set showFirstLastButtons(value) {
                this._showFirstLastButtons = coerceBooleanProperty(value);
              }
              constructor(_intl, _changeDetectorRef, defaults) {
                super();
                this._intl = _intl;
                this._changeDetectorRef = _changeDetectorRef;
                this._pageIndex = 0;
                this._length = 0;
                this._pageSizeOptions = [];
                this._hidePageSize = false;
                this._showFirstLastButtons = false;
                /** Used to configure the underlying `MatSelect` inside the paginator. */
                this.selectConfig = {};
                /** Event emitted when the paginator changes the page size or page index. */
                this.page = new EventEmitter();
                this._intlChanges = _intl.changes.subscribe(() => this._changeDetectorRef.markForCheck());
                if (defaults) {
                  const {
                    pageSize,
                    pageSizeOptions,
                    hidePageSize,
                    showFirstLastButtons
                  } = defaults;
                  if (pageSize != null) {
                    this._pageSize = pageSize;
                  }
                  if (pageSizeOptions != null) {
                    this._pageSizeOptions = pageSizeOptions;
                  }
                  if (hidePageSize != null) {
                    this._hidePageSize = hidePageSize;
                  }
                  if (showFirstLastButtons != null) {
                    this._showFirstLastButtons = showFirstLastButtons;
                  }
                }
              }
              ngOnInit() {
                this._initialized = true;
                this._updateDisplayedPageSizeOptions();
                this._markInitialized();
              }
              ngOnDestroy() {
                this._intlChanges.unsubscribe();
              }
              /** Advances to the next page if it exists. */
              nextPage() {
                if (!this.hasNextPage()) {
                  return;
                }
                const previousPageIndex = this.pageIndex;
                this.pageIndex = this.pageIndex + 1;
                this._emitPageEvent(previousPageIndex);
              }
              /** Move back to the previous page if it exists. */
              previousPage() {
                if (!this.hasPreviousPage()) {
                  return;
                }
                const previousPageIndex = this.pageIndex;
                this.pageIndex = this.pageIndex - 1;
                this._emitPageEvent(previousPageIndex);
              }
              /** Move to the first page if not already there. */
              firstPage() {
                // hasPreviousPage being false implies at the start
                if (!this.hasPreviousPage()) {
                  return;
                }
                const previousPageIndex = this.pageIndex;
                this.pageIndex = 0;
                this._emitPageEvent(previousPageIndex);
              }
              /** Move to the last page if not already there. */
              lastPage() {
                // hasNextPage being false implies at the end
                if (!this.hasNextPage()) {
                  return;
                }
                const previousPageIndex = this.pageIndex;
                this.pageIndex = this.getNumberOfPages() - 1;
                this._emitPageEvent(previousPageIndex);
              }
              /** Whether there is a previous page. */
              hasPreviousPage() {
                return this.pageIndex >= 1 && this.pageSize != 0;
              }
              /** Whether there is a next page. */
              hasNextPage() {
                const maxPageIndex = this.getNumberOfPages() - 1;
                return this.pageIndex < maxPageIndex && this.pageSize != 0;
              }
              /** Calculate the number of pages */
              getNumberOfPages() {
                if (!this.pageSize) {
                  return 0;
                }
                return Math.ceil(this.length / this.pageSize);
              }
              /**
               * Changes the page size so that the first item displayed on the page will still be
               * displayed using the new page size.
               *
               * For example, if the page size is 10 and on the second page (items indexed 10-19) then
               * switching so that the page size is 5 will set the third page as the current page so
               * that the 10th item will still be displayed.
               */
              _changePageSize(pageSize) {
                // Current page needs to be updated to reflect the new page size. Navigate to the page
                // containing the previous page's first item.
                const startIndex = this.pageIndex * this.pageSize;
                const previousPageIndex = this.pageIndex;
                this.pageIndex = Math.floor(startIndex / pageSize) || 0;
                this.pageSize = pageSize;
                this._emitPageEvent(previousPageIndex);
              }
              /** Checks whether the buttons for going forwards should be disabled. */
              _nextButtonsDisabled() {
                return this.disabled || !this.hasNextPage();
              }
              /** Checks whether the buttons for going backwards should be disabled. */
              _previousButtonsDisabled() {
                return this.disabled || !this.hasPreviousPage();
              }
              /**
               * Updates the list of page size options to display to the user. Includes making sure that
               * the page size is an option and that the list is sorted.
               */
              _updateDisplayedPageSizeOptions() {
                if (!this._initialized) {
                  return;
                }
                // If no page size is provided, use the first page size option or the default page size.
                if (!this.pageSize) {
                  this._pageSize = this.pageSizeOptions.length != 0 ? this.pageSizeOptions[0] : DEFAULT_PAGE_SIZE;
                }
                this._displayedPageSizeOptions = this.pageSizeOptions.slice();
                if (this._displayedPageSizeOptions.indexOf(this.pageSize) === -1) {
                  this._displayedPageSizeOptions.push(this.pageSize);
                }
                // Sort the numbers using a number-specific sort function.
                this._displayedPageSizeOptions.sort((a, b) => a - b);
                this._changeDetectorRef.markForCheck();
              }
              /** Emits an event notifying that a change of the paginator's properties has been triggered. */
              _emitPageEvent(previousPageIndex) {
                this.page.emit({
                  previousPageIndex,
                  pageIndex: this.pageIndex,
                  pageSize: this.pageSize,
                  length: this.length
                });
              }
            } exports('_MatPaginatorBase', _MatPaginatorBase);
            _MatPaginatorBase.ɵfac = function _MatPaginatorBase_Factory(t) {
              i0.ɵɵinvalidFactory();
            };
            _MatPaginatorBase.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: _MatPaginatorBase,
              inputs: {
                color: "color",
                pageIndex: "pageIndex",
                length: "length",
                pageSize: "pageSize",
                pageSizeOptions: "pageSizeOptions",
                hidePageSize: "hidePageSize",
                showFirstLastButtons: "showFirstLastButtons",
                selectConfig: "selectConfig"
              },
              outputs: {
                page: "page"
              },
              features: [i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(_MatPaginatorBase, [{
                type: Directive
              }], function () {
                return [{
                  type: MatPaginatorIntl
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: undefined
                }];
              }, {
                color: [{
                  type: Input
                }],
                pageIndex: [{
                  type: Input
                }],
                length: [{
                  type: Input
                }],
                pageSize: [{
                  type: Input
                }],
                pageSizeOptions: [{
                  type: Input
                }],
                hidePageSize: [{
                  type: Input
                }],
                showFirstLastButtons: [{
                  type: Input
                }],
                selectConfig: [{
                  type: Input
                }],
                page: [{
                  type: Output
                }]
              });
            })();
            let nextUniqueId = 0;
            /**
             * Component to provide navigation between paged information. Displays the size of the current
             * page, user-selectable options to change that size, what items are being shown, and
             * navigational button to go to the previous or next page.
             */
            class MatPaginator extends _MatPaginatorBase {
              constructor(intl, changeDetectorRef, defaults) {
                super(intl, changeDetectorRef, defaults);
                /** ID for the DOM node containing the paginator's items per page label. */
                this._pageSizeLabelId = `mat-paginator-page-size-label-${nextUniqueId++}`;
                this._formFieldAppearance = (defaults === null || defaults === void 0 ? void 0 : defaults.formFieldAppearance) || 'outline';
              }
            } exports('MatPaginator', MatPaginator);
            MatPaginator.ɵfac = function MatPaginator_Factory(t) {
              return new (t || MatPaginator)(i0.ɵɵdirectiveInject(MatPaginatorIntl), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(MAT_PAGINATOR_DEFAULT_OPTIONS, 8));
            };
            MatPaginator.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatPaginator,
              selectors: [["mat-paginator"]],
              hostAttrs: ["role", "group", 1, "mat-mdc-paginator"],
              inputs: {
                disabled: "disabled"
              },
              exportAs: ["matPaginator"],
              features: [i0.ɵɵInheritDefinitionFeature],
              decls: 14,
              vars: 14,
              consts: [[1, "mat-mdc-paginator-outer-container"], [1, "mat-mdc-paginator-container"], ["class", "mat-mdc-paginator-page-size", 4, "ngIf"], [1, "mat-mdc-paginator-range-actions"], ["aria-live", "polite", 1, "mat-mdc-paginator-range-label"], ["mat-icon-button", "", "type", "button", "class", "mat-mdc-paginator-navigation-first", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click", 4, "ngIf"], ["mat-icon-button", "", "type", "button", 1, "mat-mdc-paginator-navigation-previous", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click"], ["viewBox", "0 0 24 24", "focusable", "false", 1, "mat-mdc-paginator-icon"], ["d", "M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z"], ["mat-icon-button", "", "type", "button", 1, "mat-mdc-paginator-navigation-next", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click"], ["d", "M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z"], ["mat-icon-button", "", "type", "button", "class", "mat-mdc-paginator-navigation-last", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click", 4, "ngIf"], [1, "mat-mdc-paginator-page-size"], [1, "mat-mdc-paginator-page-size-label", 3, "id"], ["class", "mat-mdc-paginator-page-size-select", 3, "appearance", "color", 4, "ngIf"], ["class", "mat-mdc-paginator-page-size-value", 4, "ngIf"], [1, "mat-mdc-paginator-page-size-select", 3, "appearance", "color"], ["hideSingleSelectionIndicator", "", 3, "value", "disabled", "aria-labelledby", "panelClass", "disableOptionCentering", "selectionChange"], [3, "value", 4, "ngFor", "ngForOf"], [3, "value"], [1, "mat-mdc-paginator-page-size-value"], ["mat-icon-button", "", "type", "button", 1, "mat-mdc-paginator-navigation-first", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click"], ["d", "M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z"], ["mat-icon-button", "", "type", "button", 1, "mat-mdc-paginator-navigation-last", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click"], ["d", "M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z"]],
              template: function MatPaginator_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵelementStart(0, "div", 0)(1, "div", 1);
                  i0.ɵɵtemplate(2, MatPaginator_div_2_Template, 5, 4, "div", 2);
                  i0.ɵɵelementStart(3, "div", 3)(4, "div", 4);
                  i0.ɵɵtext(5);
                  i0.ɵɵelementEnd();
                  i0.ɵɵtemplate(6, MatPaginator_button_6_Template, 3, 5, "button", 5);
                  i0.ɵɵelementStart(7, "button", 6);
                  i0.ɵɵlistener("click", function MatPaginator_Template_button_click_7_listener() {
                    return ctx.previousPage();
                  });
                  i0.ɵɵnamespaceSVG();
                  i0.ɵɵelementStart(8, "svg", 7);
                  i0.ɵɵelement(9, "path", 8);
                  i0.ɵɵelementEnd()();
                  i0.ɵɵnamespaceHTML();
                  i0.ɵɵelementStart(10, "button", 9);
                  i0.ɵɵlistener("click", function MatPaginator_Template_button_click_10_listener() {
                    return ctx.nextPage();
                  });
                  i0.ɵɵnamespaceSVG();
                  i0.ɵɵelementStart(11, "svg", 7);
                  i0.ɵɵelement(12, "path", 10);
                  i0.ɵɵelementEnd()();
                  i0.ɵɵtemplate(13, MatPaginator_button_13_Template, 3, 5, "button", 11);
                  i0.ɵɵelementEnd()()();
                }
                if (rf & 2) {
                  i0.ɵɵadvance(2);
                  i0.ɵɵproperty("ngIf", !ctx.hidePageSize);
                  i0.ɵɵadvance(3);
                  i0.ɵɵtextInterpolate1(" ", ctx._intl.getRangeLabel(ctx.pageIndex, ctx.pageSize, ctx.length), " ");
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngIf", ctx.showFirstLastButtons);
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("matTooltip", ctx._intl.previousPageLabel)("matTooltipDisabled", ctx._previousButtonsDisabled())("matTooltipPosition", "above")("disabled", ctx._previousButtonsDisabled());
                  i0.ɵɵattribute("aria-label", ctx._intl.previousPageLabel);
                  i0.ɵɵadvance(3);
                  i0.ɵɵproperty("matTooltip", ctx._intl.nextPageLabel)("matTooltipDisabled", ctx._nextButtonsDisabled())("matTooltipPosition", "above")("disabled", ctx._nextButtonsDisabled());
                  i0.ɵɵattribute("aria-label", ctx._intl.nextPageLabel);
                  i0.ɵɵadvance(3);
                  i0.ɵɵproperty("ngIf", ctx.showFirstLastButtons);
                }
              },
              dependencies: [i2.NgForOf, i2.NgIf, i3.MatIconButton, i4.MatFormField, i5.MatSelect, i6.MatOption, i7.MatTooltip],
              styles: [".mat-mdc-paginator{display:block}.mat-mdc-paginator .mat-mdc-form-field-subscript-wrapper{display:none}.mat-mdc-paginator .mat-mdc-select{line-height:1.5}.mat-mdc-paginator-outer-container{display:flex}.mat-mdc-paginator-container{display:flex;align-items:center;justify-content:flex-end;padding:0 8px;flex-wrap:wrap-reverse;width:100%}.mat-mdc-paginator-page-size{display:flex;align-items:baseline;margin-right:8px}[dir=rtl] .mat-mdc-paginator-page-size{margin-right:0;margin-left:8px}.mat-mdc-paginator-page-size-label{margin:0 4px}.mat-mdc-paginator-page-size-select{margin:0 4px;width:84px}.mat-mdc-paginator-range-label{margin:0 32px 0 24px}.mat-mdc-paginator-range-actions{display:flex;align-items:center}.mat-mdc-paginator-icon{display:inline-block;width:28px}[dir=rtl] .mat-mdc-paginator-icon{transform:rotate(180deg)}.cdk-high-contrast-active .mat-mdc-icon-button[disabled] .mat-mdc-paginator-icon,.cdk-high-contrast-active .mat-mdc-paginator-icon{fill:currentColor;fill:CanvasText}.cdk-high-contrast-active .mat-mdc-paginator-range-actions .mat-mdc-icon-button{outline:solid 1px}"],
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatPaginator, [{
                type: Component,
                args: [{
                  selector: 'mat-paginator',
                  exportAs: 'matPaginator',
                  inputs: ['disabled'],
                  host: {
                    'class': 'mat-mdc-paginator',
                    'role': 'group'
                  },
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  encapsulation: ViewEncapsulation.None,
                  template: "<div class=\"mat-mdc-paginator-outer-container\">\n  <div class=\"mat-mdc-paginator-container\">\n    <div class=\"mat-mdc-paginator-page-size\" *ngIf=\"!hidePageSize\">\n      <div class=\"mat-mdc-paginator-page-size-label\" id=\"{{_pageSizeLabelId}}\">\n        {{_intl.itemsPerPageLabel}}\n      </div>\n\n      <mat-form-field\n        *ngIf=\"_displayedPageSizeOptions.length > 1\"\n        [appearance]=\"_formFieldAppearance!\"\n        [color]=\"color\"\n        class=\"mat-mdc-paginator-page-size-select\">\n        <mat-select\n          [value]=\"pageSize\"\n          [disabled]=\"disabled\"\n          [aria-labelledby]=\"_pageSizeLabelId\"\n          [panelClass]=\"selectConfig.panelClass || ''\"\n          [disableOptionCentering]=\"selectConfig.disableOptionCentering\"\n          (selectionChange)=\"_changePageSize($event.value)\"\n          hideSingleSelectionIndicator>\n          <mat-option *ngFor=\"let pageSizeOption of _displayedPageSizeOptions\" [value]=\"pageSizeOption\">\n            {{pageSizeOption}}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n\n      <div\n        class=\"mat-mdc-paginator-page-size-value\"\n        *ngIf=\"_displayedPageSizeOptions.length <= 1\">{{pageSize}}</div>\n    </div>\n\n    <div class=\"mat-mdc-paginator-range-actions\">\n      <div class=\"mat-mdc-paginator-range-label\" aria-live=\"polite\">\n        {{_intl.getRangeLabel(pageIndex, pageSize, length)}}\n      </div>\n\n      <button mat-icon-button type=\"button\"\n              class=\"mat-mdc-paginator-navigation-first\"\n              (click)=\"firstPage()\"\n              [attr.aria-label]=\"_intl.firstPageLabel\"\n              [matTooltip]=\"_intl.firstPageLabel\"\n              [matTooltipDisabled]=\"_previousButtonsDisabled()\"\n              [matTooltipPosition]=\"'above'\"\n              [disabled]=\"_previousButtonsDisabled()\"\n              *ngIf=\"showFirstLastButtons\">\n        <svg class=\"mat-mdc-paginator-icon\" viewBox=\"0 0 24 24\" focusable=\"false\">\n          <path d=\"M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z\"/>\n        </svg>\n      </button>\n      <button mat-icon-button type=\"button\"\n              class=\"mat-mdc-paginator-navigation-previous\"\n              (click)=\"previousPage()\"\n              [attr.aria-label]=\"_intl.previousPageLabel\"\n              [matTooltip]=\"_intl.previousPageLabel\"\n              [matTooltipDisabled]=\"_previousButtonsDisabled()\"\n              [matTooltipPosition]=\"'above'\"\n              [disabled]=\"_previousButtonsDisabled()\">\n        <svg class=\"mat-mdc-paginator-icon\" viewBox=\"0 0 24 24\" focusable=\"false\">\n          <path d=\"M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z\"/>\n        </svg>\n      </button>\n      <button mat-icon-button type=\"button\"\n              class=\"mat-mdc-paginator-navigation-next\"\n              (click)=\"nextPage()\"\n              [attr.aria-label]=\"_intl.nextPageLabel\"\n              [matTooltip]=\"_intl.nextPageLabel\"\n              [matTooltipDisabled]=\"_nextButtonsDisabled()\"\n              [matTooltipPosition]=\"'above'\"\n              [disabled]=\"_nextButtonsDisabled()\">\n        <svg class=\"mat-mdc-paginator-icon\" viewBox=\"0 0 24 24\" focusable=\"false\">\n          <path d=\"M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z\"/>\n        </svg>\n      </button>\n      <button mat-icon-button type=\"button\"\n              class=\"mat-mdc-paginator-navigation-last\"\n              (click)=\"lastPage()\"\n              [attr.aria-label]=\"_intl.lastPageLabel\"\n              [matTooltip]=\"_intl.lastPageLabel\"\n              [matTooltipDisabled]=\"_nextButtonsDisabled()\"\n              [matTooltipPosition]=\"'above'\"\n              [disabled]=\"_nextButtonsDisabled()\"\n              *ngIf=\"showFirstLastButtons\">\n        <svg class=\"mat-mdc-paginator-icon\" viewBox=\"0 0 24 24\" focusable=\"false\">\n          <path d=\"M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z\"/>\n        </svg>\n      </button>\n    </div>\n  </div>\n</div>\n",
                  styles: [".mat-mdc-paginator{display:block}.mat-mdc-paginator .mat-mdc-form-field-subscript-wrapper{display:none}.mat-mdc-paginator .mat-mdc-select{line-height:1.5}.mat-mdc-paginator-outer-container{display:flex}.mat-mdc-paginator-container{display:flex;align-items:center;justify-content:flex-end;padding:0 8px;flex-wrap:wrap-reverse;width:100%}.mat-mdc-paginator-page-size{display:flex;align-items:baseline;margin-right:8px}[dir=rtl] .mat-mdc-paginator-page-size{margin-right:0;margin-left:8px}.mat-mdc-paginator-page-size-label{margin:0 4px}.mat-mdc-paginator-page-size-select{margin:0 4px;width:84px}.mat-mdc-paginator-range-label{margin:0 32px 0 24px}.mat-mdc-paginator-range-actions{display:flex;align-items:center}.mat-mdc-paginator-icon{display:inline-block;width:28px}[dir=rtl] .mat-mdc-paginator-icon{transform:rotate(180deg)}.cdk-high-contrast-active .mat-mdc-icon-button[disabled] .mat-mdc-paginator-icon,.cdk-high-contrast-active .mat-mdc-paginator-icon{fill:currentColor;fill:CanvasText}.cdk-high-contrast-active .mat-mdc-paginator-range-actions .mat-mdc-icon-button{outline:solid 1px}"]
                }]
              }], function () {
                return [{
                  type: MatPaginatorIntl
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_PAGINATOR_DEFAULT_OPTIONS]
                  }]
                }];
              }, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            class MatPaginatorModule {} exports('MatPaginatorModule', MatPaginatorModule);
            MatPaginatorModule.ɵfac = function MatPaginatorModule_Factory(t) {
              return new (t || MatPaginatorModule)();
            };
            MatPaginatorModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatPaginatorModule
            });
            MatPaginatorModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              providers: [MAT_PAGINATOR_INTL_PROVIDER],
              imports: [CommonModule, MatButtonModule, MatSelectModule, MatTooltipModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatPaginatorModule, [{
                type: NgModule,
                args: [{
                  imports: [CommonModule, MatButtonModule, MatSelectModule, MatTooltipModule],
                  exports: [MatPaginator],
                  declarations: [MatPaginator],
                  providers: [MAT_PAGINATOR_INTL_PROVIDER]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-paginator.js.map
