/* esm-bundle - @angular/material/stepper@15.2.9 - Ivy - system format - es2015 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/cdk/portal', '@angular/cdk/stepper', '@angular/common', '@angular/core', '@angular/material/core', '@angular/material/icon', 'rxjs', '@angular/cdk/a11y', 'rxjs/operators', '@angular/animations', '@angular/cdk/bidi'], (function (exports) {
    'use strict';
    var i2$1, PortalModule, TemplatePortal, CdkStepHeader, STEPPER_GLOBAL_OPTIONS, CdkStep, CdkStepper, CdkStepperModule, CdkStepLabel, CdkStepperNext, CdkStepperPrevious, i3, CommonModule, i0, Directive, Injectable, Optional, SkipSelf, Component, ViewEncapsulation, ChangeDetectionStrategy, Input, forwardRef, Inject, ContentChild, QueryList, EventEmitter, ViewChildren, ContentChildren, Output, NgModule, mixinColor, i1, ErrorStateMatcher, MatCommonModule, MatRippleModule, i4, MatIconModule, Subject, Subscription, i2, takeUntil, distinctUntilChanged, switchMap, map, startWith, trigger, state, style, transition, animate, i3$1;
    return {
        setters: [function (module) {
            i2$1 = module;
            PortalModule = module.PortalModule;
            TemplatePortal = module.TemplatePortal;
        }, function (module) {
            CdkStepHeader = module.CdkStepHeader;
            STEPPER_GLOBAL_OPTIONS = module.STEPPER_GLOBAL_OPTIONS;
            CdkStep = module.CdkStep;
            CdkStepper = module.CdkStepper;
            CdkStepperModule = module.CdkStepperModule;
            CdkStepLabel = module.CdkStepLabel;
            CdkStepperNext = module.CdkStepperNext;
            CdkStepperPrevious = module.CdkStepperPrevious;
        }, function (module) {
            i3 = module;
            CommonModule = module.CommonModule;
        }, function (module) {
            i0 = module;
            Directive = module.Directive;
            Injectable = module.Injectable;
            Optional = module.Optional;
            SkipSelf = module.SkipSelf;
            Component = module.Component;
            ViewEncapsulation = module.ViewEncapsulation;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            Input = module.Input;
            forwardRef = module.forwardRef;
            Inject = module.Inject;
            ContentChild = module.ContentChild;
            QueryList = module.QueryList;
            EventEmitter = module.EventEmitter;
            ViewChildren = module.ViewChildren;
            ContentChildren = module.ContentChildren;
            Output = module.Output;
            NgModule = module.NgModule;
        }, function (module) {
            mixinColor = module.mixinColor;
            i1 = module;
            ErrorStateMatcher = module.ErrorStateMatcher;
            MatCommonModule = module.MatCommonModule;
            MatRippleModule = module.MatRippleModule;
        }, function (module) {
            i4 = module;
            MatIconModule = module.MatIconModule;
        }, function (module) {
            Subject = module.Subject;
            Subscription = module.Subscription;
        }, function (module) {
            i2 = module;
        }, function (module) {
            takeUntil = module.takeUntil;
            distinctUntilChanged = module.distinctUntilChanged;
            switchMap = module.switchMap;
            map = module.map;
            startWith = module.startWith;
        }, function (module) {
            trigger = module.trigger;
            state = module.state;
            style = module.style;
            transition = module.transition;
            animate = module.animate;
        }, function (module) {
            i3$1 = module;
        }],
        execute: (function () {

            exports('MAT_STEPPER_INTL_PROVIDER_FACTORY', MAT_STEPPER_INTL_PROVIDER_FACTORY);

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            function MatStepHeader_ng_container_3_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementContainer(0, 8);
              }
              if (rf & 2) {
                const ctx_r0 = i0.ɵɵnextContext();
                i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.iconOverrides[ctx_r0.state])("ngTemplateOutletContext", ctx_r0._getIconContext());
              }
            }
            function MatStepHeader_ng_container_4_span_1_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "span", 13);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r6 = i0.ɵɵnextContext(2);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r6._getDefaultTextForState(ctx_r6.state));
              }
            }
            function MatStepHeader_ng_container_4_span_2_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "span", 14);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r7 = i0.ɵɵnextContext(2);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r7._intl.completedLabel);
              }
            }
            function MatStepHeader_ng_container_4_span_3_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "span", 14);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r8 = i0.ɵɵnextContext(2);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r8._intl.editableLabel);
              }
            }
            function MatStepHeader_ng_container_4_mat_icon_4_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "mat-icon", 13);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r9 = i0.ɵɵnextContext(2);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r9._getDefaultTextForState(ctx_r9.state));
              }
            }
            function MatStepHeader_ng_container_4_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementContainerStart(0, 9);
                i0.ɵɵtemplate(1, MatStepHeader_ng_container_4_span_1_Template, 2, 1, "span", 10);
                i0.ɵɵtemplate(2, MatStepHeader_ng_container_4_span_2_Template, 2, 1, "span", 11);
                i0.ɵɵtemplate(3, MatStepHeader_ng_container_4_span_3_Template, 2, 1, "span", 11);
                i0.ɵɵtemplate(4, MatStepHeader_ng_container_4_mat_icon_4_Template, 2, 1, "mat-icon", 12);
                i0.ɵɵelementContainerEnd();
              }
              if (rf & 2) {
                const ctx_r1 = i0.ɵɵnextContext();
                i0.ɵɵproperty("ngSwitch", ctx_r1.state);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngSwitchCase", "number");
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngIf", ctx_r1.state === "done");
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngIf", ctx_r1.state === "edit");
              }
            }
            function MatStepHeader_div_6_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 15);
                i0.ɵɵelementContainer(1, 16);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r2 = i0.ɵɵnextContext();
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngTemplateOutlet", ctx_r2._templateLabel().template);
              }
            }
            function MatStepHeader_div_7_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 15);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r3 = i0.ɵɵnextContext();
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r3.label);
              }
            }
            function MatStepHeader_div_8_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 17);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r4 = i0.ɵɵnextContext();
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r4._intl.optionalLabel);
              }
            }
            function MatStepHeader_div_9_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 18);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r5 = i0.ɵɵnextContext();
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r5.errorMessage);
              }
            }
            function MatStep_ng_template_0_ng_template_1_Template(rf, ctx) {}
            function MatStep_ng_template_0_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵprojection(0);
                i0.ɵɵtemplate(1, MatStep_ng_template_0_ng_template_1_Template, 0, 0, "ng-template", 0);
              }
              if (rf & 2) {
                const ctx_r0 = i0.ɵɵnextContext();
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("cdkPortalOutlet", ctx_r0._portal);
              }
            }
            const _c0 = ["*"];
            function MatStepper_div_1_ng_container_2_div_2_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelement(0, "div", 11);
              }
            }
            const _c1 = function (a0, a1) {
              return {
                step: a0,
                i: a1
              };
            };
            function MatStepper_div_1_ng_container_2_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementContainerStart(0);
                i0.ɵɵelementContainer(1, 9);
                i0.ɵɵtemplate(2, MatStepper_div_1_ng_container_2_div_2_Template, 1, 0, "div", 10);
                i0.ɵɵelementContainerEnd();
              }
              if (rf & 2) {
                const step_r6 = ctx.$implicit;
                const i_r7 = ctx.index;
                const isLast_r8 = ctx.last;
                i0.ɵɵnextContext(2);
                const _r2 = i0.ɵɵreference(4);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngTemplateOutlet", _r2)("ngTemplateOutletContext", i0.ɵɵpureFunction2(3, _c1, step_r6, i_r7));
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngIf", !isLast_r8);
              }
            }
            const _c2 = function (a0) {
              return {
                "animationDuration": a0
              };
            };
            const _c3 = function (a0, a1) {
              return {
                "value": a0,
                "params": a1
              };
            };
            function MatStepper_div_1_div_4_Template(rf, ctx) {
              if (rf & 1) {
                const _r13 = i0.ɵɵgetCurrentView();
                i0.ɵɵelementStart(0, "div", 12);
                i0.ɵɵlistener("@horizontalStepTransition.done", function MatStepper_div_1_div_4_Template_div_animation_horizontalStepTransition_done_0_listener($event) {
                  i0.ɵɵrestoreView(_r13);
                  const ctx_r12 = i0.ɵɵnextContext(2);
                  return i0.ɵɵresetView(ctx_r12._animationDone.next($event));
                });
                i0.ɵɵelementContainer(1, 13);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const step_r10 = ctx.$implicit;
                const i_r11 = ctx.index;
                const ctx_r5 = i0.ɵɵnextContext(2);
                i0.ɵɵclassProp("mat-horizontal-stepper-content-inactive", ctx_r5.selectedIndex !== i_r11);
                i0.ɵɵproperty("@horizontalStepTransition", i0.ɵɵpureFunction2(8, _c3, ctx_r5._getAnimationDirection(i_r11), i0.ɵɵpureFunction1(6, _c2, ctx_r5._getAnimationDuration())))("id", ctx_r5._getStepContentId(i_r11));
                i0.ɵɵattribute("aria-labelledby", ctx_r5._getStepLabelId(i_r11));
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngTemplateOutlet", step_r10.content);
              }
            }
            function MatStepper_div_1_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 4)(1, "div", 5);
                i0.ɵɵtemplate(2, MatStepper_div_1_ng_container_2_Template, 3, 6, "ng-container", 6);
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(3, "div", 7);
                i0.ɵɵtemplate(4, MatStepper_div_1_div_4_Template, 2, 11, "div", 8);
                i0.ɵɵelementEnd()();
              }
              if (rf & 2) {
                const ctx_r0 = i0.ɵɵnextContext();
                i0.ɵɵadvance(2);
                i0.ɵɵproperty("ngForOf", ctx_r0.steps);
                i0.ɵɵadvance(2);
                i0.ɵɵproperty("ngForOf", ctx_r0.steps);
              }
            }
            function MatStepper_ng_container_2_div_1_Template(rf, ctx) {
              if (rf & 1) {
                const _r19 = i0.ɵɵgetCurrentView();
                i0.ɵɵelementStart(0, "div", 15);
                i0.ɵɵelementContainer(1, 9);
                i0.ɵɵelementStart(2, "div", 16)(3, "div", 17);
                i0.ɵɵlistener("@verticalStepTransition.done", function MatStepper_ng_container_2_div_1_Template_div_animation_verticalStepTransition_done_3_listener($event) {
                  i0.ɵɵrestoreView(_r19);
                  const ctx_r18 = i0.ɵɵnextContext(2);
                  return i0.ɵɵresetView(ctx_r18._animationDone.next($event));
                });
                i0.ɵɵelementStart(4, "div", 18);
                i0.ɵɵelementContainer(5, 13);
                i0.ɵɵelementEnd()()()();
              }
              if (rf & 2) {
                const step_r15 = ctx.$implicit;
                const i_r16 = ctx.index;
                const isLast_r17 = ctx.last;
                const ctx_r14 = i0.ɵɵnextContext(2);
                const _r2 = i0.ɵɵreference(4);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngTemplateOutlet", _r2)("ngTemplateOutletContext", i0.ɵɵpureFunction2(10, _c1, step_r15, i_r16));
                i0.ɵɵadvance(1);
                i0.ɵɵclassProp("mat-stepper-vertical-line", !isLast_r17);
                i0.ɵɵadvance(1);
                i0.ɵɵclassProp("mat-vertical-stepper-content-inactive", ctx_r14.selectedIndex !== i_r16);
                i0.ɵɵproperty("@verticalStepTransition", i0.ɵɵpureFunction2(15, _c3, ctx_r14._getAnimationDirection(i_r16), i0.ɵɵpureFunction1(13, _c2, ctx_r14._getAnimationDuration())))("id", ctx_r14._getStepContentId(i_r16));
                i0.ɵɵattribute("aria-labelledby", ctx_r14._getStepLabelId(i_r16));
                i0.ɵɵadvance(2);
                i0.ɵɵproperty("ngTemplateOutlet", step_r15.content);
              }
            }
            function MatStepper_ng_container_2_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementContainerStart(0);
                i0.ɵɵtemplate(1, MatStepper_ng_container_2_div_1_Template, 6, 18, "div", 14);
                i0.ɵɵelementContainerEnd();
              }
              if (rf & 2) {
                const ctx_r1 = i0.ɵɵnextContext();
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngForOf", ctx_r1.steps);
              }
            }
            function MatStepper_ng_template_3_Template(rf, ctx) {
              if (rf & 1) {
                const _r23 = i0.ɵɵgetCurrentView();
                i0.ɵɵelementStart(0, "mat-step-header", 19);
                i0.ɵɵlistener("click", function MatStepper_ng_template_3_Template_mat_step_header_click_0_listener() {
                  const restoredCtx = i0.ɵɵrestoreView(_r23);
                  const step_r20 = restoredCtx.step;
                  return i0.ɵɵresetView(step_r20.select());
                })("keydown", function MatStepper_ng_template_3_Template_mat_step_header_keydown_0_listener($event) {
                  i0.ɵɵrestoreView(_r23);
                  const ctx_r24 = i0.ɵɵnextContext();
                  return i0.ɵɵresetView(ctx_r24._onKeydown($event));
                });
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const step_r20 = ctx.step;
                const i_r21 = ctx.i;
                const ctx_r3 = i0.ɵɵnextContext();
                i0.ɵɵclassProp("mat-horizontal-stepper-header", ctx_r3.orientation === "horizontal")("mat-vertical-stepper-header", ctx_r3.orientation === "vertical");
                i0.ɵɵproperty("tabIndex", ctx_r3._getFocusIndex() === i_r21 ? 0 : -1)("id", ctx_r3._getStepLabelId(i_r21))("index", i_r21)("state", ctx_r3._getIndicatorType(i_r21, step_r20.state))("label", step_r20.stepLabel || step_r20.label)("selected", ctx_r3.selectedIndex === i_r21)("active", ctx_r3._stepIsNavigable(i_r21, step_r20))("optional", step_r20.optional)("errorMessage", step_r20.errorMessage)("iconOverrides", ctx_r3._iconOverrides)("disableRipple", ctx_r3.disableRipple || !ctx_r3._stepIsNavigable(i_r21, step_r20))("color", step_r20.color || ctx_r3.color);
                i0.ɵɵattribute("aria-posinset", i_r21 + 1)("aria-setsize", ctx_r3.steps.length)("aria-controls", ctx_r3._getStepContentId(i_r21))("aria-selected", ctx_r3.selectedIndex == i_r21)("aria-label", step_r20.ariaLabel || null)("aria-labelledby", !step_r20.ariaLabel && step_r20.ariaLabelledby ? step_r20.ariaLabelledby : null)("aria-disabled", ctx_r3._stepIsNavigable(i_r21, step_r20) ? null : true);
              }
            }
            class MatStepLabel extends CdkStepLabel {} exports('MatStepLabel', MatStepLabel);
            MatStepLabel.ɵfac = /* @__PURE__ */function () {
              let ɵMatStepLabel_BaseFactory;
              return function MatStepLabel_Factory(t) {
                return (ɵMatStepLabel_BaseFactory || (ɵMatStepLabel_BaseFactory = i0.ɵɵgetInheritedFactory(MatStepLabel)))(t || MatStepLabel);
              };
            }();
            MatStepLabel.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatStepLabel,
              selectors: [["", "matStepLabel", ""]],
              features: [i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStepLabel, [{
                type: Directive,
                args: [{
                  selector: '[matStepLabel]'
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /** Stepper data that is required for internationalization. */
            class MatStepperIntl {
              constructor() {
                /**
                 * Stream that emits whenever the labels here are changed. Use this to notify
                 * components if the labels have changed after initialization.
                 */
                this.changes = new Subject();
                /** Label that is rendered below optional steps. */
                this.optionalLabel = 'Optional';
                /** Label that is used to indicate step as completed to screen readers. */
                this.completedLabel = 'Completed';
                /** Label that is used to indicate step as editable to screen readers. */
                this.editableLabel = 'Editable';
              }
            } exports('MatStepperIntl', MatStepperIntl);
            MatStepperIntl.ɵfac = function MatStepperIntl_Factory(t) {
              return new (t || MatStepperIntl)();
            };
            MatStepperIntl.ɵprov = /* @__PURE__ */i0.ɵɵdefineInjectable({
              token: MatStepperIntl,
              factory: MatStepperIntl.ɵfac,
              providedIn: 'root'
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStepperIntl, [{
                type: Injectable,
                args: [{
                  providedIn: 'root'
                }]
              }], null, null);
            })();
            /** @docs-private */
            function MAT_STEPPER_INTL_PROVIDER_FACTORY(parentIntl) {
              return parentIntl || new MatStepperIntl();
            }
            /** @docs-private */
            const MAT_STEPPER_INTL_PROVIDER = exports('MAT_STEPPER_INTL_PROVIDER', {
              provide: MatStepperIntl,
              deps: [[new Optional(), new SkipSelf(), MatStepperIntl]],
              useFactory: MAT_STEPPER_INTL_PROVIDER_FACTORY
            });

            // Boilerplate for applying mixins to MatStepHeader.
            /** @docs-private */
            const _MatStepHeaderBase = mixinColor(class MatStepHeaderBase extends CdkStepHeader {
              constructor(elementRef) {
                super(elementRef);
              }
            }, 'primary');
            class MatStepHeader extends _MatStepHeaderBase {
              constructor(_intl, _focusMonitor, _elementRef, changeDetectorRef) {
                super(_elementRef);
                this._intl = _intl;
                this._focusMonitor = _focusMonitor;
                this._intlSubscription = _intl.changes.subscribe(() => changeDetectorRef.markForCheck());
              }
              ngAfterViewInit() {
                this._focusMonitor.monitor(this._elementRef, true);
              }
              ngOnDestroy() {
                this._intlSubscription.unsubscribe();
                this._focusMonitor.stopMonitoring(this._elementRef);
              }
              /** Focuses the step header. */
              focus(origin, options) {
                if (origin) {
                  this._focusMonitor.focusVia(this._elementRef, origin, options);
                } else {
                  this._elementRef.nativeElement.focus(options);
                }
              }
              /** Returns string label of given step if it is a text label. */
              _stringLabel() {
                return this.label instanceof MatStepLabel ? null : this.label;
              }
              /** Returns MatStepLabel if the label of given step is a template label. */
              _templateLabel() {
                return this.label instanceof MatStepLabel ? this.label : null;
              }
              /** Returns the host HTML element. */
              _getHostElement() {
                return this._elementRef.nativeElement;
              }
              /** Template context variables that are exposed to the `matStepperIcon` instances. */
              _getIconContext() {
                return {
                  index: this.index,
                  active: this.active,
                  optional: this.optional
                };
              }
              _getDefaultTextForState(state) {
                if (state == 'number') {
                  return `${this.index + 1}`;
                }
                if (state == 'edit') {
                  return 'create';
                }
                if (state == 'error') {
                  return 'warning';
                }
                return state;
              }
            } exports('MatStepHeader', MatStepHeader);
            MatStepHeader.ɵfac = function MatStepHeader_Factory(t) {
              return new (t || MatStepHeader)(i0.ɵɵdirectiveInject(MatStepperIntl), i0.ɵɵdirectiveInject(i2.FocusMonitor), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef));
            };
            MatStepHeader.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatStepHeader,
              selectors: [["mat-step-header"]],
              hostAttrs: ["role", "tab", 1, "mat-step-header"],
              inputs: {
                color: "color",
                state: "state",
                label: "label",
                errorMessage: "errorMessage",
                iconOverrides: "iconOverrides",
                index: "index",
                selected: "selected",
                active: "active",
                optional: "optional",
                disableRipple: "disableRipple"
              },
              features: [i0.ɵɵInheritDefinitionFeature],
              decls: 10,
              vars: 19,
              consts: [["matRipple", "", 1, "mat-step-header-ripple", "mat-focus-indicator", 3, "matRippleTrigger", "matRippleDisabled"], [1, "mat-step-icon-content", 3, "ngSwitch"], [3, "ngTemplateOutlet", "ngTemplateOutletContext", 4, "ngSwitchCase"], [3, "ngSwitch", 4, "ngSwitchDefault"], [1, "mat-step-label"], ["class", "mat-step-text-label", 4, "ngIf"], ["class", "mat-step-optional", 4, "ngIf"], ["class", "mat-step-sub-label-error", 4, "ngIf"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"], [3, "ngSwitch"], ["aria-hidden", "true", 4, "ngSwitchCase"], ["class", "cdk-visually-hidden", 4, "ngIf"], ["aria-hidden", "true", 4, "ngSwitchDefault"], ["aria-hidden", "true"], [1, "cdk-visually-hidden"], [1, "mat-step-text-label"], [3, "ngTemplateOutlet"], [1, "mat-step-optional"], [1, "mat-step-sub-label-error"]],
              template: function MatStepHeader_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵelement(0, "div", 0);
                  i0.ɵɵelementStart(1, "div")(2, "div", 1);
                  i0.ɵɵtemplate(3, MatStepHeader_ng_container_3_Template, 1, 2, "ng-container", 2);
                  i0.ɵɵtemplate(4, MatStepHeader_ng_container_4_Template, 5, 4, "ng-container", 3);
                  i0.ɵɵelementEnd()();
                  i0.ɵɵelementStart(5, "div", 4);
                  i0.ɵɵtemplate(6, MatStepHeader_div_6_Template, 2, 1, "div", 5);
                  i0.ɵɵtemplate(7, MatStepHeader_div_7_Template, 2, 1, "div", 5);
                  i0.ɵɵtemplate(8, MatStepHeader_div_8_Template, 2, 1, "div", 6);
                  i0.ɵɵtemplate(9, MatStepHeader_div_9_Template, 2, 1, "div", 7);
                  i0.ɵɵelementEnd();
                }
                if (rf & 2) {
                  i0.ɵɵproperty("matRippleTrigger", ctx._getHostElement())("matRippleDisabled", ctx.disableRipple);
                  i0.ɵɵadvance(1);
                  i0.ɵɵclassMapInterpolate1("mat-step-icon-state-", ctx.state, " mat-step-icon");
                  i0.ɵɵclassProp("mat-step-icon-selected", ctx.selected);
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngSwitch", !!(ctx.iconOverrides && ctx.iconOverrides[ctx.state]));
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngSwitchCase", true);
                  i0.ɵɵadvance(2);
                  i0.ɵɵclassProp("mat-step-label-active", ctx.active)("mat-step-label-selected", ctx.selected)("mat-step-label-error", ctx.state == "error");
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngIf", ctx._templateLabel());
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngIf", ctx._stringLabel());
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngIf", ctx.optional && ctx.state != "error");
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngIf", ctx.state == "error");
                }
              },
              dependencies: [i3.NgIf, i3.NgTemplateOutlet, i3.NgSwitch, i3.NgSwitchCase, i3.NgSwitchDefault, i4.MatIcon, i1.MatRipple],
              styles: [".mat-step-header{overflow:hidden;outline:none;cursor:pointer;position:relative;box-sizing:content-box;-webkit-tap-highlight-color:rgba(0,0,0,0)}.mat-step-header:focus .mat-focus-indicator::before{content:\"\"}.cdk-high-contrast-active .mat-step-header{outline:solid 1px}.cdk-high-contrast-active .mat-step-header[aria-selected=true] .mat-step-label{text-decoration:underline}.cdk-high-contrast-active .mat-step-header[aria-disabled=true]{outline-color:GrayText}.cdk-high-contrast-active .mat-step-header[aria-disabled=true] .mat-step-label,.cdk-high-contrast-active .mat-step-header[aria-disabled=true] .mat-step-icon,.cdk-high-contrast-active .mat-step-header[aria-disabled=true] .mat-step-optional{color:GrayText}.mat-step-optional,.mat-step-sub-label-error{font-size:12px}.mat-step-icon{border-radius:50%;height:24px;width:24px;flex-shrink:0;position:relative}.mat-step-icon-content{position:absolute;top:50%;left:50%;transform:translate(-50%, -50%);display:flex}.mat-step-icon .mat-icon{font-size:16px;height:16px;width:16px}.mat-step-icon-state-error .mat-icon{font-size:24px;height:24px;width:24px}.mat-step-label{display:inline-block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;min-width:50px;vertical-align:middle}.mat-step-text-label{text-overflow:ellipsis;overflow:hidden}.mat-step-header .mat-step-header-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none}"],
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStepHeader, [{
                type: Component,
                args: [{
                  selector: 'mat-step-header',
                  inputs: ['color'],
                  host: {
                    'class': 'mat-step-header',
                    'role': 'tab'
                  },
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  template: "<div class=\"mat-step-header-ripple mat-focus-indicator\" matRipple\n     [matRippleTrigger]=\"_getHostElement()\"\n     [matRippleDisabled]=\"disableRipple\"></div>\n\n<div class=\"mat-step-icon-state-{{state}} mat-step-icon\" [class.mat-step-icon-selected]=\"selected\">\n  <div class=\"mat-step-icon-content\" [ngSwitch]=\"!!(iconOverrides && iconOverrides[state])\">\n    <ng-container\n      *ngSwitchCase=\"true\"\n      [ngTemplateOutlet]=\"iconOverrides[state]\"\n      [ngTemplateOutletContext]=\"_getIconContext()\"></ng-container>\n    <ng-container *ngSwitchDefault [ngSwitch]=\"state\">\n      <span aria-hidden=\"true\" *ngSwitchCase=\"'number'\">{{_getDefaultTextForState(state)}}</span>\n      <span class=\"cdk-visually-hidden\" *ngIf=\"state === 'done'\">{{_intl.completedLabel}}</span>\n      <span class=\"cdk-visually-hidden\" *ngIf=\"state === 'edit'\">{{_intl.editableLabel}}</span>\n      <mat-icon aria-hidden=\"true\" *ngSwitchDefault>{{_getDefaultTextForState(state)}}</mat-icon>\n    </ng-container>\n  </div>\n</div>\n<div class=\"mat-step-label\"\n     [class.mat-step-label-active]=\"active\"\n     [class.mat-step-label-selected]=\"selected\"\n     [class.mat-step-label-error]=\"state == 'error'\">\n  <!-- If there is a label template, use it. -->\n  <div class=\"mat-step-text-label\" *ngIf=\"_templateLabel()\">\n    <ng-container [ngTemplateOutlet]=\"_templateLabel()!.template\"></ng-container>\n  </div>\n  <!-- If there is no label template, fall back to the text label. -->\n  <div class=\"mat-step-text-label\" *ngIf=\"_stringLabel()\">{{label}}</div>\n\n  <div class=\"mat-step-optional\" *ngIf=\"optional && state != 'error'\">{{_intl.optionalLabel}}</div>\n  <div class=\"mat-step-sub-label-error\" *ngIf=\"state == 'error'\">{{errorMessage}}</div>\n</div>\n\n",
                  styles: [".mat-step-header{overflow:hidden;outline:none;cursor:pointer;position:relative;box-sizing:content-box;-webkit-tap-highlight-color:rgba(0,0,0,0)}.mat-step-header:focus .mat-focus-indicator::before{content:\"\"}.cdk-high-contrast-active .mat-step-header{outline:solid 1px}.cdk-high-contrast-active .mat-step-header[aria-selected=true] .mat-step-label{text-decoration:underline}.cdk-high-contrast-active .mat-step-header[aria-disabled=true]{outline-color:GrayText}.cdk-high-contrast-active .mat-step-header[aria-disabled=true] .mat-step-label,.cdk-high-contrast-active .mat-step-header[aria-disabled=true] .mat-step-icon,.cdk-high-contrast-active .mat-step-header[aria-disabled=true] .mat-step-optional{color:GrayText}.mat-step-optional,.mat-step-sub-label-error{font-size:12px}.mat-step-icon{border-radius:50%;height:24px;width:24px;flex-shrink:0;position:relative}.mat-step-icon-content{position:absolute;top:50%;left:50%;transform:translate(-50%, -50%);display:flex}.mat-step-icon .mat-icon{font-size:16px;height:16px;width:16px}.mat-step-icon-state-error .mat-icon{font-size:24px;height:24px;width:24px}.mat-step-label{display:inline-block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;min-width:50px;vertical-align:middle}.mat-step-text-label{text-overflow:ellipsis;overflow:hidden}.mat-step-header .mat-step-header-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none}"]
                }]
              }], function () {
                return [{
                  type: MatStepperIntl
                }, {
                  type: i2.FocusMonitor
                }, {
                  type: i0.ElementRef
                }, {
                  type: i0.ChangeDetectorRef
                }];
              }, {
                state: [{
                  type: Input
                }],
                label: [{
                  type: Input
                }],
                errorMessage: [{
                  type: Input
                }],
                iconOverrides: [{
                  type: Input
                }],
                index: [{
                  type: Input
                }],
                selected: [{
                  type: Input
                }],
                active: [{
                  type: Input
                }],
                optional: [{
                  type: Input
                }],
                disableRipple: [{
                  type: Input
                }]
              });
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            const DEFAULT_HORIZONTAL_ANIMATION_DURATION = '500ms';
            const DEFAULT_VERTICAL_ANIMATION_DURATION = '225ms';
            /**
             * Animations used by the Material steppers.
             * @docs-private
             */
            const matStepperAnimations = exports('matStepperAnimations', {
              /** Animation that transitions the step along the X axis in a horizontal stepper. */
              horizontalStepTransition: trigger('horizontalStepTransition', [state('previous', style({
                transform: 'translate3d(-100%, 0, 0)',
                visibility: 'hidden'
              })),
              // Transition to `inherit`, rather than `visible`,
              // because visibility on a child element the one from the parent,
              // making this element focusable inside of a `hidden` element.
              state('current', style({
                transform: 'none',
                visibility: 'inherit'
              })), state('next', style({
                transform: 'translate3d(100%, 0, 0)',
                visibility: 'hidden'
              })), transition('* => *', animate('{{animationDuration}} cubic-bezier(0.35, 0, 0.25, 1)'), {
                params: {
                  'animationDuration': DEFAULT_HORIZONTAL_ANIMATION_DURATION
                }
              })]),
              /** Animation that transitions the step along the Y axis in a vertical stepper. */
              verticalStepTransition: trigger('verticalStepTransition', [state('previous', style({
                height: '0px',
                visibility: 'hidden'
              })), state('next', style({
                height: '0px',
                visibility: 'hidden'
              })),
              // Transition to `inherit`, rather than `visible`,
              // because visibility on a child element the one from the parent,
              // making this element focusable inside of a `hidden` element.
              state('current', style({
                height: '*',
                visibility: 'inherit'
              })), transition('* <=> current', animate('{{animationDuration}} cubic-bezier(0.4, 0.0, 0.2, 1)'), {
                params: {
                  'animationDuration': DEFAULT_VERTICAL_ANIMATION_DURATION
                }
              })])
            });

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Template to be used to override the icons inside the step header.
             */
            class MatStepperIcon {
              constructor(templateRef) {
                this.templateRef = templateRef;
              }
            } exports('MatStepperIcon', MatStepperIcon);
            MatStepperIcon.ɵfac = function MatStepperIcon_Factory(t) {
              return new (t || MatStepperIcon)(i0.ɵɵdirectiveInject(i0.TemplateRef));
            };
            MatStepperIcon.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatStepperIcon,
              selectors: [["ng-template", "matStepperIcon", ""]],
              inputs: {
                name: ["matStepperIcon", "name"]
              }
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStepperIcon, [{
                type: Directive,
                args: [{
                  selector: 'ng-template[matStepperIcon]'
                }]
              }], function () {
                return [{
                  type: i0.TemplateRef
                }];
              }, {
                name: [{
                  type: Input,
                  args: ['matStepperIcon']
                }]
              });
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Content for a `mat-step` that will be rendered lazily.
             */
            class MatStepContent {
              constructor(_template) {
                this._template = _template;
              }
            } exports('MatStepContent', MatStepContent);
            MatStepContent.ɵfac = function MatStepContent_Factory(t) {
              return new (t || MatStepContent)(i0.ɵɵdirectiveInject(i0.TemplateRef));
            };
            MatStepContent.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatStepContent,
              selectors: [["ng-template", "matStepContent", ""]]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStepContent, [{
                type: Directive,
                args: [{
                  selector: 'ng-template[matStepContent]'
                }]
              }], function () {
                return [{
                  type: i0.TemplateRef
                }];
              }, null);
            })();
            class MatStep extends CdkStep {
              constructor(stepper, _errorStateMatcher, _viewContainerRef, stepperOptions) {
                super(stepper, stepperOptions);
                this._errorStateMatcher = _errorStateMatcher;
                this._viewContainerRef = _viewContainerRef;
                this._isSelected = Subscription.EMPTY;
              }
              ngAfterContentInit() {
                this._isSelected = this._stepper.steps.changes.pipe(switchMap(() => {
                  return this._stepper.selectionChange.pipe(map(event => event.selectedStep === this), startWith(this._stepper.selected === this));
                })).subscribe(isSelected => {
                  if (isSelected && this._lazyContent && !this._portal) {
                    this._portal = new TemplatePortal(this._lazyContent._template, this._viewContainerRef);
                  }
                });
              }
              ngOnDestroy() {
                this._isSelected.unsubscribe();
              }
              /** Custom error state matcher that additionally checks for validity of interacted form. */
              isErrorState(control, form) {
                const originalErrorState = this._errorStateMatcher.isErrorState(control, form);
                // Custom error state checks for the validity of form that is not submitted or touched
                // since user can trigger a form change by calling for another step without directly
                // interacting with the current form.
                const customErrorState = !!(control && control.invalid && this.interacted);
                return originalErrorState || customErrorState;
              }
            } exports('MatStep', MatStep);
            MatStep.ɵfac = function MatStep_Factory(t) {
              return new (t || MatStep)(i0.ɵɵdirectiveInject(forwardRef(() => MatStepper)), i0.ɵɵdirectiveInject(i1.ErrorStateMatcher, 4), i0.ɵɵdirectiveInject(i0.ViewContainerRef), i0.ɵɵdirectiveInject(STEPPER_GLOBAL_OPTIONS, 8));
            };
            MatStep.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatStep,
              selectors: [["mat-step"]],
              contentQueries: function MatStep_ContentQueries(rf, ctx, dirIndex) {
                if (rf & 1) {
                  i0.ɵɵcontentQuery(dirIndex, MatStepLabel, 5);
                  i0.ɵɵcontentQuery(dirIndex, MatStepContent, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.stepLabel = _t.first);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._lazyContent = _t.first);
                }
              },
              inputs: {
                color: "color"
              },
              exportAs: ["matStep"],
              features: [i0.ɵɵProvidersFeature([{
                provide: ErrorStateMatcher,
                useExisting: MatStep
              }, {
                provide: CdkStep,
                useExisting: MatStep
              }]), i0.ɵɵInheritDefinitionFeature],
              ngContentSelectors: _c0,
              decls: 1,
              vars: 0,
              consts: [[3, "cdkPortalOutlet"]],
              template: function MatStep_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵprojectionDef();
                  i0.ɵɵtemplate(0, MatStep_ng_template_0_Template, 2, 1, "ng-template");
                }
              },
              dependencies: [i2$1.CdkPortalOutlet],
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStep, [{
                type: Component,
                args: [{
                  selector: 'mat-step',
                  providers: [{
                    provide: ErrorStateMatcher,
                    useExisting: MatStep
                  }, {
                    provide: CdkStep,
                    useExisting: MatStep
                  }],
                  encapsulation: ViewEncapsulation.None,
                  exportAs: 'matStep',
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  template: "<ng-template>\n  <ng-content></ng-content>\n  <ng-template [cdkPortalOutlet]=\"_portal\"></ng-template>\n</ng-template>\n"
                }]
              }], function () {
                return [{
                  type: MatStepper,
                  decorators: [{
                    type: Inject,
                    args: [forwardRef(() => MatStepper)]
                  }]
                }, {
                  type: i1.ErrorStateMatcher,
                  decorators: [{
                    type: SkipSelf
                  }]
                }, {
                  type: i0.ViewContainerRef
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [STEPPER_GLOBAL_OPTIONS]
                  }]
                }];
              }, {
                stepLabel: [{
                  type: ContentChild,
                  args: [MatStepLabel]
                }],
                color: [{
                  type: Input
                }],
                _lazyContent: [{
                  type: ContentChild,
                  args: [MatStepContent, {
                    static: false
                  }]
                }]
              });
            })();
            class MatStepper extends CdkStepper {
              /** Duration for the animation. Will be normalized to milliseconds if no units are set. */
              get animationDuration() {
                return this._animationDuration;
              }
              set animationDuration(value) {
                this._animationDuration = /^\d+$/.test(value) ? value + 'ms' : value;
              }
              constructor(dir, changeDetectorRef, elementRef) {
                super(dir, changeDetectorRef, elementRef);
                /** Steps that belong to the current stepper, excluding ones from nested steppers. */
                this.steps = new QueryList();
                /** Event emitted when the current step is done transitioning in. */
                this.animationDone = new EventEmitter();
                /**
                 * Whether the label should display in bottom or end position.
                 * Only applies in the `horizontal` orientation.
                 */
                this.labelPosition = 'end';
                /**
                 * Position of the stepper's header.
                 * Only applies in the `horizontal` orientation.
                 */
                this.headerPosition = 'top';
                /** Consumer-specified template-refs to be used to override the header icons. */
                this._iconOverrides = {};
                /** Stream of animation `done` events when the body expands/collapses. */
                this._animationDone = new Subject();
                this._animationDuration = '';
                const nodeName = elementRef.nativeElement.nodeName.toLowerCase();
                this.orientation = nodeName === 'mat-vertical-stepper' ? 'vertical' : 'horizontal';
              }
              ngAfterContentInit() {
                super.ngAfterContentInit();
                this._icons.forEach(({
                  name,
                  templateRef
                }) => this._iconOverrides[name] = templateRef);
                // Mark the component for change detection whenever the content children query changes
                this.steps.changes.pipe(takeUntil(this._destroyed)).subscribe(() => {
                  this._stateChanged();
                });
                this._animationDone.pipe(
                // This needs a `distinctUntilChanged` in order to avoid emitting the same event twice due
                // to a bug in animations where the `.done` callback gets invoked twice on some browsers.
                // See https://github.com/angular/angular/issues/24084
                distinctUntilChanged((x, y) => x.fromState === y.fromState && x.toState === y.toState), takeUntil(this._destroyed)).subscribe(event => {
                  if (event.toState === 'current') {
                    this.animationDone.emit();
                  }
                });
              }
              _stepIsNavigable(index, step) {
                return step.completed || this.selectedIndex === index || !this.linear;
              }
              _getAnimationDuration() {
                if (this.animationDuration) {
                  return this.animationDuration;
                }
                return this.orientation === 'horizontal' ? DEFAULT_HORIZONTAL_ANIMATION_DURATION : DEFAULT_VERTICAL_ANIMATION_DURATION;
              }
            } exports('MatStepper', MatStepper);
            MatStepper.ɵfac = function MatStepper_Factory(t) {
              return new (t || MatStepper)(i0.ɵɵdirectiveInject(i3$1.Directionality, 8), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i0.ElementRef));
            };
            MatStepper.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatStepper,
              selectors: [["mat-stepper"], ["mat-vertical-stepper"], ["mat-horizontal-stepper"], ["", "matStepper", ""]],
              contentQueries: function MatStepper_ContentQueries(rf, ctx, dirIndex) {
                if (rf & 1) {
                  i0.ɵɵcontentQuery(dirIndex, MatStep, 5);
                  i0.ɵɵcontentQuery(dirIndex, MatStepperIcon, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._steps = _t);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._icons = _t);
                }
              },
              viewQuery: function MatStepper_Query(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵviewQuery(MatStepHeader, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._stepHeader = _t);
                }
              },
              hostAttrs: ["role", "tablist"],
              hostVars: 11,
              hostBindings: function MatStepper_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵattribute("aria-orientation", ctx.orientation);
                  i0.ɵɵclassProp("mat-stepper-horizontal", ctx.orientation === "horizontal")("mat-stepper-vertical", ctx.orientation === "vertical")("mat-stepper-label-position-end", ctx.orientation === "horizontal" && ctx.labelPosition == "end")("mat-stepper-label-position-bottom", ctx.orientation === "horizontal" && ctx.labelPosition == "bottom")("mat-stepper-header-position-bottom", ctx.headerPosition === "bottom");
                }
              },
              inputs: {
                selectedIndex: "selectedIndex",
                disableRipple: "disableRipple",
                color: "color",
                labelPosition: "labelPosition",
                headerPosition: "headerPosition",
                animationDuration: "animationDuration"
              },
              outputs: {
                animationDone: "animationDone"
              },
              exportAs: ["matStepper", "matVerticalStepper", "matHorizontalStepper"],
              features: [i0.ɵɵProvidersFeature([{
                provide: CdkStepper,
                useExisting: MatStepper
              }]), i0.ɵɵInheritDefinitionFeature],
              decls: 5,
              vars: 3,
              consts: [[3, "ngSwitch"], ["class", "mat-horizontal-stepper-wrapper", 4, "ngSwitchCase"], [4, "ngSwitchCase"], ["stepTemplate", ""], [1, "mat-horizontal-stepper-wrapper"], [1, "mat-horizontal-stepper-header-container"], [4, "ngFor", "ngForOf"], [1, "mat-horizontal-content-container"], ["class", "mat-horizontal-stepper-content", "role", "tabpanel", 3, "id", "mat-horizontal-stepper-content-inactive", 4, "ngFor", "ngForOf"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"], ["class", "mat-stepper-horizontal-line", 4, "ngIf"], [1, "mat-stepper-horizontal-line"], ["role", "tabpanel", 1, "mat-horizontal-stepper-content", 3, "id"], [3, "ngTemplateOutlet"], ["class", "mat-step", 4, "ngFor", "ngForOf"], [1, "mat-step"], [1, "mat-vertical-content-container"], ["role", "tabpanel", 1, "mat-vertical-stepper-content", 3, "id"], [1, "mat-vertical-content"], [3, "tabIndex", "id", "index", "state", "label", "selected", "active", "optional", "errorMessage", "iconOverrides", "disableRipple", "color", "click", "keydown"]],
              template: function MatStepper_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵelementContainerStart(0, 0);
                  i0.ɵɵtemplate(1, MatStepper_div_1_Template, 5, 2, "div", 1);
                  i0.ɵɵtemplate(2, MatStepper_ng_container_2_Template, 2, 1, "ng-container", 2);
                  i0.ɵɵelementContainerEnd();
                  i0.ɵɵtemplate(3, MatStepper_ng_template_3_Template, 1, 23, "ng-template", null, 3, i0.ɵɵtemplateRefExtractor);
                }
                if (rf & 2) {
                  i0.ɵɵproperty("ngSwitch", ctx.orientation);
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngSwitchCase", "horizontal");
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngSwitchCase", "vertical");
                }
              },
              dependencies: [i3.NgForOf, i3.NgIf, i3.NgTemplateOutlet, i3.NgSwitch, i3.NgSwitchCase, MatStepHeader],
              styles: [".mat-stepper-vertical,.mat-stepper-horizontal{display:block}.mat-horizontal-stepper-header-container{white-space:nowrap;display:flex;align-items:center}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header-container{align-items:flex-start}.mat-stepper-header-position-bottom .mat-horizontal-stepper-header-container{order:1}.mat-stepper-horizontal-line{border-top-width:1px;border-top-style:solid;flex:auto;height:0;margin:0 -16px;min-width:32px}.mat-stepper-label-position-bottom .mat-stepper-horizontal-line{margin:0;min-width:0;position:relative}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child)::before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child)::before,.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child)::after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child)::after{border-top-width:1px;border-top-style:solid;content:\"\";display:inline-block;height:0;position:absolute;width:calc(50% - 20px)}.mat-horizontal-stepper-header{display:flex;height:72px;overflow:hidden;align-items:center;padding:0 24px}.mat-horizontal-stepper-header .mat-step-icon{margin-right:8px;flex:none}[dir=rtl] .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:8px}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header{box-sizing:border-box;flex-direction:column;height:auto}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child)::after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child)::after{right:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child)::before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child)::before{left:0}[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:last-child::before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:first-child::after{display:none}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-label{padding:16px 0 0 0;text-align:center;width:100%}.mat-vertical-stepper-header{display:flex;align-items:center;height:24px}.mat-vertical-stepper-header .mat-step-icon{margin-right:12px}[dir=rtl] .mat-vertical-stepper-header .mat-step-icon{margin-right:0;margin-left:12px}.mat-horizontal-stepper-wrapper{display:flex;flex-direction:column}.mat-horizontal-stepper-content{outline:0}.mat-horizontal-stepper-content.mat-horizontal-stepper-content-inactive{height:0;overflow:hidden}.mat-horizontal-stepper-content:not(.mat-horizontal-stepper-content-inactive){visibility:inherit !important}.mat-horizontal-content-container{overflow:hidden;padding:0 24px 24px 24px}.cdk-high-contrast-active .mat-horizontal-content-container{outline:solid 1px}.mat-stepper-header-position-bottom .mat-horizontal-content-container{padding:24px 24px 0 24px}.mat-vertical-content-container{margin-left:36px;border:0;position:relative}.cdk-high-contrast-active .mat-vertical-content-container{outline:solid 1px}[dir=rtl] .mat-vertical-content-container{margin-left:0;margin-right:36px}.mat-stepper-vertical-line::before{content:\"\";position:absolute;left:0;border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-stepper-vertical-line::before{left:auto;right:0}.mat-vertical-stepper-content{overflow:hidden;outline:0}.mat-vertical-stepper-content:not(.mat-vertical-stepper-content-inactive){visibility:inherit !important}.mat-vertical-content{padding:0 24px 24px 24px}.mat-step:last-child .mat-vertical-content-container{border:none}"],
              encapsulation: 2,
              data: {
                animation: [matStepperAnimations.horizontalStepTransition, matStepperAnimations.verticalStepTransition]
              },
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStepper, [{
                type: Component,
                args: [{
                  selector: 'mat-stepper, mat-vertical-stepper, mat-horizontal-stepper, [matStepper]',
                  exportAs: 'matStepper, matVerticalStepper, matHorizontalStepper',
                  inputs: ['selectedIndex'],
                  host: {
                    '[class.mat-stepper-horizontal]': 'orientation === "horizontal"',
                    '[class.mat-stepper-vertical]': 'orientation === "vertical"',
                    '[class.mat-stepper-label-position-end]': 'orientation === "horizontal" && labelPosition == "end"',
                    '[class.mat-stepper-label-position-bottom]': 'orientation === "horizontal" && labelPosition == "bottom"',
                    '[class.mat-stepper-header-position-bottom]': 'headerPosition === "bottom"',
                    '[attr.aria-orientation]': 'orientation',
                    'role': 'tablist'
                  },
                  animations: [matStepperAnimations.horizontalStepTransition, matStepperAnimations.verticalStepTransition],
                  providers: [{
                    provide: CdkStepper,
                    useExisting: MatStepper
                  }],
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  template: "<ng-container [ngSwitch]=\"orientation\">\n  <!-- Horizontal stepper -->\n  <div class=\"mat-horizontal-stepper-wrapper\" *ngSwitchCase=\"'horizontal'\">\n    <div class=\"mat-horizontal-stepper-header-container\">\n      <ng-container *ngFor=\"let step of steps; let i = index; let isLast = last\">\n        <ng-container\n          [ngTemplateOutlet]=\"stepTemplate\"\n          [ngTemplateOutletContext]=\"{step: step, i: i}\"></ng-container>\n        <div *ngIf=\"!isLast\" class=\"mat-stepper-horizontal-line\"></div>\n      </ng-container>\n    </div>\n\n    <div class=\"mat-horizontal-content-container\">\n      <div *ngFor=\"let step of steps; let i = index\"\n           class=\"mat-horizontal-stepper-content\" role=\"tabpanel\"\n           [@horizontalStepTransition]=\"{\n              'value': _getAnimationDirection(i),\n              'params': {'animationDuration': _getAnimationDuration()}\n            }\"\n           (@horizontalStepTransition.done)=\"_animationDone.next($event)\"\n           [id]=\"_getStepContentId(i)\"\n           [attr.aria-labelledby]=\"_getStepLabelId(i)\"\n           [class.mat-horizontal-stepper-content-inactive]=\"selectedIndex !== i\">\n        <ng-container [ngTemplateOutlet]=\"step.content\"></ng-container>\n      </div>\n    </div>\n  </div>\n\n  <!-- Vertical stepper -->\n  <ng-container *ngSwitchCase=\"'vertical'\">\n    <div class=\"mat-step\" *ngFor=\"let step of steps; let i = index; let isLast = last\">\n      <ng-container\n        [ngTemplateOutlet]=\"stepTemplate\"\n        [ngTemplateOutletContext]=\"{step: step, i: i}\"></ng-container>\n      <div class=\"mat-vertical-content-container\" [class.mat-stepper-vertical-line]=\"!isLast\">\n        <div class=\"mat-vertical-stepper-content\" role=\"tabpanel\"\n             [@verticalStepTransition]=\"{\n                'value': _getAnimationDirection(i),\n                'params': {'animationDuration': _getAnimationDuration()}\n              }\"\n             (@verticalStepTransition.done)=\"_animationDone.next($event)\"\n             [id]=\"_getStepContentId(i)\"\n             [attr.aria-labelledby]=\"_getStepLabelId(i)\"\n             [class.mat-vertical-stepper-content-inactive]=\"selectedIndex !== i\">\n          <div class=\"mat-vertical-content\">\n            <ng-container [ngTemplateOutlet]=\"step.content\"></ng-container>\n          </div>\n        </div>\n      </div>\n    </div>\n  </ng-container>\n\n</ng-container>\n\n<!-- Common step templating -->\n<ng-template let-step=\"step\" let-i=\"i\" #stepTemplate>\n  <mat-step-header\n    [class.mat-horizontal-stepper-header]=\"orientation === 'horizontal'\"\n    [class.mat-vertical-stepper-header]=\"orientation === 'vertical'\"\n    (click)=\"step.select()\"\n    (keydown)=\"_onKeydown($event)\"\n    [tabIndex]=\"_getFocusIndex() === i ? 0 : -1\"\n    [id]=\"_getStepLabelId(i)\"\n    [attr.aria-posinset]=\"i + 1\"\n    [attr.aria-setsize]=\"steps.length\"\n    [attr.aria-controls]=\"_getStepContentId(i)\"\n    [attr.aria-selected]=\"selectedIndex == i\"\n    [attr.aria-label]=\"step.ariaLabel || null\"\n    [attr.aria-labelledby]=\"(!step.ariaLabel && step.ariaLabelledby) ? step.ariaLabelledby : null\"\n    [attr.aria-disabled]=\"_stepIsNavigable(i, step) ? null : true\"\n    [index]=\"i\"\n    [state]=\"_getIndicatorType(i, step.state)\"\n    [label]=\"step.stepLabel || step.label\"\n    [selected]=\"selectedIndex === i\"\n    [active]=\"_stepIsNavigable(i, step)\"\n    [optional]=\"step.optional\"\n    [errorMessage]=\"step.errorMessage\"\n    [iconOverrides]=\"_iconOverrides\"\n    [disableRipple]=\"disableRipple || !_stepIsNavigable(i, step)\"\n    [color]=\"step.color || color\"></mat-step-header>\n</ng-template>\n",
                  styles: [".mat-stepper-vertical,.mat-stepper-horizontal{display:block}.mat-horizontal-stepper-header-container{white-space:nowrap;display:flex;align-items:center}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header-container{align-items:flex-start}.mat-stepper-header-position-bottom .mat-horizontal-stepper-header-container{order:1}.mat-stepper-horizontal-line{border-top-width:1px;border-top-style:solid;flex:auto;height:0;margin:0 -16px;min-width:32px}.mat-stepper-label-position-bottom .mat-stepper-horizontal-line{margin:0;min-width:0;position:relative}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child)::before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child)::before,.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child)::after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child)::after{border-top-width:1px;border-top-style:solid;content:\"\";display:inline-block;height:0;position:absolute;width:calc(50% - 20px)}.mat-horizontal-stepper-header{display:flex;height:72px;overflow:hidden;align-items:center;padding:0 24px}.mat-horizontal-stepper-header .mat-step-icon{margin-right:8px;flex:none}[dir=rtl] .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:8px}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header{box-sizing:border-box;flex-direction:column;height:auto}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child)::after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child)::after{right:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child)::before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child)::before{left:0}[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:last-child::before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:first-child::after{display:none}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-label{padding:16px 0 0 0;text-align:center;width:100%}.mat-vertical-stepper-header{display:flex;align-items:center;height:24px}.mat-vertical-stepper-header .mat-step-icon{margin-right:12px}[dir=rtl] .mat-vertical-stepper-header .mat-step-icon{margin-right:0;margin-left:12px}.mat-horizontal-stepper-wrapper{display:flex;flex-direction:column}.mat-horizontal-stepper-content{outline:0}.mat-horizontal-stepper-content.mat-horizontal-stepper-content-inactive{height:0;overflow:hidden}.mat-horizontal-stepper-content:not(.mat-horizontal-stepper-content-inactive){visibility:inherit !important}.mat-horizontal-content-container{overflow:hidden;padding:0 24px 24px 24px}.cdk-high-contrast-active .mat-horizontal-content-container{outline:solid 1px}.mat-stepper-header-position-bottom .mat-horizontal-content-container{padding:24px 24px 0 24px}.mat-vertical-content-container{margin-left:36px;border:0;position:relative}.cdk-high-contrast-active .mat-vertical-content-container{outline:solid 1px}[dir=rtl] .mat-vertical-content-container{margin-left:0;margin-right:36px}.mat-stepper-vertical-line::before{content:\"\";position:absolute;left:0;border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-stepper-vertical-line::before{left:auto;right:0}.mat-vertical-stepper-content{overflow:hidden;outline:0}.mat-vertical-stepper-content:not(.mat-vertical-stepper-content-inactive){visibility:inherit !important}.mat-vertical-content{padding:0 24px 24px 24px}.mat-step:last-child .mat-vertical-content-container{border:none}"]
                }]
              }], function () {
                return [{
                  type: i3$1.Directionality,
                  decorators: [{
                    type: Optional
                  }]
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: i0.ElementRef
                }];
              }, {
                _stepHeader: [{
                  type: ViewChildren,
                  args: [MatStepHeader]
                }],
                _steps: [{
                  type: ContentChildren,
                  args: [MatStep, {
                    descendants: true
                  }]
                }],
                _icons: [{
                  type: ContentChildren,
                  args: [MatStepperIcon, {
                    descendants: true
                  }]
                }],
                animationDone: [{
                  type: Output
                }],
                disableRipple: [{
                  type: Input
                }],
                color: [{
                  type: Input
                }],
                labelPosition: [{
                  type: Input
                }],
                headerPosition: [{
                  type: Input
                }],
                animationDuration: [{
                  type: Input
                }]
              });
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /** Button that moves to the next step in a stepper workflow. */
            class MatStepperNext extends CdkStepperNext {} exports('MatStepperNext', MatStepperNext);
            MatStepperNext.ɵfac = /* @__PURE__ */function () {
              let ɵMatStepperNext_BaseFactory;
              return function MatStepperNext_Factory(t) {
                return (ɵMatStepperNext_BaseFactory || (ɵMatStepperNext_BaseFactory = i0.ɵɵgetInheritedFactory(MatStepperNext)))(t || MatStepperNext);
              };
            }();
            MatStepperNext.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatStepperNext,
              selectors: [["button", "matStepperNext", ""]],
              hostAttrs: [1, "mat-stepper-next"],
              hostVars: 1,
              hostBindings: function MatStepperNext_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵhostProperty("type", ctx.type);
                }
              },
              inputs: {
                type: "type"
              },
              features: [i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStepperNext, [{
                type: Directive,
                args: [{
                  selector: 'button[matStepperNext]',
                  host: {
                    'class': 'mat-stepper-next',
                    '[type]': 'type'
                  },
                  inputs: ['type']
                }]
              }], null, null);
            })();
            /** Button that moves to the previous step in a stepper workflow. */
            class MatStepperPrevious extends CdkStepperPrevious {} exports('MatStepperPrevious', MatStepperPrevious);
            MatStepperPrevious.ɵfac = /* @__PURE__ */function () {
              let ɵMatStepperPrevious_BaseFactory;
              return function MatStepperPrevious_Factory(t) {
                return (ɵMatStepperPrevious_BaseFactory || (ɵMatStepperPrevious_BaseFactory = i0.ɵɵgetInheritedFactory(MatStepperPrevious)))(t || MatStepperPrevious);
              };
            }();
            MatStepperPrevious.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatStepperPrevious,
              selectors: [["button", "matStepperPrevious", ""]],
              hostAttrs: [1, "mat-stepper-previous"],
              hostVars: 1,
              hostBindings: function MatStepperPrevious_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵhostProperty("type", ctx.type);
                }
              },
              inputs: {
                type: "type"
              },
              features: [i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStepperPrevious, [{
                type: Directive,
                args: [{
                  selector: 'button[matStepperPrevious]',
                  host: {
                    'class': 'mat-stepper-previous',
                    '[type]': 'type'
                  },
                  inputs: ['type']
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            class MatStepperModule {} exports('MatStepperModule', MatStepperModule);
            MatStepperModule.ɵfac = function MatStepperModule_Factory(t) {
              return new (t || MatStepperModule)();
            };
            MatStepperModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatStepperModule
            });
            MatStepperModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              providers: [MAT_STEPPER_INTL_PROVIDER, ErrorStateMatcher],
              imports: [MatCommonModule, CommonModule, PortalModule, CdkStepperModule, MatIconModule, MatRippleModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatStepperModule, [{
                type: NgModule,
                args: [{
                  imports: [MatCommonModule, CommonModule, PortalModule, CdkStepperModule, MatIconModule, MatRippleModule],
                  exports: [MatCommonModule, MatStep, MatStepLabel, MatStepper, MatStepperNext, MatStepperPrevious, MatStepHeader, MatStepperIcon, MatStepContent],
                  declarations: [MatStep, MatStepLabel, MatStepper, MatStepperNext, MatStepperPrevious, MatStepHeader, MatStepperIcon, MatStepContent],
                  providers: [MAT_STEPPER_INTL_PROVIDER, ErrorStateMatcher]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-stepper.js.map
