/* esm-bundle - @angular/material/legacy-form-field@15.2.9 - Ivy - system format - es2020 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/cdk/observers', '@angular/common', '@angular/core', '@angular/material/core', '@angular/material/form-field', '@angular/cdk/bidi', '@angular/cdk/coercion', 'rxjs', 'rxjs/operators', '@angular/cdk/platform', '@angular/platform-browser/animations'], (function (exports) {
    'use strict';
    var i4, ObserversModule, i3, CommonModule, i0, Directive, Attribute, Input, InjectionToken, Component, ViewEncapsulation, ChangeDetectionStrategy, Optional, Inject, ViewChild, ContentChild, ContentChildren, NgModule, mixinColor, MatCommonModule, MAT_ERROR, MatFormFieldControl, MAT_PREFIX, MAT_SUFFIX, MAT_FORM_FIELD, matFormFieldAnimations, getMatFormFieldPlaceholderConflictError, getMatFormFieldDuplicatedHintError, getMatFormFieldMissingControlError, i1, coerceBooleanProperty, Subject, merge, fromEvent, startWith, takeUntil, take, i2, ANIMATION_MODULE_TYPE;
    return {
        setters: [function (module) {
            i4 = module;
            ObserversModule = module.ObserversModule;
        }, function (module) {
            i3 = module;
            CommonModule = module.CommonModule;
        }, function (module) {
            i0 = module;
            Directive = module.Directive;
            Attribute = module.Attribute;
            Input = module.Input;
            InjectionToken = module.InjectionToken;
            Component = module.Component;
            ViewEncapsulation = module.ViewEncapsulation;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            Optional = module.Optional;
            Inject = module.Inject;
            ViewChild = module.ViewChild;
            ContentChild = module.ContentChild;
            ContentChildren = module.ContentChildren;
            NgModule = module.NgModule;
        }, function (module) {
            mixinColor = module.mixinColor;
            MatCommonModule = module.MatCommonModule;
        }, function (module) {
            MAT_ERROR = module.MAT_ERROR;
            MatFormFieldControl = module.MatFormFieldControl;
            MAT_PREFIX = module.MAT_PREFIX;
            MAT_SUFFIX = module.MAT_SUFFIX;
            MAT_FORM_FIELD = module.MAT_FORM_FIELD;
            matFormFieldAnimations = module.matFormFieldAnimations;
            getMatFormFieldPlaceholderConflictError = module.getMatFormFieldPlaceholderConflictError;
            getMatFormFieldDuplicatedHintError = module.getMatFormFieldDuplicatedHintError;
            getMatFormFieldMissingControlError = module.getMatFormFieldMissingControlError;
            exports({ MAT_LEGACY_ERROR: module.MAT_ERROR, MAT_LEGACY_FORM_FIELD: module.MAT_FORM_FIELD, MAT_LEGACY_PREFIX: module.MAT_PREFIX, MAT_LEGACY_SUFFIX: module.MAT_SUFFIX, MatLegacyFormFieldControl: module.MatFormFieldControl, getMatLegacyFormFieldDuplicatedHintError: module.getMatFormFieldDuplicatedHintError, getMatLegacyFormFieldMissingControlError: module.getMatFormFieldMissingControlError, getMatLegacyFormFieldPlaceholderConflictError: module.getMatFormFieldPlaceholderConflictError, matLegacyFormFieldAnimations: module.matFormFieldAnimations });
        }, function (module) {
            i1 = module;
        }, function (module) {
            coerceBooleanProperty = module.coerceBooleanProperty;
        }, function (module) {
            Subject = module.Subject;
            merge = module.merge;
            fromEvent = module.fromEvent;
        }, function (module) {
            startWith = module.startWith;
            takeUntil = module.takeUntil;
            take = module.take;
        }, function (module) {
            i2 = module;
        }, function (module) {
            ANIMATION_MODULE_TYPE = module.ANIMATION_MODULE_TYPE;
        }],
        execute: (function () {

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            const _c0 = ["connectionContainer"];
            const _c1 = ["inputContainer"];
            const _c2 = ["label"];
            function MatLegacyFormField_ng_container_3_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementContainerStart(0);
                i0.ɵɵelementStart(1, "div", 14);
                i0.ɵɵelement(2, "div", 15)(3, "div", 16)(4, "div", 17);
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(5, "div", 18);
                i0.ɵɵelement(6, "div", 15)(7, "div", 16)(8, "div", 17);
                i0.ɵɵelementEnd();
                i0.ɵɵelementContainerEnd();
              }
            }
            function MatLegacyFormField_div_4_Template(rf, ctx) {
              if (rf & 1) {
                const _r10 = i0.ɵɵgetCurrentView();
                i0.ɵɵelementStart(0, "div", 19);
                i0.ɵɵlistener("cdkObserveContent", function MatLegacyFormField_div_4_Template_div_cdkObserveContent_0_listener() {
                  i0.ɵɵrestoreView(_r10);
                  const ctx_r9 = i0.ɵɵnextContext();
                  return i0.ɵɵresetView(ctx_r9.updateOutlineGap());
                });
                i0.ɵɵprojection(1, 1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r2 = i0.ɵɵnextContext();
                i0.ɵɵproperty("cdkObserveContentDisabled", ctx_r2.appearance != "outline");
              }
            }
            function MatLegacyFormField_label_9_ng_container_2_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementContainerStart(0);
                i0.ɵɵprojection(1, 2);
                i0.ɵɵelementStart(2, "span");
                i0.ɵɵtext(3);
                i0.ɵɵelementEnd();
                i0.ɵɵelementContainerEnd();
              }
              if (rf & 2) {
                const ctx_r12 = i0.ɵɵnextContext(2);
                i0.ɵɵadvance(3);
                i0.ɵɵtextInterpolate(ctx_r12._control.placeholder);
              }
            }
            function MatLegacyFormField_label_9_ng_content_3_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵprojection(0, 3, ["*ngSwitchCase", "true"]);
              }
            }
            function MatLegacyFormField_label_9_span_4_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "span", 23);
                i0.ɵɵtext(1, " *");
                i0.ɵɵelementEnd();
              }
            }
            function MatLegacyFormField_label_9_Template(rf, ctx) {
              if (rf & 1) {
                const _r16 = i0.ɵɵgetCurrentView();
                i0.ɵɵelementStart(0, "label", 20, 21);
                i0.ɵɵlistener("cdkObserveContent", function MatLegacyFormField_label_9_Template_label_cdkObserveContent_0_listener() {
                  i0.ɵɵrestoreView(_r16);
                  const ctx_r15 = i0.ɵɵnextContext();
                  return i0.ɵɵresetView(ctx_r15.updateOutlineGap());
                });
                i0.ɵɵtemplate(2, MatLegacyFormField_label_9_ng_container_2_Template, 4, 1, "ng-container", 12);
                i0.ɵɵtemplate(3, MatLegacyFormField_label_9_ng_content_3_Template, 1, 0, "ng-content", 12);
                i0.ɵɵtemplate(4, MatLegacyFormField_label_9_span_4_Template, 2, 0, "span", 22);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r4 = i0.ɵɵnextContext();
                i0.ɵɵclassProp("mat-empty", ctx_r4._control.empty && !ctx_r4._shouldAlwaysFloat())("mat-form-field-empty", ctx_r4._control.empty && !ctx_r4._shouldAlwaysFloat())("mat-accent", ctx_r4.color == "accent")("mat-warn", ctx_r4.color == "warn");
                i0.ɵɵproperty("cdkObserveContentDisabled", ctx_r4.appearance != "outline")("id", ctx_r4._labelId)("ngSwitch", ctx_r4._hasLabel());
                i0.ɵɵattribute("for", ctx_r4._control.id)("aria-owns", ctx_r4._control.id);
                i0.ɵɵadvance(2);
                i0.ɵɵproperty("ngSwitchCase", false);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngSwitchCase", true);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngIf", !ctx_r4.hideRequiredMarker && ctx_r4._control.required && !ctx_r4._control.disabled);
              }
            }
            function MatLegacyFormField_div_10_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 24);
                i0.ɵɵprojection(1, 4);
                i0.ɵɵelementEnd();
              }
            }
            function MatLegacyFormField_div_11_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 25);
                i0.ɵɵelement(1, "span", 26);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r6 = i0.ɵɵnextContext();
                i0.ɵɵadvance(1);
                i0.ɵɵclassProp("mat-accent", ctx_r6.color == "accent")("mat-warn", ctx_r6.color == "warn");
              }
            }
            function MatLegacyFormField_div_13_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div");
                i0.ɵɵprojection(1, 5);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r7 = i0.ɵɵnextContext();
                i0.ɵɵproperty("@transitionMessages", ctx_r7._subscriptAnimationState);
              }
            }
            function MatLegacyFormField_div_14_div_1_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 30);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r17 = i0.ɵɵnextContext(2);
                i0.ɵɵproperty("id", ctx_r17._hintLabelId);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r17.hintLabel);
              }
            }
            function MatLegacyFormField_div_14_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 27);
                i0.ɵɵtemplate(1, MatLegacyFormField_div_14_div_1_Template, 2, 2, "div", 28);
                i0.ɵɵprojection(2, 6);
                i0.ɵɵelement(3, "div", 29);
                i0.ɵɵprojection(4, 7);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r8 = i0.ɵɵnextContext();
                i0.ɵɵproperty("@transitionMessages", ctx_r8._subscriptAnimationState);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngIf", ctx_r8.hintLabel);
              }
            }
            const _c3 = ["*", [["", "matPrefix", ""]], [["mat-placeholder"]], [["mat-label"]], [["", "matSuffix", ""]], [["mat-error"]], [["mat-hint", 3, "align", "end"]], [["mat-hint", "align", "end"]]];
            const _c4 = ["*", "[matPrefix]", "mat-placeholder", "mat-label", "[matSuffix]", "mat-error", "mat-hint:not([align='end'])", "mat-hint[align='end']"];
            let nextUniqueId$2 = 0;
            /**
             * Single error message to be shown underneath the form field.
             * @deprecated Use `MatError` from `@angular/material/form-field` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyError {
              constructor(ariaLive, elementRef) {
                this.id = `mat-error-${nextUniqueId$2++}`;
                // If no aria-live value is set add 'polite' as a default. This is preferred over setting
                // role='alert' so that screen readers do not interrupt the current task to read this aloud.
                if (!ariaLive) {
                  elementRef.nativeElement.setAttribute('aria-live', 'polite');
                }
              }
            } exports('MatLegacyError', MatLegacyError);
            MatLegacyError.ɵfac = function MatLegacyError_Factory(t) {
              return new (t || MatLegacyError)(i0.ɵɵinjectAttribute('aria-live'), i0.ɵɵdirectiveInject(i0.ElementRef));
            };
            MatLegacyError.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyError,
              selectors: [["mat-error"]],
              hostAttrs: ["aria-atomic", "true", 1, "mat-error"],
              hostVars: 1,
              hostBindings: function MatLegacyError_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵattribute("id", ctx.id);
                }
              },
              inputs: {
                id: "id"
              },
              features: [i0.ɵɵProvidersFeature([{
                provide: MAT_ERROR,
                useExisting: MatLegacyError
              }])]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyError, [{
                type: Directive,
                args: [{
                  selector: 'mat-error',
                  host: {
                    'class': 'mat-error',
                    '[attr.id]': 'id',
                    'aria-atomic': 'true'
                  },
                  providers: [{
                    provide: MAT_ERROR,
                    useExisting: MatLegacyError
                  }]
                }]
              }], function () {
                return [{
                  type: undefined,
                  decorators: [{
                    type: Attribute,
                    args: ['aria-live']
                  }]
                }, {
                  type: i0.ElementRef
                }];
              }, {
                id: [{
                  type: Input
                }]
              });
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            let nextUniqueId$1 = 0;
            /**
             * Injection token that can be used to reference instances of `MatHint`. It serves as
             * alternative token to the actual `MatHint` class which could cause unnecessary
             * retention of the class and its directive metadata.
             *
             * *Note*: This is not part of the public API as the MDC-based form-field will not
             * need a lightweight token for `MatHint` and we want to reduce breaking changes.
             *
             * @deprecated Use `_MAT_HINT` from `@angular/material/form-field` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            const _MAT_LEGACY_HINT = exports('_MAT_LEGACY_HINT', new InjectionToken('MatHint'));
            /**
             * Hint text to be shown underneath the form field control.
             * @deprecated Use `MatHint` from `@angular/material/form-field` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyHint {
              constructor() {
                /** Whether to align the hint label at the start or end of the line. */
                this.align = 'start';
                /** Unique ID for the hint. Used for the aria-describedby on the form field control. */
                this.id = `mat-hint-${nextUniqueId$1++}`;
              }
            } exports('MatLegacyHint', MatLegacyHint);
            MatLegacyHint.ɵfac = function MatLegacyHint_Factory(t) {
              return new (t || MatLegacyHint)();
            };
            MatLegacyHint.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyHint,
              selectors: [["mat-hint"]],
              hostAttrs: [1, "mat-hint"],
              hostVars: 4,
              hostBindings: function MatLegacyHint_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵattribute("id", ctx.id)("align", null);
                  i0.ɵɵclassProp("mat-form-field-hint-end", ctx.align === "end");
                }
              },
              inputs: {
                align: "align",
                id: "id"
              },
              features: [i0.ɵɵProvidersFeature([{
                provide: _MAT_LEGACY_HINT,
                useExisting: MatLegacyHint
              }])]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyHint, [{
                type: Directive,
                args: [{
                  selector: 'mat-hint',
                  host: {
                    'class': 'mat-hint',
                    '[class.mat-form-field-hint-end]': 'align === "end"',
                    '[attr.id]': 'id',
                    // Remove align attribute to prevent it from interfering with layout.
                    '[attr.align]': 'null'
                  },
                  providers: [{
                    provide: _MAT_LEGACY_HINT,
                    useExisting: MatLegacyHint
                  }]
                }]
              }], null, {
                align: [{
                  type: Input
                }],
                id: [{
                  type: Input
                }]
              });
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * The floating label for a `mat-form-field`.
             * @deprecated Use `MatLabel` from `@angular/material/form-field` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyLabel {} exports('MatLegacyLabel', MatLegacyLabel);
            MatLegacyLabel.ɵfac = function MatLegacyLabel_Factory(t) {
              return new (t || MatLegacyLabel)();
            };
            MatLegacyLabel.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyLabel,
              selectors: [["mat-label"]]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyLabel, [{
                type: Directive,
                args: [{
                  selector: 'mat-label'
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * The placeholder text for an `MatFormField`.
             * @deprecated Use `<mat-label>` to specify the label and the `placeholder` attribute to specify the
             *     placeholder.
             * @breaking-change 8.0.0
             */
            class MatLegacyPlaceholder {} exports('MatLegacyPlaceholder', MatLegacyPlaceholder);
            MatLegacyPlaceholder.ɵfac = function MatLegacyPlaceholder_Factory(t) {
              return new (t || MatLegacyPlaceholder)();
            };
            MatLegacyPlaceholder.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyPlaceholder,
              selectors: [["mat-placeholder"]]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyPlaceholder, [{
                type: Directive,
                args: [{
                  selector: 'mat-placeholder'
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            let nextUniqueId = 0;
            const floatingLabelScale = 0.75;
            const outlineGapPadding = 5;
            /**
             * Boilerplate for applying mixins to MatFormField.
             * @docs-private
             */
            const _MatFormFieldBase = mixinColor(class {
              constructor(_elementRef) {
                this._elementRef = _elementRef;
              }
            }, 'primary');
            /**
             * Injection token that can be used to configure the
             * default options for all form field within an app.
             * @deprecated Use `MAT_FORM_FIELD_DEFAULT_OPTIONS` from `@angular/material/form-field` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            const MAT_LEGACY_FORM_FIELD_DEFAULT_OPTIONS = exports('MAT_LEGACY_FORM_FIELD_DEFAULT_OPTIONS', new InjectionToken('MAT_FORM_FIELD_DEFAULT_OPTIONS'));
            /**
             * Container for form controls that applies Material Design styling and behavior.
             * @deprecated Use `MatFormField` from `@angular/material/form-field` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyFormField extends _MatFormFieldBase {
              /** The form field appearance style. */
              get appearance() {
                return this._appearance;
              }
              set appearance(value) {
                const oldValue = this._appearance;
                this._appearance = value || this._defaults?.appearance || 'legacy';
                if (this._appearance === 'outline' && oldValue !== value) {
                  this._outlineGapCalculationNeededOnStable = true;
                }
              }
              /** Whether the required marker should be hidden. */
              get hideRequiredMarker() {
                return this._hideRequiredMarker;
              }
              set hideRequiredMarker(value) {
                this._hideRequiredMarker = coerceBooleanProperty(value);
              }
              /** Whether the floating label should always float or not. */
              _shouldAlwaysFloat() {
                return this.floatLabel === 'always' && !this._showAlwaysAnimate;
              }
              /** Whether the label can float or not. */
              _canLabelFloat() {
                return this.floatLabel !== 'never';
              }
              /** Text for the form field hint. */
              get hintLabel() {
                return this._hintLabel;
              }
              set hintLabel(value) {
                this._hintLabel = value;
                this._processHints();
              }
              /**
               * Whether the label should always float, never float or float as the user types.
               *
               * Note: only the legacy appearance supports the `never` option. `never` was originally added as a
               * way to make the floating label emulate the behavior of a standard input placeholder. However
               * the form field now supports both floating labels and placeholders. Therefore in the non-legacy
               * appearances the `never` option has been disabled in favor of just using the placeholder.
               */
              get floatLabel() {
                return this.appearance !== 'legacy' && this._floatLabel === 'never' ? 'auto' : this._floatLabel;
              }
              set floatLabel(value) {
                if (value !== this._floatLabel) {
                  this._floatLabel = value || this._getDefaultFloatLabelState();
                  this._changeDetectorRef.markForCheck();
                }
              }
              get _control() {
                // TODO(crisbeto): we need this workaround in order to support both Ivy and ViewEngine.
                //  We should clean this up once Ivy is the default renderer.
                return this._explicitFormFieldControl || this._controlNonStatic || this._controlStatic;
              }
              set _control(value) {
                this._explicitFormFieldControl = value;
              }
              constructor(elementRef, _changeDetectorRef, _dir, _defaults, _platform, _ngZone, _animationMode) {
                super(elementRef);
                this._changeDetectorRef = _changeDetectorRef;
                this._dir = _dir;
                this._defaults = _defaults;
                this._platform = _platform;
                this._ngZone = _ngZone;
                /**
                 * Whether the outline gap needs to be calculated
                 * immediately on the next change detection run.
                 */
                this._outlineGapCalculationNeededImmediately = false;
                /** Whether the outline gap needs to be calculated next time the zone has stabilized. */
                this._outlineGapCalculationNeededOnStable = false;
                this._destroyed = new Subject();
                this._hideRequiredMarker = false;
                /** Override for the logic that disables the label animation in certain cases. */
                this._showAlwaysAnimate = false;
                /** State of the mat-hint and mat-error animations. */
                this._subscriptAnimationState = '';
                this._hintLabel = '';
                // Unique id for the hint label.
                this._hintLabelId = `mat-hint-${nextUniqueId++}`;
                // Unique id for the label element.
                this._labelId = `mat-form-field-label-${nextUniqueId++}`;
                this.floatLabel = this._getDefaultFloatLabelState();
                this._animationsEnabled = _animationMode !== 'NoopAnimations';
                // Set the default through here so we invoke the setter on the first run.
                this.appearance = _defaults?.appearance || 'legacy';
                if (_defaults) {
                  this._hideRequiredMarker = Boolean(_defaults.hideRequiredMarker);
                  if (_defaults.color) {
                    this.color = this.defaultColor = _defaults.color;
                  }
                }
              }
              /**
               * Gets the id of the label element. If no label is present, returns `null`.
               */
              getLabelId() {
                return this._hasFloatingLabel() ? this._labelId : null;
              }
              /**
               * Gets an ElementRef for the element that a overlay attached to the form field should be
               * positioned relative to.
               */
              getConnectedOverlayOrigin() {
                return this._connectionContainerRef || this._elementRef;
              }
              ngAfterContentInit() {
                this._validateControlChild();
                const control = this._control;
                if (control.controlType) {
                  this._elementRef.nativeElement.classList.add(`mat-form-field-type-${control.controlType}`);
                }
                // Subscribe to changes in the child control state in order to update the form field UI.
                control.stateChanges.pipe(startWith(null)).subscribe(() => {
                  this._validatePlaceholders();
                  this._syncDescribedByIds();
                  this._changeDetectorRef.markForCheck();
                });
                // Run change detection if the value changes.
                if (control.ngControl && control.ngControl.valueChanges) {
                  control.ngControl.valueChanges.pipe(takeUntil(this._destroyed)).subscribe(() => this._changeDetectorRef.markForCheck());
                }
                // Note that we have to run outside of the `NgZone` explicitly,
                // in order to avoid throwing users into an infinite loop
                // if `zone-patch-rxjs` is included.
                this._ngZone.runOutsideAngular(() => {
                  this._ngZone.onStable.pipe(takeUntil(this._destroyed)).subscribe(() => {
                    if (this._outlineGapCalculationNeededOnStable) {
                      this.updateOutlineGap();
                    }
                  });
                });
                // Run change detection and update the outline if the suffix or prefix changes.
                merge(this._prefixChildren.changes, this._suffixChildren.changes).subscribe(() => {
                  this._outlineGapCalculationNeededOnStable = true;
                  this._changeDetectorRef.markForCheck();
                });
                // Re-validate when the number of hints changes.
                this._hintChildren.changes.pipe(startWith(null)).subscribe(() => {
                  this._processHints();
                  this._changeDetectorRef.markForCheck();
                });
                // Update the aria-described by when the number of errors changes.
                this._errorChildren.changes.pipe(startWith(null)).subscribe(() => {
                  this._syncDescribedByIds();
                  this._changeDetectorRef.markForCheck();
                });
                if (this._dir) {
                  this._dir.change.pipe(takeUntil(this._destroyed)).subscribe(() => {
                    if (typeof requestAnimationFrame === 'function') {
                      this._ngZone.runOutsideAngular(() => {
                        requestAnimationFrame(() => this.updateOutlineGap());
                      });
                    } else {
                      this.updateOutlineGap();
                    }
                  });
                }
              }
              ngAfterContentChecked() {
                this._validateControlChild();
                if (this._outlineGapCalculationNeededImmediately) {
                  this.updateOutlineGap();
                }
              }
              ngAfterViewInit() {
                // Avoid animations on load.
                this._subscriptAnimationState = 'enter';
                this._changeDetectorRef.detectChanges();
              }
              ngOnDestroy() {
                this._destroyed.next();
                this._destroyed.complete();
              }
              /**
               * Determines whether a class from the AbstractControlDirective
               * should be forwarded to the host element.
               */
              _shouldForward(prop) {
                const control = this._control ? this._control.ngControl : null;
                return control && control[prop];
              }
              _hasPlaceholder() {
                return !!(this._control && this._control.placeholder || this._placeholderChild);
              }
              _hasLabel() {
                return !!(this._labelChildNonStatic || this._labelChildStatic);
              }
              _shouldLabelFloat() {
                return this._canLabelFloat() && (this._control && this._control.shouldLabelFloat || this._shouldAlwaysFloat());
              }
              _hideControlPlaceholder() {
                // In the legacy appearance the placeholder is promoted to a label if no label is given.
                return this.appearance === 'legacy' && !this._hasLabel() || this._hasLabel() && !this._shouldLabelFloat();
              }
              _hasFloatingLabel() {
                // In the legacy appearance the placeholder is promoted to a label if no label is given.
                return this._hasLabel() || this.appearance === 'legacy' && this._hasPlaceholder();
              }
              /** Determines whether to display hints or errors. */
              _getDisplayedMessages() {
                return this._errorChildren && this._errorChildren.length > 0 && this._control.errorState ? 'error' : 'hint';
              }
              /** Animates the placeholder up and locks it in position. */
              _animateAndLockLabel() {
                if (this._hasFloatingLabel() && this._canLabelFloat()) {
                  // If animations are disabled, we shouldn't go in here,
                  // because the `transitionend` will never fire.
                  if (this._animationsEnabled && this._label) {
                    this._showAlwaysAnimate = true;
                    fromEvent(this._label.nativeElement, 'transitionend').pipe(take(1)).subscribe(() => {
                      this._showAlwaysAnimate = false;
                    });
                  }
                  this.floatLabel = 'always';
                  this._changeDetectorRef.markForCheck();
                }
              }
              /**
               * Ensure that there is only one placeholder (either `placeholder` attribute on the child control
               * or child element with the `mat-placeholder` directive).
               */
              _validatePlaceholders() {
                if (this._control.placeholder && this._placeholderChild && (typeof ngDevMode === 'undefined' || ngDevMode)) {
                  throw getMatFormFieldPlaceholderConflictError();
                }
              }
              /** Does any extra processing that is required when handling the hints. */
              _processHints() {
                this._validateHints();
                this._syncDescribedByIds();
              }
              /**
               * Ensure that there is a maximum of one of each `<mat-hint>` alignment specified, with the
               * attribute being considered as `align="start"`.
               */
              _validateHints() {
                if (this._hintChildren && (typeof ngDevMode === 'undefined' || ngDevMode)) {
                  let startHint;
                  let endHint;
                  this._hintChildren.forEach(hint => {
                    if (hint.align === 'start') {
                      if (startHint || this.hintLabel) {
                        throw getMatFormFieldDuplicatedHintError('start');
                      }
                      startHint = hint;
                    } else if (hint.align === 'end') {
                      if (endHint) {
                        throw getMatFormFieldDuplicatedHintError('end');
                      }
                      endHint = hint;
                    }
                  });
                }
              }
              /** Gets the default float label state. */
              _getDefaultFloatLabelState() {
                return this._defaults && this._defaults.floatLabel || 'auto';
              }
              /**
               * Sets the list of element IDs that describe the child control. This allows the control to update
               * its `aria-describedby` attribute accordingly.
               */
              _syncDescribedByIds() {
                if (this._control) {
                  let ids = [];
                  // TODO(wagnermaciel): Remove the type check when we find the root cause of this bug.
                  if (this._control.userAriaDescribedBy && typeof this._control.userAriaDescribedBy === 'string') {
                    ids.push(...this._control.userAriaDescribedBy.split(' '));
                  }
                  if (this._getDisplayedMessages() === 'hint') {
                    const startHint = this._hintChildren ? this._hintChildren.find(hint => hint.align === 'start') : null;
                    const endHint = this._hintChildren ? this._hintChildren.find(hint => hint.align === 'end') : null;
                    if (startHint) {
                      ids.push(startHint.id);
                    } else if (this._hintLabel) {
                      ids.push(this._hintLabelId);
                    }
                    if (endHint) {
                      ids.push(endHint.id);
                    }
                  } else if (this._errorChildren) {
                    ids.push(...this._errorChildren.map(error => error.id));
                  }
                  this._control.setDescribedByIds(ids);
                }
              }
              /** Throws an error if the form field's control is missing. */
              _validateControlChild() {
                if (!this._control && (typeof ngDevMode === 'undefined' || ngDevMode)) {
                  throw getMatFormFieldMissingControlError();
                }
              }
              /**
               * Updates the width and position of the gap in the outline. Only relevant for the outline
               * appearance.
               */
              updateOutlineGap() {
                const labelEl = this._label ? this._label.nativeElement : null;
                const container = this._connectionContainerRef.nativeElement;
                const outlineStartSelector = '.mat-form-field-outline-start';
                const outlineGapSelector = '.mat-form-field-outline-gap';
                // getBoundingClientRect isn't available on the server.
                if (this.appearance !== 'outline' || !this._platform.isBrowser) {
                  return;
                }
                // If there is no content, set the gap elements to zero.
                if (!labelEl || !labelEl.children.length || !labelEl.textContent.trim()) {
                  const gapElements = container.querySelectorAll(`${outlineStartSelector}, ${outlineGapSelector}`);
                  for (let i = 0; i < gapElements.length; i++) {
                    gapElements[i].style.width = '0';
                  }
                  return;
                }
                // If the element is not present in the DOM, the outline gap will need to be calculated
                // the next time it is checked and in the DOM.
                if (!this._isAttachedToDOM()) {
                  this._outlineGapCalculationNeededImmediately = true;
                  return;
                }
                let startWidth = 0;
                let gapWidth = 0;
                const startEls = container.querySelectorAll(outlineStartSelector);
                const gapEls = container.querySelectorAll(outlineGapSelector);
                if (this._label && this._label.nativeElement.children.length) {
                  const containerRect = container.getBoundingClientRect();
                  // If the container's width and height are zero, it means that the element is
                  // invisible and we can't calculate the outline gap. Mark the element as needing
                  // to be checked the next time the zone stabilizes. We can't do this immediately
                  // on the next change detection, because even if the element becomes visible,
                  // the `ClientRect` won't be recalculated immediately. We reset the
                  // `_outlineGapCalculationNeededImmediately` flag some we don't run the checks twice.
                  if (containerRect.width === 0 && containerRect.height === 0) {
                    this._outlineGapCalculationNeededOnStable = true;
                    this._outlineGapCalculationNeededImmediately = false;
                    return;
                  }
                  const containerStart = this._getStartEnd(containerRect);
                  const labelChildren = labelEl.children;
                  const labelStart = this._getStartEnd(labelChildren[0].getBoundingClientRect());
                  let labelWidth = 0;
                  for (let i = 0; i < labelChildren.length; i++) {
                    labelWidth += labelChildren[i].offsetWidth;
                  }
                  startWidth = Math.abs(labelStart - containerStart) - outlineGapPadding;
                  gapWidth = labelWidth > 0 ? labelWidth * floatingLabelScale + outlineGapPadding * 2 : 0;
                }
                for (let i = 0; i < startEls.length; i++) {
                  startEls[i].style.width = `${startWidth}px`;
                }
                for (let i = 0; i < gapEls.length; i++) {
                  gapEls[i].style.width = `${gapWidth}px`;
                }
                this._outlineGapCalculationNeededOnStable = this._outlineGapCalculationNeededImmediately = false;
              }
              /** Gets the start end of the rect considering the current directionality. */
              _getStartEnd(rect) {
                return this._dir && this._dir.value === 'rtl' ? rect.right : rect.left;
              }
              /** Checks whether the form field is attached to the DOM. */
              _isAttachedToDOM() {
                const element = this._elementRef.nativeElement;
                if (element.getRootNode) {
                  const rootNode = element.getRootNode();
                  // If the element is inside the DOM the root node will be either the document
                  // or the closest shadow root, otherwise it'll be the element itself.
                  return rootNode && rootNode !== element;
                }
                // Otherwise fall back to checking if it's in the document. This doesn't account for
                // shadow DOM, however browser that support shadow DOM should support `getRootNode` as well.
                return document.documentElement.contains(element);
              }
            } exports('MatLegacyFormField', MatLegacyFormField);
            MatLegacyFormField.ɵfac = function MatLegacyFormField_Factory(t) {
              return new (t || MatLegacyFormField)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i1.Directionality, 8), i0.ɵɵdirectiveInject(MAT_LEGACY_FORM_FIELD_DEFAULT_OPTIONS, 8), i0.ɵɵdirectiveInject(i2.Platform), i0.ɵɵdirectiveInject(i0.NgZone), i0.ɵɵdirectiveInject(ANIMATION_MODULE_TYPE, 8));
            };
            MatLegacyFormField.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatLegacyFormField,
              selectors: [["mat-form-field"]],
              contentQueries: function MatLegacyFormField_ContentQueries(rf, ctx, dirIndex) {
                if (rf & 1) {
                  i0.ɵɵcontentQuery(dirIndex, MatFormFieldControl, 5);
                  i0.ɵɵcontentQuery(dirIndex, MatFormFieldControl, 7);
                  i0.ɵɵcontentQuery(dirIndex, MatLegacyLabel, 5);
                  i0.ɵɵcontentQuery(dirIndex, MatLegacyLabel, 7);
                  i0.ɵɵcontentQuery(dirIndex, MatLegacyPlaceholder, 5);
                  i0.ɵɵcontentQuery(dirIndex, MAT_ERROR, 5);
                  i0.ɵɵcontentQuery(dirIndex, _MAT_LEGACY_HINT, 5);
                  i0.ɵɵcontentQuery(dirIndex, MAT_PREFIX, 5);
                  i0.ɵɵcontentQuery(dirIndex, MAT_SUFFIX, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._controlNonStatic = _t.first);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._controlStatic = _t.first);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._labelChildNonStatic = _t.first);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._labelChildStatic = _t.first);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._placeholderChild = _t.first);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._errorChildren = _t);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._hintChildren = _t);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._prefixChildren = _t);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._suffixChildren = _t);
                }
              },
              viewQuery: function MatLegacyFormField_Query(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵviewQuery(_c0, 7);
                  i0.ɵɵviewQuery(_c1, 5);
                  i0.ɵɵviewQuery(_c2, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._connectionContainerRef = _t.first);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._inputContainerRef = _t.first);
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._label = _t.first);
                }
              },
              hostAttrs: [1, "mat-form-field"],
              hostVars: 40,
              hostBindings: function MatLegacyFormField_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵclassProp("mat-form-field-appearance-standard", ctx.appearance == "standard")("mat-form-field-appearance-fill", ctx.appearance == "fill")("mat-form-field-appearance-outline", ctx.appearance == "outline")("mat-form-field-appearance-legacy", ctx.appearance == "legacy")("mat-form-field-invalid", ctx._control.errorState)("mat-form-field-can-float", ctx._canLabelFloat())("mat-form-field-should-float", ctx._shouldLabelFloat())("mat-form-field-has-label", ctx._hasFloatingLabel())("mat-form-field-hide-placeholder", ctx._hideControlPlaceholder())("mat-form-field-disabled", ctx._control.disabled)("mat-form-field-autofilled", ctx._control.autofilled)("mat-focused", ctx._control.focused)("ng-untouched", ctx._shouldForward("untouched"))("ng-touched", ctx._shouldForward("touched"))("ng-pristine", ctx._shouldForward("pristine"))("ng-dirty", ctx._shouldForward("dirty"))("ng-valid", ctx._shouldForward("valid"))("ng-invalid", ctx._shouldForward("invalid"))("ng-pending", ctx._shouldForward("pending"))("_mat-animation-noopable", !ctx._animationsEnabled);
                }
              },
              inputs: {
                color: "color",
                appearance: "appearance",
                hideRequiredMarker: "hideRequiredMarker",
                hintLabel: "hintLabel",
                floatLabel: "floatLabel"
              },
              exportAs: ["matFormField"],
              features: [i0.ɵɵProvidersFeature([{
                provide: MAT_FORM_FIELD,
                useExisting: MatLegacyFormField
              }]), i0.ɵɵInheritDefinitionFeature],
              ngContentSelectors: _c4,
              decls: 15,
              vars: 8,
              consts: [[1, "mat-form-field-wrapper"], [1, "mat-form-field-flex", 3, "click"], ["connectionContainer", ""], [4, "ngIf"], ["class", "mat-form-field-prefix", 3, "cdkObserveContentDisabled", "cdkObserveContent", 4, "ngIf"], [1, "mat-form-field-infix"], ["inputContainer", ""], [1, "mat-form-field-label-wrapper"], ["class", "mat-form-field-label", 3, "cdkObserveContentDisabled", "id", "mat-empty", "mat-form-field-empty", "mat-accent", "mat-warn", "ngSwitch", "cdkObserveContent", 4, "ngIf"], ["class", "mat-form-field-suffix", 4, "ngIf"], ["class", "mat-form-field-underline", 4, "ngIf"], [1, "mat-form-field-subscript-wrapper", 3, "ngSwitch"], [4, "ngSwitchCase"], ["class", "mat-form-field-hint-wrapper", 4, "ngSwitchCase"], [1, "mat-form-field-outline"], [1, "mat-form-field-outline-start"], [1, "mat-form-field-outline-gap"], [1, "mat-form-field-outline-end"], [1, "mat-form-field-outline", "mat-form-field-outline-thick"], [1, "mat-form-field-prefix", 3, "cdkObserveContentDisabled", "cdkObserveContent"], [1, "mat-form-field-label", 3, "cdkObserveContentDisabled", "id", "ngSwitch", "cdkObserveContent"], ["label", ""], ["class", "mat-placeholder-required mat-form-field-required-marker", "aria-hidden", "true", 4, "ngIf"], ["aria-hidden", "true", 1, "mat-placeholder-required", "mat-form-field-required-marker"], [1, "mat-form-field-suffix"], [1, "mat-form-field-underline"], [1, "mat-form-field-ripple"], [1, "mat-form-field-hint-wrapper"], ["class", "mat-hint", 3, "id", 4, "ngIf"], [1, "mat-form-field-hint-spacer"], [1, "mat-hint", 3, "id"]],
              template: function MatLegacyFormField_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵprojectionDef(_c3);
                  i0.ɵɵelementStart(0, "div", 0)(1, "div", 1, 2);
                  i0.ɵɵlistener("click", function MatLegacyFormField_Template_div_click_1_listener($event) {
                    return ctx._control.onContainerClick && ctx._control.onContainerClick($event);
                  });
                  i0.ɵɵtemplate(3, MatLegacyFormField_ng_container_3_Template, 9, 0, "ng-container", 3);
                  i0.ɵɵtemplate(4, MatLegacyFormField_div_4_Template, 2, 1, "div", 4);
                  i0.ɵɵelementStart(5, "div", 5, 6);
                  i0.ɵɵprojection(7);
                  i0.ɵɵelementStart(8, "span", 7);
                  i0.ɵɵtemplate(9, MatLegacyFormField_label_9_Template, 5, 16, "label", 8);
                  i0.ɵɵelementEnd()();
                  i0.ɵɵtemplate(10, MatLegacyFormField_div_10_Template, 2, 0, "div", 9);
                  i0.ɵɵelementEnd();
                  i0.ɵɵtemplate(11, MatLegacyFormField_div_11_Template, 2, 4, "div", 10);
                  i0.ɵɵelementStart(12, "div", 11);
                  i0.ɵɵtemplate(13, MatLegacyFormField_div_13_Template, 2, 1, "div", 12);
                  i0.ɵɵtemplate(14, MatLegacyFormField_div_14_Template, 5, 2, "div", 13);
                  i0.ɵɵelementEnd()();
                }
                if (rf & 2) {
                  i0.ɵɵadvance(3);
                  i0.ɵɵproperty("ngIf", ctx.appearance == "outline");
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngIf", ctx._prefixChildren.length);
                  i0.ɵɵadvance(5);
                  i0.ɵɵproperty("ngIf", ctx._hasFloatingLabel());
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngIf", ctx._suffixChildren.length);
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngIf", ctx.appearance != "outline");
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngSwitch", ctx._getDisplayedMessages());
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngSwitchCase", "error");
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngSwitchCase", "hint");
                }
              },
              dependencies: [i3.NgIf, i3.NgSwitch, i3.NgSwitchCase, i4.CdkObserveContent],
              styles: [".mat-form-field{display:inline-block;position:relative;text-align:left}[dir=rtl] .mat-form-field{text-align:right}.mat-form-field-wrapper{position:relative}.mat-form-field-flex{display:inline-flex;align-items:baseline;box-sizing:border-box;width:100%}.mat-form-field-prefix,.mat-form-field-suffix{white-space:nowrap;flex:none;position:relative}.mat-form-field-infix{display:block;position:relative;flex:auto;min-width:0;width:180px}.cdk-high-contrast-active .mat-form-field-infix{border-image:linear-gradient(transparent, transparent)}.mat-form-field-label-wrapper{position:absolute;left:0;box-sizing:content-box;width:100%;height:100%;overflow:hidden;pointer-events:none}[dir=rtl] .mat-form-field-label-wrapper{left:auto;right:0}.mat-form-field-label{position:absolute;left:0;font:inherit;pointer-events:none;width:100%;white-space:nowrap;text-overflow:ellipsis;overflow:hidden;transform-origin:0 0;transition:transform 400ms cubic-bezier(0.25, 0.8, 0.25, 1),color 400ms cubic-bezier(0.25, 0.8, 0.25, 1),width 400ms cubic-bezier(0.25, 0.8, 0.25, 1);display:none}[dir=rtl] .mat-form-field-label{transform-origin:100% 0;left:auto;right:0}.cdk-high-contrast-active .mat-form-field-disabled .mat-form-field-label{color:GrayText}.mat-form-field-empty.mat-form-field-label,.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-label{display:block}.mat-form-field-autofill-control:-webkit-autofill+.mat-form-field-label-wrapper .mat-form-field-label{display:none}.mat-form-field-can-float .mat-form-field-autofill-control:-webkit-autofill+.mat-form-field-label-wrapper .mat-form-field-label{display:block;transition:none}.mat-input-server:focus+.mat-form-field-label-wrapper .mat-form-field-label,.mat-input-server[placeholder]:not(:placeholder-shown)+.mat-form-field-label-wrapper .mat-form-field-label{display:none}.mat-form-field-can-float .mat-input-server:focus+.mat-form-field-label-wrapper .mat-form-field-label,.mat-form-field-can-float .mat-input-server[placeholder]:not(:placeholder-shown)+.mat-form-field-label-wrapper .mat-form-field-label{display:block}.mat-form-field-label:not(.mat-form-field-empty){transition:none}.mat-form-field-underline{position:absolute;width:100%;pointer-events:none;transform:scale3d(1, 1.0001, 1)}.mat-form-field-ripple{position:absolute;left:0;width:100%;transform-origin:50%;transform:scaleX(0.5);opacity:0;transition:background-color 300ms cubic-bezier(0.55, 0, 0.55, 0.2)}.mat-form-field.mat-focused .mat-form-field-ripple,.mat-form-field.mat-form-field-invalid .mat-form-field-ripple{opacity:1;transform:none;transition:transform 300ms cubic-bezier(0.25, 0.8, 0.25, 1),opacity 100ms cubic-bezier(0.25, 0.8, 0.25, 1),background-color 300ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-subscript-wrapper{position:absolute;box-sizing:border-box;width:100%;overflow:hidden}.mat-form-field-subscript-wrapper .mat-icon,.mat-form-field-label-wrapper .mat-icon{width:1em;height:1em;font-size:inherit;vertical-align:baseline}.mat-form-field-hint-wrapper{display:flex}.mat-form-field-hint-spacer{flex:1 0 1em}.mat-error{display:block}.mat-form-field-control-wrapper{position:relative}.mat-form-field-hint-end{order:1}.mat-form-field._mat-animation-noopable .mat-form-field-label,.mat-form-field._mat-animation-noopable .mat-form-field-ripple{transition:none}.mat-form-field .mat-form-field-prefix .mat-datepicker-toggle .mat-mdc-button-base,.mat-form-field .mat-form-field-suffix .mat-datepicker-toggle .mat-mdc-button-base{width:40px;height:40px;padding:8px 0}.mat-form-field .mat-datepicker-toggle .mat-mdc-icon-button .mat-icon{font-size:1em;display:inline-block;margin:-2px 0 1px}.mat-form-field-type-mat-date-range-input .mat-form-field-infix{width:200px}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-datepicker-toggle .mat-mdc-icon-button,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-datepicker-toggle .mat-mdc-icon-button{font-size:inherit;width:1.5em;height:1.5em;padding:0}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-datepicker-toggle-default-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-datepicker-toggle-default-icon{width:1em}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-datepicker-toggle .mat-mdc-icon-button .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-datepicker-toggle .mat-mdc-icon-button .mat-icon{line-height:1.5em;margin:0}.mat-form-field .mat-datepicker-toggle .mat-mdc-button-base{vertical-align:middle}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-datepicker-toggle .mat-mdc-button-base{vertical-align:baseline}", ".mat-form-field-appearance-fill .mat-form-field-flex{border-radius:4px 4px 0 0;padding:.75em .75em 0 .75em}.cdk-high-contrast-active .mat-form-field-appearance-fill .mat-form-field-flex{outline:solid 1px}.cdk-high-contrast-active .mat-form-field-appearance-fill.mat-form-field-disabled .mat-form-field-flex{outline-color:GrayText}.cdk-high-contrast-active .mat-form-field-appearance-fill.mat-focused .mat-form-field-flex{outline:dashed 3px}.mat-form-field-appearance-fill .mat-form-field-underline::before{content:\"\";display:block;position:absolute;bottom:0;height:1px;width:100%}.mat-form-field-appearance-fill .mat-form-field-ripple{bottom:0;height:2px}.cdk-high-contrast-active .mat-form-field-appearance-fill .mat-form-field-ripple{height:0}.mat-form-field-appearance-fill:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{opacity:1;transform:none;transition:opacity 600ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-appearance-fill._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{transition:none}.mat-form-field-appearance-fill .mat-form-field-subscript-wrapper{padding:0 1em}", ".mat-input-element{font:inherit;background:rgba(0,0,0,0);color:currentColor;border:none;outline:none;padding:0;margin:0;width:100%;max-width:100%;vertical-align:bottom;text-align:inherit;box-sizing:content-box}.mat-input-element:-moz-ui-invalid{box-shadow:none}.mat-input-element,.mat-input-element::-webkit-search-cancel-button,.mat-input-element::-webkit-search-decoration,.mat-input-element::-webkit-search-results-button,.mat-input-element::-webkit-search-results-decoration{-webkit-appearance:none}.mat-input-element::-webkit-contacts-auto-fill-button,.mat-input-element::-webkit-caps-lock-indicator,.mat-input-element:not([type=password])::-webkit-credentials-auto-fill-button{visibility:hidden}.mat-input-element[type=date],.mat-input-element[type=datetime],.mat-input-element[type=datetime-local],.mat-input-element[type=month],.mat-input-element[type=week],.mat-input-element[type=time]{line-height:1}.mat-input-element[type=date]::after,.mat-input-element[type=datetime]::after,.mat-input-element[type=datetime-local]::after,.mat-input-element[type=month]::after,.mat-input-element[type=week]::after,.mat-input-element[type=time]::after{content:\" \";white-space:pre;width:1px}.mat-input-element::-webkit-inner-spin-button,.mat-input-element::-webkit-calendar-picker-indicator,.mat-input-element::-webkit-clear-button{font-size:.75em}.mat-input-element::placeholder{-webkit-user-select:none;user-select:none;transition:color 400ms 133.3333333333ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-input-element::-moz-placeholder{-webkit-user-select:none;user-select:none;transition:color 400ms 133.3333333333ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-input-element::-webkit-input-placeholder{-webkit-user-select:none;user-select:none;transition:color 400ms 133.3333333333ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-input-element:-ms-input-placeholder{-webkit-user-select:none;user-select:none;transition:color 400ms 133.3333333333ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-hide-placeholder .mat-input-element::placeholder{color:rgba(0,0,0,0) !important;-webkit-text-fill-color:rgba(0,0,0,0);transition:none}.cdk-high-contrast-active .mat-form-field-hide-placeholder .mat-input-element::placeholder{opacity:0}.mat-form-field-hide-placeholder .mat-input-element::-moz-placeholder{color:rgba(0,0,0,0) !important;-webkit-text-fill-color:rgba(0,0,0,0);transition:none}.cdk-high-contrast-active .mat-form-field-hide-placeholder .mat-input-element::-moz-placeholder{opacity:0}.mat-form-field-hide-placeholder .mat-input-element::-webkit-input-placeholder{color:rgba(0,0,0,0) !important;-webkit-text-fill-color:rgba(0,0,0,0);transition:none}.cdk-high-contrast-active .mat-form-field-hide-placeholder .mat-input-element::-webkit-input-placeholder{opacity:0}.mat-form-field-hide-placeholder .mat-input-element:-ms-input-placeholder{color:rgba(0,0,0,0) !important;-webkit-text-fill-color:rgba(0,0,0,0);transition:none}.cdk-high-contrast-active .mat-form-field-hide-placeholder .mat-input-element:-ms-input-placeholder{opacity:0}._mat-animation-noopable .mat-input-element::placeholder{transition:none}._mat-animation-noopable .mat-input-element::-moz-placeholder{transition:none}._mat-animation-noopable .mat-input-element::-webkit-input-placeholder{transition:none}._mat-animation-noopable .mat-input-element:-ms-input-placeholder{transition:none}textarea.mat-input-element{resize:vertical;overflow:auto}textarea.mat-input-element.cdk-textarea-autosize{resize:none}textarea.mat-input-element{padding:2px 0;margin:-2px 0}select.mat-input-element{-moz-appearance:none;-webkit-appearance:none;position:relative;background-color:rgba(0,0,0,0);display:inline-flex;box-sizing:border-box;padding-top:1em;top:-1em;margin-bottom:-1em}select.mat-input-element::-moz-focus-inner{border:0}select.mat-input-element:not(:disabled){cursor:pointer}.mat-form-field-type-mat-native-select .mat-form-field-infix::after{content:\"\";width:0;height:0;border-left:5px solid rgba(0,0,0,0);border-right:5px solid rgba(0,0,0,0);border-top:5px solid;position:absolute;top:50%;right:0;margin-top:-2.5px;pointer-events:none}[dir=rtl] .mat-form-field-type-mat-native-select .mat-form-field-infix::after{right:auto;left:0}.mat-form-field-type-mat-native-select .mat-input-element{padding-right:15px}[dir=rtl] .mat-form-field-type-mat-native-select .mat-input-element{padding-right:0;padding-left:15px}.mat-form-field-type-mat-native-select .mat-form-field-label-wrapper{max-width:calc(100% - 10px)}.mat-form-field-type-mat-native-select.mat-form-field-appearance-outline .mat-form-field-infix::after{margin-top:-5px}.mat-form-field-type-mat-native-select.mat-form-field-appearance-fill .mat-form-field-infix::after{margin-top:-10px}", ".mat-form-field-appearance-legacy .mat-form-field-label{transform:perspective(100px)}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon{width:1em}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon-button,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon-button{font:inherit;vertical-align:baseline}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon-button .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon-button .mat-icon{font-size:inherit}.mat-form-field-appearance-legacy .mat-form-field-underline{height:1px}.cdk-high-contrast-active .mat-form-field-appearance-legacy .mat-form-field-underline{height:0;border-top:solid 1px}.mat-form-field-appearance-legacy .mat-form-field-ripple{top:0;height:2px;overflow:hidden}.cdk-high-contrast-active .mat-form-field-appearance-legacy .mat-form-field-ripple{height:0;border-top:solid 2px}.mat-form-field-appearance-legacy.mat-form-field-disabled .mat-form-field-underline{background-position:0;background-color:rgba(0,0,0,0)}.cdk-high-contrast-active .mat-form-field-appearance-legacy.mat-form-field-disabled .mat-form-field-underline{border-top-style:dotted;border-top-width:2px;border-top-color:GrayText}.mat-form-field-appearance-legacy.mat-form-field-invalid:not(.mat-focused) .mat-form-field-ripple{height:1px}", ".mat-form-field-appearance-outline .mat-form-field-wrapper{margin:.25em 0}.mat-form-field-appearance-outline .mat-form-field-flex{padding:0 .75em 0 .75em;margin-top:-0.25em;position:relative}.mat-form-field-appearance-outline .mat-form-field-prefix,.mat-form-field-appearance-outline .mat-form-field-suffix{top:.25em}.mat-form-field-appearance-outline .mat-form-field-outline{display:flex;position:absolute;top:.25em;left:0;right:0;bottom:0;pointer-events:none}.mat-form-field-appearance-outline .mat-form-field-outline-start,.mat-form-field-appearance-outline .mat-form-field-outline-end{border:1px solid currentColor;min-width:5px}.mat-form-field-appearance-outline .mat-form-field-outline-start{border-radius:5px 0 0 5px;border-right-style:none}[dir=rtl] .mat-form-field-appearance-outline .mat-form-field-outline-start{border-right-style:solid;border-left-style:none;border-radius:0 5px 5px 0}.mat-form-field-appearance-outline .mat-form-field-outline-end{border-radius:0 5px 5px 0;border-left-style:none;flex-grow:1}[dir=rtl] .mat-form-field-appearance-outline .mat-form-field-outline-end{border-left-style:solid;border-right-style:none;border-radius:5px 0 0 5px}.mat-form-field-appearance-outline .mat-form-field-outline-gap{border-radius:.000001px;border:1px solid currentColor;border-left-style:none;border-right-style:none}.mat-form-field-appearance-outline.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-outline-gap{border-top-color:rgba(0,0,0,0)}.mat-form-field-appearance-outline .mat-form-field-outline-thick{opacity:0}.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-start,.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-end,.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-gap{border-width:2px}.mat-form-field-appearance-outline.mat-focused .mat-form-field-outline,.mat-form-field-appearance-outline.mat-form-field-invalid .mat-form-field-outline{opacity:0;transition:opacity 100ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-appearance-outline.mat-focused .mat-form-field-outline-thick,.mat-form-field-appearance-outline.mat-form-field-invalid .mat-form-field-outline-thick{opacity:1}.cdk-high-contrast-active .mat-form-field-appearance-outline.mat-focused .mat-form-field-outline-thick{border:3px dashed}.mat-form-field-appearance-outline:not(.mat-form-field-disabled) .mat-form-field-flex:hover .mat-form-field-outline{opacity:0;transition:opacity 600ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-appearance-outline:not(.mat-form-field-disabled) .mat-form-field-flex:hover .mat-form-field-outline-thick{opacity:1}.mat-form-field-appearance-outline .mat-form-field-subscript-wrapper{padding:0 1em}.cdk-high-contrast-active .mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{color:GrayText}.mat-form-field-appearance-outline._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-outline,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-start,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-end,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-gap{transition:none}", ".mat-form-field-appearance-standard .mat-form-field-flex{padding-top:.75em}.mat-form-field-appearance-standard .mat-form-field-underline{height:1px}.cdk-high-contrast-active .mat-form-field-appearance-standard .mat-form-field-underline{height:0;border-top:solid 1px}.mat-form-field-appearance-standard .mat-form-field-ripple{bottom:0;height:2px}.cdk-high-contrast-active .mat-form-field-appearance-standard .mat-form-field-ripple{height:0;border-top:solid 2px}.mat-form-field-appearance-standard.mat-form-field-disabled .mat-form-field-underline{background-position:0;background-color:rgba(0,0,0,0)}.cdk-high-contrast-active .mat-form-field-appearance-standard.mat-form-field-disabled .mat-form-field-underline{border-top-style:dotted;border-top-width:2px}.mat-form-field-appearance-standard:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{opacity:1;transform:none;transition:opacity 600ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-appearance-standard._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{transition:none}"],
              encapsulation: 2,
              data: {
                animation: [matFormFieldAnimations.transitionMessages]
              },
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyFormField, [{
                type: Component,
                args: [{
                  selector: 'mat-form-field',
                  exportAs: 'matFormField',
                  animations: [matFormFieldAnimations.transitionMessages],
                  host: {
                    'class': 'mat-form-field',
                    '[class.mat-form-field-appearance-standard]': 'appearance == "standard"',
                    '[class.mat-form-field-appearance-fill]': 'appearance == "fill"',
                    '[class.mat-form-field-appearance-outline]': 'appearance == "outline"',
                    '[class.mat-form-field-appearance-legacy]': 'appearance == "legacy"',
                    '[class.mat-form-field-invalid]': '_control.errorState',
                    '[class.mat-form-field-can-float]': '_canLabelFloat()',
                    '[class.mat-form-field-should-float]': '_shouldLabelFloat()',
                    '[class.mat-form-field-has-label]': '_hasFloatingLabel()',
                    '[class.mat-form-field-hide-placeholder]': '_hideControlPlaceholder()',
                    '[class.mat-form-field-disabled]': '_control.disabled',
                    '[class.mat-form-field-autofilled]': '_control.autofilled',
                    '[class.mat-focused]': '_control.focused',
                    '[class.ng-untouched]': '_shouldForward("untouched")',
                    '[class.ng-touched]': '_shouldForward("touched")',
                    '[class.ng-pristine]': '_shouldForward("pristine")',
                    '[class.ng-dirty]': '_shouldForward("dirty")',
                    '[class.ng-valid]': '_shouldForward("valid")',
                    '[class.ng-invalid]': '_shouldForward("invalid")',
                    '[class.ng-pending]': '_shouldForward("pending")',
                    '[class._mat-animation-noopable]': '!_animationsEnabled'
                  },
                  inputs: ['color'],
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  providers: [{
                    provide: MAT_FORM_FIELD,
                    useExisting: MatLegacyFormField
                  }],
                  template: "<div class=\"mat-form-field-wrapper\">\n  <div class=\"mat-form-field-flex\" #connectionContainer\n       (click)=\"_control.onContainerClick && _control.onContainerClick($event)\">\n\n    <!-- Outline used for outline appearance. -->\n    <ng-container *ngIf=\"appearance == 'outline'\">\n      <div class=\"mat-form-field-outline\">\n        <div class=\"mat-form-field-outline-start\"></div>\n        <div class=\"mat-form-field-outline-gap\"></div>\n        <div class=\"mat-form-field-outline-end\"></div>\n      </div>\n      <div class=\"mat-form-field-outline mat-form-field-outline-thick\">\n        <div class=\"mat-form-field-outline-start\"></div>\n        <div class=\"mat-form-field-outline-gap\"></div>\n        <div class=\"mat-form-field-outline-end\"></div>\n      </div>\n    </ng-container>\n\n    <div\n      class=\"mat-form-field-prefix\"\n      *ngIf=\"_prefixChildren.length\"\n      (cdkObserveContent)=\"updateOutlineGap()\"\n      [cdkObserveContentDisabled]=\"appearance != 'outline'\">\n      <ng-content select=\"[matPrefix]\"></ng-content>\n    </div>\n\n    <div class=\"mat-form-field-infix\" #inputContainer>\n      <ng-content></ng-content>\n\n      <span class=\"mat-form-field-label-wrapper\">\n        <!-- We add aria-owns as a workaround for an issue in JAWS & NVDA where the label isn't\n             read if it comes before the control in the DOM. -->\n        <label class=\"mat-form-field-label\"\n               (cdkObserveContent)=\"updateOutlineGap()\"\n               [cdkObserveContentDisabled]=\"appearance != 'outline'\"\n               [id]=\"_labelId\"\n               [attr.for]=\"_control.id\"\n               [attr.aria-owns]=\"_control.id\"\n               [class.mat-empty]=\"_control.empty && !_shouldAlwaysFloat()\"\n               [class.mat-form-field-empty]=\"_control.empty && !_shouldAlwaysFloat()\"\n               [class.mat-accent]=\"color == 'accent'\"\n               [class.mat-warn]=\"color == 'warn'\"\n               #label\n               *ngIf=\"_hasFloatingLabel()\"\n               [ngSwitch]=\"_hasLabel()\">\n\n          <!-- @breaking-change 8.0.0 remove in favor of mat-label element an placeholder attr. -->\n          <ng-container *ngSwitchCase=\"false\">\n            <ng-content select=\"mat-placeholder\"></ng-content>\n            <span>{{_control.placeholder}}</span>\n          </ng-container>\n\n          <ng-content select=\"mat-label\" *ngSwitchCase=\"true\"></ng-content>\n\n          <!-- @breaking-change 8.0.0 remove `mat-placeholder-required` class -->\n          <span\n            class=\"mat-placeholder-required mat-form-field-required-marker\"\n            aria-hidden=\"true\"\n            *ngIf=\"!hideRequiredMarker && _control.required && !_control.disabled\">&#32;*</span>\n        </label>\n      </span>\n    </div>\n\n    <div class=\"mat-form-field-suffix\" *ngIf=\"_suffixChildren.length\">\n      <ng-content select=\"[matSuffix]\"></ng-content>\n    </div>\n  </div>\n\n  <!-- Underline used for legacy, standard, and box appearances. -->\n  <div class=\"mat-form-field-underline\"\n       *ngIf=\"appearance != 'outline'\">\n    <span class=\"mat-form-field-ripple\"\n          [class.mat-accent]=\"color == 'accent'\"\n          [class.mat-warn]=\"color == 'warn'\"></span>\n  </div>\n\n  <div class=\"mat-form-field-subscript-wrapper\"\n       [ngSwitch]=\"_getDisplayedMessages()\">\n    <div *ngSwitchCase=\"'error'\" [@transitionMessages]=\"_subscriptAnimationState\">\n      <ng-content select=\"mat-error\"></ng-content>\n    </div>\n\n    <div class=\"mat-form-field-hint-wrapper\" *ngSwitchCase=\"'hint'\"\n      [@transitionMessages]=\"_subscriptAnimationState\">\n      <!-- TODO(mmalerba): use an actual <mat-hint> once all selectors are switched to mat-* -->\n      <div *ngIf=\"hintLabel\" [id]=\"_hintLabelId\" class=\"mat-hint\">{{hintLabel}}</div>\n      <ng-content select=\"mat-hint:not([align='end'])\"></ng-content>\n      <div class=\"mat-form-field-hint-spacer\"></div>\n      <ng-content select=\"mat-hint[align='end']\"></ng-content>\n    </div>\n  </div>\n</div>\n",
                  styles: [".mat-form-field{display:inline-block;position:relative;text-align:left}[dir=rtl] .mat-form-field{text-align:right}.mat-form-field-wrapper{position:relative}.mat-form-field-flex{display:inline-flex;align-items:baseline;box-sizing:border-box;width:100%}.mat-form-field-prefix,.mat-form-field-suffix{white-space:nowrap;flex:none;position:relative}.mat-form-field-infix{display:block;position:relative;flex:auto;min-width:0;width:180px}.cdk-high-contrast-active .mat-form-field-infix{border-image:linear-gradient(transparent, transparent)}.mat-form-field-label-wrapper{position:absolute;left:0;box-sizing:content-box;width:100%;height:100%;overflow:hidden;pointer-events:none}[dir=rtl] .mat-form-field-label-wrapper{left:auto;right:0}.mat-form-field-label{position:absolute;left:0;font:inherit;pointer-events:none;width:100%;white-space:nowrap;text-overflow:ellipsis;overflow:hidden;transform-origin:0 0;transition:transform 400ms cubic-bezier(0.25, 0.8, 0.25, 1),color 400ms cubic-bezier(0.25, 0.8, 0.25, 1),width 400ms cubic-bezier(0.25, 0.8, 0.25, 1);display:none}[dir=rtl] .mat-form-field-label{transform-origin:100% 0;left:auto;right:0}.cdk-high-contrast-active .mat-form-field-disabled .mat-form-field-label{color:GrayText}.mat-form-field-empty.mat-form-field-label,.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-label{display:block}.mat-form-field-autofill-control:-webkit-autofill+.mat-form-field-label-wrapper .mat-form-field-label{display:none}.mat-form-field-can-float .mat-form-field-autofill-control:-webkit-autofill+.mat-form-field-label-wrapper .mat-form-field-label{display:block;transition:none}.mat-input-server:focus+.mat-form-field-label-wrapper .mat-form-field-label,.mat-input-server[placeholder]:not(:placeholder-shown)+.mat-form-field-label-wrapper .mat-form-field-label{display:none}.mat-form-field-can-float .mat-input-server:focus+.mat-form-field-label-wrapper .mat-form-field-label,.mat-form-field-can-float .mat-input-server[placeholder]:not(:placeholder-shown)+.mat-form-field-label-wrapper .mat-form-field-label{display:block}.mat-form-field-label:not(.mat-form-field-empty){transition:none}.mat-form-field-underline{position:absolute;width:100%;pointer-events:none;transform:scale3d(1, 1.0001, 1)}.mat-form-field-ripple{position:absolute;left:0;width:100%;transform-origin:50%;transform:scaleX(0.5);opacity:0;transition:background-color 300ms cubic-bezier(0.55, 0, 0.55, 0.2)}.mat-form-field.mat-focused .mat-form-field-ripple,.mat-form-field.mat-form-field-invalid .mat-form-field-ripple{opacity:1;transform:none;transition:transform 300ms cubic-bezier(0.25, 0.8, 0.25, 1),opacity 100ms cubic-bezier(0.25, 0.8, 0.25, 1),background-color 300ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-subscript-wrapper{position:absolute;box-sizing:border-box;width:100%;overflow:hidden}.mat-form-field-subscript-wrapper .mat-icon,.mat-form-field-label-wrapper .mat-icon{width:1em;height:1em;font-size:inherit;vertical-align:baseline}.mat-form-field-hint-wrapper{display:flex}.mat-form-field-hint-spacer{flex:1 0 1em}.mat-error{display:block}.mat-form-field-control-wrapper{position:relative}.mat-form-field-hint-end{order:1}.mat-form-field._mat-animation-noopable .mat-form-field-label,.mat-form-field._mat-animation-noopable .mat-form-field-ripple{transition:none}.mat-form-field .mat-form-field-prefix .mat-datepicker-toggle .mat-mdc-button-base,.mat-form-field .mat-form-field-suffix .mat-datepicker-toggle .mat-mdc-button-base{width:40px;height:40px;padding:8px 0}.mat-form-field .mat-datepicker-toggle .mat-mdc-icon-button .mat-icon{font-size:1em;display:inline-block;margin:-2px 0 1px}.mat-form-field-type-mat-date-range-input .mat-form-field-infix{width:200px}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-datepicker-toggle .mat-mdc-icon-button,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-datepicker-toggle .mat-mdc-icon-button{font-size:inherit;width:1.5em;height:1.5em;padding:0}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-datepicker-toggle-default-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-datepicker-toggle-default-icon{width:1em}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-datepicker-toggle .mat-mdc-icon-button .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-datepicker-toggle .mat-mdc-icon-button .mat-icon{line-height:1.5em;margin:0}.mat-form-field .mat-datepicker-toggle .mat-mdc-button-base{vertical-align:middle}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-datepicker-toggle .mat-mdc-button-base{vertical-align:baseline}", ".mat-form-field-appearance-fill .mat-form-field-flex{border-radius:4px 4px 0 0;padding:.75em .75em 0 .75em}.cdk-high-contrast-active .mat-form-field-appearance-fill .mat-form-field-flex{outline:solid 1px}.cdk-high-contrast-active .mat-form-field-appearance-fill.mat-form-field-disabled .mat-form-field-flex{outline-color:GrayText}.cdk-high-contrast-active .mat-form-field-appearance-fill.mat-focused .mat-form-field-flex{outline:dashed 3px}.mat-form-field-appearance-fill .mat-form-field-underline::before{content:\"\";display:block;position:absolute;bottom:0;height:1px;width:100%}.mat-form-field-appearance-fill .mat-form-field-ripple{bottom:0;height:2px}.cdk-high-contrast-active .mat-form-field-appearance-fill .mat-form-field-ripple{height:0}.mat-form-field-appearance-fill:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{opacity:1;transform:none;transition:opacity 600ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-appearance-fill._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{transition:none}.mat-form-field-appearance-fill .mat-form-field-subscript-wrapper{padding:0 1em}", ".mat-input-element{font:inherit;background:rgba(0,0,0,0);color:currentColor;border:none;outline:none;padding:0;margin:0;width:100%;max-width:100%;vertical-align:bottom;text-align:inherit;box-sizing:content-box}.mat-input-element:-moz-ui-invalid{box-shadow:none}.mat-input-element,.mat-input-element::-webkit-search-cancel-button,.mat-input-element::-webkit-search-decoration,.mat-input-element::-webkit-search-results-button,.mat-input-element::-webkit-search-results-decoration{-webkit-appearance:none}.mat-input-element::-webkit-contacts-auto-fill-button,.mat-input-element::-webkit-caps-lock-indicator,.mat-input-element:not([type=password])::-webkit-credentials-auto-fill-button{visibility:hidden}.mat-input-element[type=date],.mat-input-element[type=datetime],.mat-input-element[type=datetime-local],.mat-input-element[type=month],.mat-input-element[type=week],.mat-input-element[type=time]{line-height:1}.mat-input-element[type=date]::after,.mat-input-element[type=datetime]::after,.mat-input-element[type=datetime-local]::after,.mat-input-element[type=month]::after,.mat-input-element[type=week]::after,.mat-input-element[type=time]::after{content:\" \";white-space:pre;width:1px}.mat-input-element::-webkit-inner-spin-button,.mat-input-element::-webkit-calendar-picker-indicator,.mat-input-element::-webkit-clear-button{font-size:.75em}.mat-input-element::placeholder{-webkit-user-select:none;user-select:none;transition:color 400ms 133.3333333333ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-input-element::-moz-placeholder{-webkit-user-select:none;user-select:none;transition:color 400ms 133.3333333333ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-input-element::-webkit-input-placeholder{-webkit-user-select:none;user-select:none;transition:color 400ms 133.3333333333ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-input-element:-ms-input-placeholder{-webkit-user-select:none;user-select:none;transition:color 400ms 133.3333333333ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-hide-placeholder .mat-input-element::placeholder{color:rgba(0,0,0,0) !important;-webkit-text-fill-color:rgba(0,0,0,0);transition:none}.cdk-high-contrast-active .mat-form-field-hide-placeholder .mat-input-element::placeholder{opacity:0}.mat-form-field-hide-placeholder .mat-input-element::-moz-placeholder{color:rgba(0,0,0,0) !important;-webkit-text-fill-color:rgba(0,0,0,0);transition:none}.cdk-high-contrast-active .mat-form-field-hide-placeholder .mat-input-element::-moz-placeholder{opacity:0}.mat-form-field-hide-placeholder .mat-input-element::-webkit-input-placeholder{color:rgba(0,0,0,0) !important;-webkit-text-fill-color:rgba(0,0,0,0);transition:none}.cdk-high-contrast-active .mat-form-field-hide-placeholder .mat-input-element::-webkit-input-placeholder{opacity:0}.mat-form-field-hide-placeholder .mat-input-element:-ms-input-placeholder{color:rgba(0,0,0,0) !important;-webkit-text-fill-color:rgba(0,0,0,0);transition:none}.cdk-high-contrast-active .mat-form-field-hide-placeholder .mat-input-element:-ms-input-placeholder{opacity:0}._mat-animation-noopable .mat-input-element::placeholder{transition:none}._mat-animation-noopable .mat-input-element::-moz-placeholder{transition:none}._mat-animation-noopable .mat-input-element::-webkit-input-placeholder{transition:none}._mat-animation-noopable .mat-input-element:-ms-input-placeholder{transition:none}textarea.mat-input-element{resize:vertical;overflow:auto}textarea.mat-input-element.cdk-textarea-autosize{resize:none}textarea.mat-input-element{padding:2px 0;margin:-2px 0}select.mat-input-element{-moz-appearance:none;-webkit-appearance:none;position:relative;background-color:rgba(0,0,0,0);display:inline-flex;box-sizing:border-box;padding-top:1em;top:-1em;margin-bottom:-1em}select.mat-input-element::-moz-focus-inner{border:0}select.mat-input-element:not(:disabled){cursor:pointer}.mat-form-field-type-mat-native-select .mat-form-field-infix::after{content:\"\";width:0;height:0;border-left:5px solid rgba(0,0,0,0);border-right:5px solid rgba(0,0,0,0);border-top:5px solid;position:absolute;top:50%;right:0;margin-top:-2.5px;pointer-events:none}[dir=rtl] .mat-form-field-type-mat-native-select .mat-form-field-infix::after{right:auto;left:0}.mat-form-field-type-mat-native-select .mat-input-element{padding-right:15px}[dir=rtl] .mat-form-field-type-mat-native-select .mat-input-element{padding-right:0;padding-left:15px}.mat-form-field-type-mat-native-select .mat-form-field-label-wrapper{max-width:calc(100% - 10px)}.mat-form-field-type-mat-native-select.mat-form-field-appearance-outline .mat-form-field-infix::after{margin-top:-5px}.mat-form-field-type-mat-native-select.mat-form-field-appearance-fill .mat-form-field-infix::after{margin-top:-10px}", ".mat-form-field-appearance-legacy .mat-form-field-label{transform:perspective(100px)}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon{width:1em}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon-button,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon-button{font:inherit;vertical-align:baseline}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon-button .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon-button .mat-icon{font-size:inherit}.mat-form-field-appearance-legacy .mat-form-field-underline{height:1px}.cdk-high-contrast-active .mat-form-field-appearance-legacy .mat-form-field-underline{height:0;border-top:solid 1px}.mat-form-field-appearance-legacy .mat-form-field-ripple{top:0;height:2px;overflow:hidden}.cdk-high-contrast-active .mat-form-field-appearance-legacy .mat-form-field-ripple{height:0;border-top:solid 2px}.mat-form-field-appearance-legacy.mat-form-field-disabled .mat-form-field-underline{background-position:0;background-color:rgba(0,0,0,0)}.cdk-high-contrast-active .mat-form-field-appearance-legacy.mat-form-field-disabled .mat-form-field-underline{border-top-style:dotted;border-top-width:2px;border-top-color:GrayText}.mat-form-field-appearance-legacy.mat-form-field-invalid:not(.mat-focused) .mat-form-field-ripple{height:1px}", ".mat-form-field-appearance-outline .mat-form-field-wrapper{margin:.25em 0}.mat-form-field-appearance-outline .mat-form-field-flex{padding:0 .75em 0 .75em;margin-top:-0.25em;position:relative}.mat-form-field-appearance-outline .mat-form-field-prefix,.mat-form-field-appearance-outline .mat-form-field-suffix{top:.25em}.mat-form-field-appearance-outline .mat-form-field-outline{display:flex;position:absolute;top:.25em;left:0;right:0;bottom:0;pointer-events:none}.mat-form-field-appearance-outline .mat-form-field-outline-start,.mat-form-field-appearance-outline .mat-form-field-outline-end{border:1px solid currentColor;min-width:5px}.mat-form-field-appearance-outline .mat-form-field-outline-start{border-radius:5px 0 0 5px;border-right-style:none}[dir=rtl] .mat-form-field-appearance-outline .mat-form-field-outline-start{border-right-style:solid;border-left-style:none;border-radius:0 5px 5px 0}.mat-form-field-appearance-outline .mat-form-field-outline-end{border-radius:0 5px 5px 0;border-left-style:none;flex-grow:1}[dir=rtl] .mat-form-field-appearance-outline .mat-form-field-outline-end{border-left-style:solid;border-right-style:none;border-radius:5px 0 0 5px}.mat-form-field-appearance-outline .mat-form-field-outline-gap{border-radius:.000001px;border:1px solid currentColor;border-left-style:none;border-right-style:none}.mat-form-field-appearance-outline.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-outline-gap{border-top-color:rgba(0,0,0,0)}.mat-form-field-appearance-outline .mat-form-field-outline-thick{opacity:0}.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-start,.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-end,.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-gap{border-width:2px}.mat-form-field-appearance-outline.mat-focused .mat-form-field-outline,.mat-form-field-appearance-outline.mat-form-field-invalid .mat-form-field-outline{opacity:0;transition:opacity 100ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-appearance-outline.mat-focused .mat-form-field-outline-thick,.mat-form-field-appearance-outline.mat-form-field-invalid .mat-form-field-outline-thick{opacity:1}.cdk-high-contrast-active .mat-form-field-appearance-outline.mat-focused .mat-form-field-outline-thick{border:3px dashed}.mat-form-field-appearance-outline:not(.mat-form-field-disabled) .mat-form-field-flex:hover .mat-form-field-outline{opacity:0;transition:opacity 600ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-appearance-outline:not(.mat-form-field-disabled) .mat-form-field-flex:hover .mat-form-field-outline-thick{opacity:1}.mat-form-field-appearance-outline .mat-form-field-subscript-wrapper{padding:0 1em}.cdk-high-contrast-active .mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{color:GrayText}.mat-form-field-appearance-outline._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-outline,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-start,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-end,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-gap{transition:none}", ".mat-form-field-appearance-standard .mat-form-field-flex{padding-top:.75em}.mat-form-field-appearance-standard .mat-form-field-underline{height:1px}.cdk-high-contrast-active .mat-form-field-appearance-standard .mat-form-field-underline{height:0;border-top:solid 1px}.mat-form-field-appearance-standard .mat-form-field-ripple{bottom:0;height:2px}.cdk-high-contrast-active .mat-form-field-appearance-standard .mat-form-field-ripple{height:0;border-top:solid 2px}.mat-form-field-appearance-standard.mat-form-field-disabled .mat-form-field-underline{background-position:0;background-color:rgba(0,0,0,0)}.cdk-high-contrast-active .mat-form-field-appearance-standard.mat-form-field-disabled .mat-form-field-underline{border-top-style:dotted;border-top-width:2px}.mat-form-field-appearance-standard:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{opacity:1;transform:none;transition:opacity 600ms cubic-bezier(0.25, 0.8, 0.25, 1)}.mat-form-field-appearance-standard._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{transition:none}"]
                }]
              }], function () {
                return [{
                  type: i0.ElementRef
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: i1.Directionality,
                  decorators: [{
                    type: Optional
                  }]
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_LEGACY_FORM_FIELD_DEFAULT_OPTIONS]
                  }]
                }, {
                  type: i2.Platform
                }, {
                  type: i0.NgZone
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [ANIMATION_MODULE_TYPE]
                  }]
                }];
              }, {
                appearance: [{
                  type: Input
                }],
                hideRequiredMarker: [{
                  type: Input
                }],
                hintLabel: [{
                  type: Input
                }],
                floatLabel: [{
                  type: Input
                }],
                _connectionContainerRef: [{
                  type: ViewChild,
                  args: ['connectionContainer', {
                    static: true
                  }]
                }],
                _inputContainerRef: [{
                  type: ViewChild,
                  args: ['inputContainer']
                }],
                _label: [{
                  type: ViewChild,
                  args: ['label']
                }],
                _controlNonStatic: [{
                  type: ContentChild,
                  args: [MatFormFieldControl]
                }],
                _controlStatic: [{
                  type: ContentChild,
                  args: [MatFormFieldControl, {
                    static: true
                  }]
                }],
                _labelChildNonStatic: [{
                  type: ContentChild,
                  args: [MatLegacyLabel]
                }],
                _labelChildStatic: [{
                  type: ContentChild,
                  args: [MatLegacyLabel, {
                    static: true
                  }]
                }],
                _placeholderChild: [{
                  type: ContentChild,
                  args: [MatLegacyPlaceholder]
                }],
                _errorChildren: [{
                  type: ContentChildren,
                  args: [MAT_ERROR, {
                    descendants: true
                  }]
                }],
                _hintChildren: [{
                  type: ContentChildren,
                  args: [_MAT_LEGACY_HINT, {
                    descendants: true
                  }]
                }],
                _prefixChildren: [{
                  type: ContentChildren,
                  args: [MAT_PREFIX, {
                    descendants: true
                  }]
                }],
                _suffixChildren: [{
                  type: ContentChildren,
                  args: [MAT_SUFFIX, {
                    descendants: true
                  }]
                }]
              });
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Prefix to be placed in front of the form field.
             * @deprecated Use `MatPrefix` from `@angular/material/form-field` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyPrefix {} exports('MatLegacyPrefix', MatLegacyPrefix);
            MatLegacyPrefix.ɵfac = function MatLegacyPrefix_Factory(t) {
              return new (t || MatLegacyPrefix)();
            };
            MatLegacyPrefix.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyPrefix,
              selectors: [["", "matPrefix", ""]],
              features: [i0.ɵɵProvidersFeature([{
                provide: MAT_PREFIX,
                useExisting: MatLegacyPrefix
              }])]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyPrefix, [{
                type: Directive,
                args: [{
                  selector: '[matPrefix]',
                  providers: [{
                    provide: MAT_PREFIX,
                    useExisting: MatLegacyPrefix
                  }]
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Suffix to be placed at the end of the form field.
             * @deprecated Use `MatSuffix` from `@angular/material/form-field` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacySuffix {} exports('MatLegacySuffix', MatLegacySuffix);
            MatLegacySuffix.ɵfac = function MatLegacySuffix_Factory(t) {
              return new (t || MatLegacySuffix)();
            };
            MatLegacySuffix.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacySuffix,
              selectors: [["", "matSuffix", ""]],
              features: [i0.ɵɵProvidersFeature([{
                provide: MAT_SUFFIX,
                useExisting: MatLegacySuffix
              }])]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacySuffix, [{
                type: Directive,
                args: [{
                  selector: '[matSuffix]',
                  providers: [{
                    provide: MAT_SUFFIX,
                    useExisting: MatLegacySuffix
                  }]
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * @deprecated Use `MatFormFieldModule` from `@angular/material/form-field` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyFormFieldModule {} exports('MatLegacyFormFieldModule', MatLegacyFormFieldModule);
            MatLegacyFormFieldModule.ɵfac = function MatLegacyFormFieldModule_Factory(t) {
              return new (t || MatLegacyFormFieldModule)();
            };
            MatLegacyFormFieldModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatLegacyFormFieldModule
            });
            MatLegacyFormFieldModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              imports: [CommonModule, MatCommonModule, ObserversModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyFormFieldModule, [{
                type: NgModule,
                args: [{
                  declarations: [MatLegacyError, MatLegacyFormField, MatLegacyHint, MatLegacyLabel, MatLegacyPlaceholder, MatLegacyPrefix, MatLegacySuffix],
                  imports: [CommonModule, MatCommonModule, ObserversModule],
                  exports: [MatCommonModule, MatLegacyError, MatLegacyFormField, MatLegacyHint, MatLegacyLabel, MatLegacyPlaceholder, MatLegacyPrefix, MatLegacySuffix]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-legacy-form-field.js.map
