/* esm-bundle - @angular/material/legacy-paginator@15.2.9 - Ivy - system format - es2020 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/common', '@angular/core', '@angular/material/core', '@angular/material/legacy-button', '@angular/material/legacy-select', '@angular/material/legacy-tooltip', '@angular/material/paginator', '@angular/material/legacy-form-field', '@angular/material/legacy-core'], (function (exports) {
    'use strict';
    var i2, CommonModule, InjectionToken, i0, Component, ChangeDetectionStrategy, ViewEncapsulation, Optional, Inject, NgModule, MatCommonModule, i3, MatLegacyButtonModule, i5, MatLegacySelectModule, i7, MatLegacyTooltipModule, i1, MAT_PAGINATOR_INTL_PROVIDER, _MatPaginatorBase, i4, i6;
    return {
        setters: [function (module) {
            i2 = module;
            CommonModule = module.CommonModule;
        }, function (module) {
            InjectionToken = module.InjectionToken;
            i0 = module;
            Component = module.Component;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            ViewEncapsulation = module.ViewEncapsulation;
            Optional = module.Optional;
            Inject = module.Inject;
            NgModule = module.NgModule;
        }, function (module) {
            MatCommonModule = module.MatCommonModule;
        }, function (module) {
            i3 = module;
            MatLegacyButtonModule = module.MatLegacyButtonModule;
        }, function (module) {
            i5 = module;
            MatLegacySelectModule = module.MatLegacySelectModule;
        }, function (module) {
            i7 = module;
            MatLegacyTooltipModule = module.MatLegacyTooltipModule;
        }, function (module) {
            i1 = module;
            MAT_PAGINATOR_INTL_PROVIDER = module.MAT_PAGINATOR_INTL_PROVIDER;
            _MatPaginatorBase = module._MatPaginatorBase;
            exports({ LegacyPageEvent: module.PageEvent, MAT_LEGACY_PAGINATOR_INTL_PROVIDER: module.MAT_PAGINATOR_INTL_PROVIDER, MAT_LEGACY_PAGINATOR_INTL_PROVIDER_FACTORY: module.MAT_PAGINATOR_INTL_PROVIDER_FACTORY, MatLegacyPaginatorIntl: module.MatPaginatorIntl, _MatLegacyPaginatorBase: module._MatPaginatorBase });
        }, function (module) {
            i4 = module;
        }, function (module) {
            i6 = module;
        }],
        execute: (function () {

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Injection token that can be used to provide the default options for the paginator module.
             * @deprecated Use `MAT_PAGINATOR_DEFAULT_OPTIONS` from `@angular/material/paginator` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            function MatLegacyPaginator_div_2_mat_form_field_3_mat_option_2_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "mat-option", 19);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const pageSizeOption_r6 = ctx.$implicit;
                i0.ɵɵproperty("value", pageSizeOption_r6);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate1(" ", pageSizeOption_r6, " ");
              }
            }
            function MatLegacyPaginator_div_2_mat_form_field_3_Template(rf, ctx) {
              if (rf & 1) {
                const _r8 = i0.ɵɵgetCurrentView();
                i0.ɵɵelementStart(0, "mat-form-field", 16)(1, "mat-select", 17);
                i0.ɵɵlistener("selectionChange", function MatLegacyPaginator_div_2_mat_form_field_3_Template_mat_select_selectionChange_1_listener($event) {
                  i0.ɵɵrestoreView(_r8);
                  const ctx_r7 = i0.ɵɵnextContext(2);
                  return i0.ɵɵresetView(ctx_r7._changePageSize($event.value));
                });
                i0.ɵɵtemplate(2, MatLegacyPaginator_div_2_mat_form_field_3_mat_option_2_Template, 2, 2, "mat-option", 18);
                i0.ɵɵelementEnd()();
              }
              if (rf & 2) {
                const ctx_r3 = i0.ɵɵnextContext(2);
                i0.ɵɵproperty("appearance", ctx_r3._formFieldAppearance)("color", ctx_r3.color);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("value", ctx_r3.pageSize)("disabled", ctx_r3.disabled)("panelClass", ctx_r3.selectConfig.panelClass || "")("disableOptionCentering", ctx_r3.selectConfig.disableOptionCentering)("aria-label", ctx_r3._intl.itemsPerPageLabel);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngForOf", ctx_r3._displayedPageSizeOptions);
              }
            }
            function MatLegacyPaginator_div_2_div_4_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 20);
                i0.ɵɵtext(1);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r4 = i0.ɵɵnextContext(2);
                i0.ɵɵadvance(1);
                i0.ɵɵtextInterpolate(ctx_r4.pageSize);
              }
            }
            function MatLegacyPaginator_div_2_Template(rf, ctx) {
              if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 12)(1, "div", 13);
                i0.ɵɵtext(2);
                i0.ɵɵelementEnd();
                i0.ɵɵtemplate(3, MatLegacyPaginator_div_2_mat_form_field_3_Template, 3, 8, "mat-form-field", 14);
                i0.ɵɵtemplate(4, MatLegacyPaginator_div_2_div_4_Template, 2, 1, "div", 15);
                i0.ɵɵelementEnd();
              }
              if (rf & 2) {
                const ctx_r0 = i0.ɵɵnextContext();
                i0.ɵɵadvance(2);
                i0.ɵɵtextInterpolate1(" ", ctx_r0._intl.itemsPerPageLabel, " ");
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngIf", ctx_r0._displayedPageSizeOptions.length > 1);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("ngIf", ctx_r0._displayedPageSizeOptions.length <= 1);
              }
            }
            function MatLegacyPaginator_button_6_Template(rf, ctx) {
              if (rf & 1) {
                const _r10 = i0.ɵɵgetCurrentView();
                i0.ɵɵelementStart(0, "button", 21);
                i0.ɵɵlistener("click", function MatLegacyPaginator_button_6_Template_button_click_0_listener() {
                  i0.ɵɵrestoreView(_r10);
                  const ctx_r9 = i0.ɵɵnextContext();
                  return i0.ɵɵresetView(ctx_r9.firstPage());
                });
                i0.ɵɵnamespaceSVG();
                i0.ɵɵelementStart(1, "svg", 7);
                i0.ɵɵelement(2, "path", 22);
                i0.ɵɵelementEnd()();
              }
              if (rf & 2) {
                const ctx_r1 = i0.ɵɵnextContext();
                i0.ɵɵproperty("matTooltip", ctx_r1._intl.firstPageLabel)("matTooltipDisabled", ctx_r1._previousButtonsDisabled())("matTooltipPosition", "above")("disabled", ctx_r1._previousButtonsDisabled());
                i0.ɵɵattribute("aria-label", ctx_r1._intl.firstPageLabel);
              }
            }
            function MatLegacyPaginator_button_13_Template(rf, ctx) {
              if (rf & 1) {
                const _r12 = i0.ɵɵgetCurrentView();
                i0.ɵɵnamespaceSVG();
                i0.ɵɵnamespaceHTML();
                i0.ɵɵelementStart(0, "button", 23);
                i0.ɵɵlistener("click", function MatLegacyPaginator_button_13_Template_button_click_0_listener() {
                  i0.ɵɵrestoreView(_r12);
                  const ctx_r11 = i0.ɵɵnextContext();
                  return i0.ɵɵresetView(ctx_r11.lastPage());
                });
                i0.ɵɵnamespaceSVG();
                i0.ɵɵelementStart(1, "svg", 7);
                i0.ɵɵelement(2, "path", 24);
                i0.ɵɵelementEnd()();
              }
              if (rf & 2) {
                const ctx_r2 = i0.ɵɵnextContext();
                i0.ɵɵproperty("matTooltip", ctx_r2._intl.lastPageLabel)("matTooltipDisabled", ctx_r2._nextButtonsDisabled())("matTooltipPosition", "above")("disabled", ctx_r2._nextButtonsDisabled());
                i0.ɵɵattribute("aria-label", ctx_r2._intl.lastPageLabel);
              }
            }
            const MAT_LEGACY_PAGINATOR_DEFAULT_OPTIONS = exports('MAT_LEGACY_PAGINATOR_DEFAULT_OPTIONS', new InjectionToken('MAT_LEGACY_PAGINATOR_DEFAULT_OPTIONS'));
            /**
             * Component to provide navigation between paged information. Displays the size of the current
             * page, user-selectable options to change that size, what items are being shown, and
             * navigational button to go to the previous or next page.
             * @deprecated Use `MatPaginator` from `@angular/material/paginator` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyPaginator extends _MatPaginatorBase {
              constructor(intl, changeDetectorRef, defaults) {
                super(intl, changeDetectorRef, defaults);
                if (defaults && defaults.formFieldAppearance != null) {
                  this._formFieldAppearance = defaults.formFieldAppearance;
                }
              }
            } exports('MatLegacyPaginator', MatLegacyPaginator);
            MatLegacyPaginator.ɵfac = function MatLegacyPaginator_Factory(t) {
              return new (t || MatLegacyPaginator)(i0.ɵɵdirectiveInject(i1.MatPaginatorIntl), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(MAT_LEGACY_PAGINATOR_DEFAULT_OPTIONS, 8));
            };
            MatLegacyPaginator.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatLegacyPaginator,
              selectors: [["mat-paginator"]],
              hostAttrs: ["role", "group", 1, "mat-paginator"],
              inputs: {
                disabled: "disabled"
              },
              exportAs: ["matPaginator"],
              features: [i0.ɵɵInheritDefinitionFeature],
              decls: 14,
              vars: 14,
              consts: [[1, "mat-paginator-outer-container"], [1, "mat-paginator-container"], ["class", "mat-paginator-page-size", 4, "ngIf"], [1, "mat-paginator-range-actions"], [1, "mat-paginator-range-label"], ["mat-icon-button", "", "type", "button", "class", "mat-paginator-navigation-first", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click", 4, "ngIf"], ["mat-icon-button", "", "type", "button", 1, "mat-paginator-navigation-previous", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click"], ["viewBox", "0 0 24 24", "focusable", "false", 1, "mat-paginator-icon"], ["d", "M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z"], ["mat-icon-button", "", "type", "button", 1, "mat-paginator-navigation-next", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click"], ["d", "M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z"], ["mat-icon-button", "", "type", "button", "class", "mat-paginator-navigation-last", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click", 4, "ngIf"], [1, "mat-paginator-page-size"], [1, "mat-paginator-page-size-label"], ["class", "mat-paginator-page-size-select", 3, "appearance", "color", 4, "ngIf"], ["class", "mat-paginator-page-size-value", 4, "ngIf"], [1, "mat-paginator-page-size-select", 3, "appearance", "color"], [3, "value", "disabled", "panelClass", "disableOptionCentering", "aria-label", "selectionChange"], [3, "value", 4, "ngFor", "ngForOf"], [3, "value"], [1, "mat-paginator-page-size-value"], ["mat-icon-button", "", "type", "button", 1, "mat-paginator-navigation-first", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click"], ["d", "M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z"], ["mat-icon-button", "", "type", "button", 1, "mat-paginator-navigation-last", 3, "matTooltip", "matTooltipDisabled", "matTooltipPosition", "disabled", "click"], ["d", "M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z"]],
              template: function MatLegacyPaginator_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵelementStart(0, "div", 0)(1, "div", 1);
                  i0.ɵɵtemplate(2, MatLegacyPaginator_div_2_Template, 5, 3, "div", 2);
                  i0.ɵɵelementStart(3, "div", 3)(4, "div", 4);
                  i0.ɵɵtext(5);
                  i0.ɵɵelementEnd();
                  i0.ɵɵtemplate(6, MatLegacyPaginator_button_6_Template, 3, 5, "button", 5);
                  i0.ɵɵelementStart(7, "button", 6);
                  i0.ɵɵlistener("click", function MatLegacyPaginator_Template_button_click_7_listener() {
                    return ctx.previousPage();
                  });
                  i0.ɵɵnamespaceSVG();
                  i0.ɵɵelementStart(8, "svg", 7);
                  i0.ɵɵelement(9, "path", 8);
                  i0.ɵɵelementEnd()();
                  i0.ɵɵnamespaceHTML();
                  i0.ɵɵelementStart(10, "button", 9);
                  i0.ɵɵlistener("click", function MatLegacyPaginator_Template_button_click_10_listener() {
                    return ctx.nextPage();
                  });
                  i0.ɵɵnamespaceSVG();
                  i0.ɵɵelementStart(11, "svg", 7);
                  i0.ɵɵelement(12, "path", 10);
                  i0.ɵɵelementEnd()();
                  i0.ɵɵtemplate(13, MatLegacyPaginator_button_13_Template, 3, 5, "button", 11);
                  i0.ɵɵelementEnd()()();
                }
                if (rf & 2) {
                  i0.ɵɵadvance(2);
                  i0.ɵɵproperty("ngIf", !ctx.hidePageSize);
                  i0.ɵɵadvance(3);
                  i0.ɵɵtextInterpolate1(" ", ctx._intl.getRangeLabel(ctx.pageIndex, ctx.pageSize, ctx.length), " ");
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngIf", ctx.showFirstLastButtons);
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("matTooltip", ctx._intl.previousPageLabel)("matTooltipDisabled", ctx._previousButtonsDisabled())("matTooltipPosition", "above")("disabled", ctx._previousButtonsDisabled());
                  i0.ɵɵattribute("aria-label", ctx._intl.previousPageLabel);
                  i0.ɵɵadvance(3);
                  i0.ɵɵproperty("matTooltip", ctx._intl.nextPageLabel)("matTooltipDisabled", ctx._nextButtonsDisabled())("matTooltipPosition", "above")("disabled", ctx._nextButtonsDisabled());
                  i0.ɵɵattribute("aria-label", ctx._intl.nextPageLabel);
                  i0.ɵɵadvance(3);
                  i0.ɵɵproperty("ngIf", ctx.showFirstLastButtons);
                }
              },
              dependencies: [i2.NgForOf, i2.NgIf, i3.MatLegacyButton, i4.MatLegacyFormField, i5.MatLegacySelect, i6.MatLegacyOption, i7.MatLegacyTooltip],
              styles: [".mat-paginator{display:block}.mat-paginator-outer-container{display:flex}.mat-paginator-container{display:flex;align-items:center;justify-content:flex-end;padding:0 8px;flex-wrap:wrap-reverse;width:100%}.mat-paginator-page-size{display:flex;align-items:baseline;margin-right:8px}[dir=rtl] .mat-paginator-page-size{margin-right:0;margin-left:8px}.mat-paginator-page-size-label{margin:0 4px}.mat-paginator-page-size-select{margin:6px 4px 0 4px;width:56px}.mat-paginator-page-size-select.mat-form-field-appearance-outline{width:64px}.mat-paginator-page-size-select.mat-form-field-appearance-fill{width:64px}.mat-paginator-range-label{margin:0 32px 0 24px}.mat-paginator-range-actions{display:flex;align-items:center}.mat-paginator-icon{display:inline-block;width:28px;fill:currentColor}[dir=rtl] .mat-paginator-icon{transform:rotate(180deg)}.cdk-high-contrast-active .mat-paginator-icon{fill:CanvasText}"],
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyPaginator, [{
                type: Component,
                args: [{
                  selector: 'mat-paginator',
                  exportAs: 'matPaginator',
                  inputs: ['disabled'],
                  host: {
                    'class': 'mat-paginator',
                    'role': 'group'
                  },
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  encapsulation: ViewEncapsulation.None,
                  template: "<div class=\"mat-paginator-outer-container\">\n  <div class=\"mat-paginator-container\">\n    <div class=\"mat-paginator-page-size\" *ngIf=\"!hidePageSize\">\n      <div class=\"mat-paginator-page-size-label\">\n        {{_intl.itemsPerPageLabel}}\n      </div>\n\n      <mat-form-field\n        *ngIf=\"_displayedPageSizeOptions.length > 1\"\n        [appearance]=\"_formFieldAppearance!\"\n        [color]=\"color\"\n        class=\"mat-paginator-page-size-select\">\n        <mat-select\n          [value]=\"pageSize\"\n          [disabled]=\"disabled\"\n          [panelClass]=\"selectConfig.panelClass || ''\"\n          [disableOptionCentering]=\"selectConfig.disableOptionCentering\"\n          [aria-label]=\"_intl.itemsPerPageLabel\"\n          (selectionChange)=\"_changePageSize($event.value)\">\n          <mat-option *ngFor=\"let pageSizeOption of _displayedPageSizeOptions\" [value]=\"pageSizeOption\">\n            {{pageSizeOption}}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n\n      <div\n        class=\"mat-paginator-page-size-value\"\n        *ngIf=\"_displayedPageSizeOptions.length <= 1\">{{pageSize}}</div>\n    </div>\n\n    <div class=\"mat-paginator-range-actions\">\n      <div class=\"mat-paginator-range-label\">\n        {{_intl.getRangeLabel(pageIndex, pageSize, length)}}\n      </div>\n\n      <button mat-icon-button type=\"button\"\n              class=\"mat-paginator-navigation-first\"\n              (click)=\"firstPage()\"\n              [attr.aria-label]=\"_intl.firstPageLabel\"\n              [matTooltip]=\"_intl.firstPageLabel\"\n              [matTooltipDisabled]=\"_previousButtonsDisabled()\"\n              [matTooltipPosition]=\"'above'\"\n              [disabled]=\"_previousButtonsDisabled()\"\n              *ngIf=\"showFirstLastButtons\">\n        <svg class=\"mat-paginator-icon\" viewBox=\"0 0 24 24\" focusable=\"false\">\n          <path d=\"M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z\"/>\n        </svg>\n      </button>\n      <button mat-icon-button type=\"button\"\n              class=\"mat-paginator-navigation-previous\"\n              (click)=\"previousPage()\"\n              [attr.aria-label]=\"_intl.previousPageLabel\"\n              [matTooltip]=\"_intl.previousPageLabel\"\n              [matTooltipDisabled]=\"_previousButtonsDisabled()\"\n              [matTooltipPosition]=\"'above'\"\n              [disabled]=\"_previousButtonsDisabled()\">\n        <svg class=\"mat-paginator-icon\" viewBox=\"0 0 24 24\" focusable=\"false\">\n          <path d=\"M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z\"/>\n        </svg>\n      </button>\n      <button mat-icon-button type=\"button\"\n              class=\"mat-paginator-navigation-next\"\n              (click)=\"nextPage()\"\n              [attr.aria-label]=\"_intl.nextPageLabel\"\n              [matTooltip]=\"_intl.nextPageLabel\"\n              [matTooltipDisabled]=\"_nextButtonsDisabled()\"\n              [matTooltipPosition]=\"'above'\"\n              [disabled]=\"_nextButtonsDisabled()\">\n        <svg class=\"mat-paginator-icon\" viewBox=\"0 0 24 24\" focusable=\"false\">\n          <path d=\"M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z\"/>\n        </svg>\n      </button>\n      <button mat-icon-button type=\"button\"\n              class=\"mat-paginator-navigation-last\"\n              (click)=\"lastPage()\"\n              [attr.aria-label]=\"_intl.lastPageLabel\"\n              [matTooltip]=\"_intl.lastPageLabel\"\n              [matTooltipDisabled]=\"_nextButtonsDisabled()\"\n              [matTooltipPosition]=\"'above'\"\n              [disabled]=\"_nextButtonsDisabled()\"\n              *ngIf=\"showFirstLastButtons\">\n        <svg class=\"mat-paginator-icon\" viewBox=\"0 0 24 24\" focusable=\"false\">\n          <path d=\"M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z\"/>\n        </svg>\n      </button>\n    </div>\n  </div>\n</div>\n",
                  styles: [".mat-paginator{display:block}.mat-paginator-outer-container{display:flex}.mat-paginator-container{display:flex;align-items:center;justify-content:flex-end;padding:0 8px;flex-wrap:wrap-reverse;width:100%}.mat-paginator-page-size{display:flex;align-items:baseline;margin-right:8px}[dir=rtl] .mat-paginator-page-size{margin-right:0;margin-left:8px}.mat-paginator-page-size-label{margin:0 4px}.mat-paginator-page-size-select{margin:6px 4px 0 4px;width:56px}.mat-paginator-page-size-select.mat-form-field-appearance-outline{width:64px}.mat-paginator-page-size-select.mat-form-field-appearance-fill{width:64px}.mat-paginator-range-label{margin:0 32px 0 24px}.mat-paginator-range-actions{display:flex;align-items:center}.mat-paginator-icon{display:inline-block;width:28px;fill:currentColor}[dir=rtl] .mat-paginator-icon{transform:rotate(180deg)}.cdk-high-contrast-active .mat-paginator-icon{fill:CanvasText}"]
                }]
              }], function () {
                return [{
                  type: i1.MatPaginatorIntl
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_LEGACY_PAGINATOR_DEFAULT_OPTIONS]
                  }]
                }];
              }, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * @deprecated Use `MatPaginatorModule` from `@angular/material/paginator` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyPaginatorModule {} exports('MatLegacyPaginatorModule', MatLegacyPaginatorModule);
            MatLegacyPaginatorModule.ɵfac = function MatLegacyPaginatorModule_Factory(t) {
              return new (t || MatLegacyPaginatorModule)();
            };
            MatLegacyPaginatorModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatLegacyPaginatorModule
            });
            MatLegacyPaginatorModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              providers: [MAT_PAGINATOR_INTL_PROVIDER],
              imports: [CommonModule, MatLegacyButtonModule, MatLegacySelectModule, MatLegacyTooltipModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyPaginatorModule, [{
                type: NgModule,
                args: [{
                  imports: [CommonModule, MatLegacyButtonModule, MatLegacySelectModule, MatLegacyTooltipModule, MatCommonModule],
                  exports: [MatLegacyPaginator],
                  declarations: [MatLegacyPaginator],
                  providers: [MAT_PAGINATOR_INTL_PROVIDER]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-legacy-paginator.js.map
