/* esm-bundle - @angular/material/legacy-table@15.2.9 - Ivy - system format - es2020 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/core', '@angular/cdk/table', '@angular/cdk/collections', '@angular/material/core', '@angular/material/table'], (function (exports) {
  'use strict';
  var i0, Directive, Component, ViewEncapsulation, ChangeDetectionStrategy, Input, NgModule, CdkTable, CDK_TABLE, _COALESCED_STYLE_SCHEDULER, _CoalescedStyleScheduler, STICKY_POSITIONING_LISTENER, i1, CDK_TABLE_TEMPLATE, CdkCellDef, CdkHeaderCellDef, CdkFooterCellDef, CdkColumnDef, CdkHeaderRowDef, CdkFooterRowDef, CdkRowDef, CdkHeaderRow, CDK_ROW_TEMPLATE, CdkFooterRow, CdkRow, CdkNoDataRow, CdkTableModule, CdkHeaderCell, CdkFooterCell, CdkCell, CdkTextColumn, _VIEW_REPEATER_STRATEGY, _RecycleViewRepeaterStrategy, _DisposeViewRepeaterStrategy, MatCommonModule, _MatTableDataSource;
  return {
    setters: [function (module) {
      i0 = module;
      Directive = module.Directive;
      Component = module.Component;
      ViewEncapsulation = module.ViewEncapsulation;
      ChangeDetectionStrategy = module.ChangeDetectionStrategy;
      Input = module.Input;
      NgModule = module.NgModule;
    }, function (module) {
      CdkTable = module.CdkTable;
      CDK_TABLE = module.CDK_TABLE;
      _COALESCED_STYLE_SCHEDULER = module._COALESCED_STYLE_SCHEDULER;
      _CoalescedStyleScheduler = module._CoalescedStyleScheduler;
      STICKY_POSITIONING_LISTENER = module.STICKY_POSITIONING_LISTENER;
      i1 = module;
      CDK_TABLE_TEMPLATE = module.CDK_TABLE_TEMPLATE;
      CdkCellDef = module.CdkCellDef;
      CdkHeaderCellDef = module.CdkHeaderCellDef;
      CdkFooterCellDef = module.CdkFooterCellDef;
      CdkColumnDef = module.CdkColumnDef;
      CdkHeaderRowDef = module.CdkHeaderRowDef;
      CdkFooterRowDef = module.CdkFooterRowDef;
      CdkRowDef = module.CdkRowDef;
      CdkHeaderRow = module.CdkHeaderRow;
      CDK_ROW_TEMPLATE = module.CDK_ROW_TEMPLATE;
      CdkFooterRow = module.CdkFooterRow;
      CdkRow = module.CdkRow;
      CdkNoDataRow = module.CdkNoDataRow;
      CdkTableModule = module.CdkTableModule;
      CdkHeaderCell = module.CdkHeaderCell;
      CdkFooterCell = module.CdkFooterCell;
      CdkCell = module.CdkCell;
      CdkTextColumn = module.CdkTextColumn;
    }, function (module) {
      _VIEW_REPEATER_STRATEGY = module._VIEW_REPEATER_STRATEGY;
      _RecycleViewRepeaterStrategy = module._RecycleViewRepeaterStrategy;
      _DisposeViewRepeaterStrategy = module._DisposeViewRepeaterStrategy;
    }, function (module) {
      MatCommonModule = module.MatCommonModule;
    }, function (module) {
      _MatTableDataSource = module._MatTableDataSource;
      exports('_MatLegacyTableDataSource', module._MatTableDataSource);
    }],
    execute: (function () {

      const _c0 = [[["caption"]], [["colgroup"], ["col"]]];
      const _c1 = ["caption", "colgroup, col"];
      function MatLegacyTextColumn_th_1_Template(rf, ctx) {
        if (rf & 1) {
          i0.ɵɵelementStart(0, "th", 3);
          i0.ɵɵtext(1);
          i0.ɵɵelementEnd();
        }
        if (rf & 2) {
          const ctx_r0 = i0.ɵɵnextContext();
          i0.ɵɵstyleProp("text-align", ctx_r0.justify);
          i0.ɵɵadvance(1);
          i0.ɵɵtextInterpolate1(" ", ctx_r0.headerText, " ");
        }
      }
      function MatLegacyTextColumn_td_2_Template(rf, ctx) {
        if (rf & 1) {
          i0.ɵɵelementStart(0, "td", 4);
          i0.ɵɵtext(1);
          i0.ɵɵelementEnd();
        }
        if (rf & 2) {
          const data_r2 = ctx.$implicit;
          const ctx_r1 = i0.ɵɵnextContext();
          i0.ɵɵstyleProp("text-align", ctx_r1.justify);
          i0.ɵɵadvance(1);
          i0.ɵɵtextInterpolate1(" ", ctx_r1.dataAccessor(data_r2, ctx_r1.name), " ");
        }
      }

      /**
       * @license
       * Copyright Google LLC All Rights Reserved.
       *
       * Use of this source code is governed by an MIT-style license that can be
       * found in the LICENSE file at https://angular.io/license
       */
      /**
       * Enables the recycle view repeater strategy, which reduces rendering latency. Not compatible with
       * tables that animate rows.
       * @deprecated Use `MatRecycleRows` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyRecycleRows {} exports('MatLegacyRecycleRows', MatLegacyRecycleRows);
      MatLegacyRecycleRows.ɵfac = function MatLegacyRecycleRows_Factory(t) {
        return new (t || MatLegacyRecycleRows)();
      };
      MatLegacyRecycleRows.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyRecycleRows,
        selectors: [["mat-table", "recycleRows", ""], ["table", "mat-table", "", "recycleRows", ""]],
        features: [i0.ɵɵProvidersFeature([{
          provide: _VIEW_REPEATER_STRATEGY,
          useClass: _RecycleViewRepeaterStrategy
        }])]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyRecycleRows, [{
          type: Directive,
          args: [{
            selector: 'mat-table[recycleRows], table[mat-table][recycleRows]',
            providers: [{
              provide: _VIEW_REPEATER_STRATEGY,
              useClass: _RecycleViewRepeaterStrategy
            }]
          }]
        }], null, null);
      })();
      /**
       * Wrapper for the CdkTable with Material design styles.
       * @deprecated Use `MatTable` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyTable extends CdkTable {
        constructor() {
          super(...arguments);
          /** Overrides the sticky CSS class set by the `CdkTable`. */
          this.stickyCssClass = 'mat-table-sticky';
          /** Overrides the need to add position: sticky on every sticky cell element in `CdkTable`. */
          this.needsPositionStickyOnElement = false;
        }
      } exports('MatLegacyTable', MatLegacyTable);
      MatLegacyTable.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyTable_BaseFactory;
        return function MatLegacyTable_Factory(t) {
          return (ɵMatLegacyTable_BaseFactory || (ɵMatLegacyTable_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyTable)))(t || MatLegacyTable);
        };
      }();
      MatLegacyTable.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
        type: MatLegacyTable,
        selectors: [["mat-table"], ["table", "mat-table", ""]],
        hostAttrs: [1, "mat-table"],
        hostVars: 2,
        hostBindings: function MatLegacyTable_HostBindings(rf, ctx) {
          if (rf & 2) {
            i0.ɵɵclassProp("mat-table-fixed-layout", ctx.fixedLayout);
          }
        },
        exportAs: ["matTable"],
        features: [i0.ɵɵProvidersFeature([
        // TODO(michaeljamesparsons) Abstract the view repeater strategy to a directive API so this code
        //  is only included in the build if used.
        {
          provide: _VIEW_REPEATER_STRATEGY,
          useClass: _DisposeViewRepeaterStrategy
        }, {
          provide: CdkTable,
          useExisting: MatLegacyTable
        }, {
          provide: CDK_TABLE,
          useExisting: MatLegacyTable
        }, {
          provide: _COALESCED_STYLE_SCHEDULER,
          useClass: _CoalescedStyleScheduler
        },
        // Prevent nested tables from seeing this table's StickyPositioningListener.
        {
          provide: STICKY_POSITIONING_LISTENER,
          useValue: null
        }]), i0.ɵɵInheritDefinitionFeature],
        ngContentSelectors: _c1,
        decls: 6,
        vars: 0,
        consts: [["headerRowOutlet", ""], ["rowOutlet", ""], ["noDataRowOutlet", ""], ["footerRowOutlet", ""]],
        template: function MatLegacyTable_Template(rf, ctx) {
          if (rf & 1) {
            i0.ɵɵprojectionDef(_c0);
            i0.ɵɵprojection(0);
            i0.ɵɵprojection(1, 1);
            i0.ɵɵelementContainer(2, 0)(3, 1)(4, 2)(5, 3);
          }
        },
        dependencies: [i1.DataRowOutlet, i1.HeaderRowOutlet, i1.FooterRowOutlet, i1.NoDataRowOutlet],
        styles: ["mat-table{display:block}mat-header-row{min-height:56px}mat-row,mat-footer-row{min-height:48px}mat-row,mat-header-row,mat-footer-row{display:flex;border-width:0;border-bottom-width:1px;border-style:solid;align-items:center;box-sizing:border-box}mat-cell:first-of-type,mat-header-cell:first-of-type,mat-footer-cell:first-of-type{padding-left:24px}[dir=rtl] mat-cell:first-of-type:not(:only-of-type),[dir=rtl] mat-header-cell:first-of-type:not(:only-of-type),[dir=rtl] mat-footer-cell:first-of-type:not(:only-of-type){padding-left:0;padding-right:24px}mat-cell:last-of-type,mat-header-cell:last-of-type,mat-footer-cell:last-of-type{padding-right:24px}[dir=rtl] mat-cell:last-of-type:not(:only-of-type),[dir=rtl] mat-header-cell:last-of-type:not(:only-of-type),[dir=rtl] mat-footer-cell:last-of-type:not(:only-of-type){padding-right:0;padding-left:24px}mat-cell,mat-header-cell,mat-footer-cell{flex:1;display:flex;align-items:center;overflow:hidden;word-wrap:break-word;min-height:inherit}table.mat-table{border-spacing:0}tr.mat-header-row{height:56px}tr.mat-row,tr.mat-footer-row{height:48px}th.mat-header-cell{text-align:left}[dir=rtl] th.mat-header-cell{text-align:right}th.mat-header-cell,td.mat-cell,td.mat-footer-cell{padding:0;border-bottom-width:1px;border-bottom-style:solid}th.mat-header-cell:first-of-type,td.mat-cell:first-of-type,td.mat-footer-cell:first-of-type{padding-left:24px}[dir=rtl] th.mat-header-cell:first-of-type:not(:only-of-type),[dir=rtl] td.mat-cell:first-of-type:not(:only-of-type),[dir=rtl] td.mat-footer-cell:first-of-type:not(:only-of-type){padding-left:0;padding-right:24px}th.mat-header-cell:last-of-type,td.mat-cell:last-of-type,td.mat-footer-cell:last-of-type{padding-right:24px}[dir=rtl] th.mat-header-cell:last-of-type:not(:only-of-type),[dir=rtl] td.mat-cell:last-of-type:not(:only-of-type),[dir=rtl] td.mat-footer-cell:last-of-type:not(:only-of-type){padding-right:0;padding-left:24px}.mat-table-sticky{position:sticky !important}.mat-table-fixed-layout{table-layout:fixed}"],
        encapsulation: 2
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyTable, [{
          type: Component,
          args: [{
            selector: 'mat-table, table[mat-table]',
            exportAs: 'matTable',
            template: CDK_TABLE_TEMPLATE,
            host: {
              'class': 'mat-table',
              '[class.mat-table-fixed-layout]': 'fixedLayout'
            },
            providers: [
            // TODO(michaeljamesparsons) Abstract the view repeater strategy to a directive API so this code
            //  is only included in the build if used.
            {
              provide: _VIEW_REPEATER_STRATEGY,
              useClass: _DisposeViewRepeaterStrategy
            }, {
              provide: CdkTable,
              useExisting: MatLegacyTable
            }, {
              provide: CDK_TABLE,
              useExisting: MatLegacyTable
            }, {
              provide: _COALESCED_STYLE_SCHEDULER,
              useClass: _CoalescedStyleScheduler
            },
            // Prevent nested tables from seeing this table's StickyPositioningListener.
            {
              provide: STICKY_POSITIONING_LISTENER,
              useValue: null
            }],
            encapsulation: ViewEncapsulation.None,
            changeDetection: ChangeDetectionStrategy.Default,
            styles: ["mat-table{display:block}mat-header-row{min-height:56px}mat-row,mat-footer-row{min-height:48px}mat-row,mat-header-row,mat-footer-row{display:flex;border-width:0;border-bottom-width:1px;border-style:solid;align-items:center;box-sizing:border-box}mat-cell:first-of-type,mat-header-cell:first-of-type,mat-footer-cell:first-of-type{padding-left:24px}[dir=rtl] mat-cell:first-of-type:not(:only-of-type),[dir=rtl] mat-header-cell:first-of-type:not(:only-of-type),[dir=rtl] mat-footer-cell:first-of-type:not(:only-of-type){padding-left:0;padding-right:24px}mat-cell:last-of-type,mat-header-cell:last-of-type,mat-footer-cell:last-of-type{padding-right:24px}[dir=rtl] mat-cell:last-of-type:not(:only-of-type),[dir=rtl] mat-header-cell:last-of-type:not(:only-of-type),[dir=rtl] mat-footer-cell:last-of-type:not(:only-of-type){padding-right:0;padding-left:24px}mat-cell,mat-header-cell,mat-footer-cell{flex:1;display:flex;align-items:center;overflow:hidden;word-wrap:break-word;min-height:inherit}table.mat-table{border-spacing:0}tr.mat-header-row{height:56px}tr.mat-row,tr.mat-footer-row{height:48px}th.mat-header-cell{text-align:left}[dir=rtl] th.mat-header-cell{text-align:right}th.mat-header-cell,td.mat-cell,td.mat-footer-cell{padding:0;border-bottom-width:1px;border-bottom-style:solid}th.mat-header-cell:first-of-type,td.mat-cell:first-of-type,td.mat-footer-cell:first-of-type{padding-left:24px}[dir=rtl] th.mat-header-cell:first-of-type:not(:only-of-type),[dir=rtl] td.mat-cell:first-of-type:not(:only-of-type),[dir=rtl] td.mat-footer-cell:first-of-type:not(:only-of-type){padding-left:0;padding-right:24px}th.mat-header-cell:last-of-type,td.mat-cell:last-of-type,td.mat-footer-cell:last-of-type{padding-right:24px}[dir=rtl] th.mat-header-cell:last-of-type:not(:only-of-type),[dir=rtl] td.mat-cell:last-of-type:not(:only-of-type),[dir=rtl] td.mat-footer-cell:last-of-type:not(:only-of-type){padding-right:0;padding-left:24px}.mat-table-sticky{position:sticky !important}.mat-table-fixed-layout{table-layout:fixed}"]
          }]
        }], null, null);
      })();

      /**
       * @license
       * Copyright Google LLC All Rights Reserved.
       *
       * Use of this source code is governed by an MIT-style license that can be
       * found in the LICENSE file at https://angular.io/license
       */
      /**
       * Cell definition for the mat-table.
       * Captures the template of a column's data row cell as well as cell-specific properties.
       * @deprecated Use `MatCellDef` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyCellDef extends CdkCellDef {} exports('MatLegacyCellDef', MatLegacyCellDef);
      MatLegacyCellDef.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyCellDef_BaseFactory;
        return function MatLegacyCellDef_Factory(t) {
          return (ɵMatLegacyCellDef_BaseFactory || (ɵMatLegacyCellDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyCellDef)))(t || MatLegacyCellDef);
        };
      }();
      MatLegacyCellDef.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyCellDef,
        selectors: [["", "matCellDef", ""]],
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkCellDef,
          useExisting: MatLegacyCellDef
        }]), i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCellDef, [{
          type: Directive,
          args: [{
            selector: '[matCellDef]',
            providers: [{
              provide: CdkCellDef,
              useExisting: MatLegacyCellDef
            }]
          }]
        }], null, null);
      })();
      /**
       * Header cell definition for the mat-table.
       * Captures the template of a column's header cell and as well as cell-specific properties.
       * @deprecated Use `MatHeaderCellDef` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyHeaderCellDef extends CdkHeaderCellDef {} exports('MatLegacyHeaderCellDef', MatLegacyHeaderCellDef);
      MatLegacyHeaderCellDef.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyHeaderCellDef_BaseFactory;
        return function MatLegacyHeaderCellDef_Factory(t) {
          return (ɵMatLegacyHeaderCellDef_BaseFactory || (ɵMatLegacyHeaderCellDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyHeaderCellDef)))(t || MatLegacyHeaderCellDef);
        };
      }();
      MatLegacyHeaderCellDef.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyHeaderCellDef,
        selectors: [["", "matHeaderCellDef", ""]],
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkHeaderCellDef,
          useExisting: MatLegacyHeaderCellDef
        }]), i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyHeaderCellDef, [{
          type: Directive,
          args: [{
            selector: '[matHeaderCellDef]',
            providers: [{
              provide: CdkHeaderCellDef,
              useExisting: MatLegacyHeaderCellDef
            }]
          }]
        }], null, null);
      })();
      /**
       * Footer cell definition for the mat-table.
       * Captures the template of a column's footer cell and as well as cell-specific properties.
       * @deprecated Use `MatFooterCellDef` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyFooterCellDef extends CdkFooterCellDef {} exports('MatLegacyFooterCellDef', MatLegacyFooterCellDef);
      MatLegacyFooterCellDef.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyFooterCellDef_BaseFactory;
        return function MatLegacyFooterCellDef_Factory(t) {
          return (ɵMatLegacyFooterCellDef_BaseFactory || (ɵMatLegacyFooterCellDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyFooterCellDef)))(t || MatLegacyFooterCellDef);
        };
      }();
      MatLegacyFooterCellDef.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyFooterCellDef,
        selectors: [["", "matFooterCellDef", ""]],
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkFooterCellDef,
          useExisting: MatLegacyFooterCellDef
        }]), i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyFooterCellDef, [{
          type: Directive,
          args: [{
            selector: '[matFooterCellDef]',
            providers: [{
              provide: CdkFooterCellDef,
              useExisting: MatLegacyFooterCellDef
            }]
          }]
        }], null, null);
      })();
      /**
       * Column definition for the mat-table.
       * Defines a set of cells available for a table column.
       * @deprecated Use `MatColumnDef` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyColumnDef extends CdkColumnDef {
        /** Unique name for this column. */
        get name() {
          return this._name;
        }
        set name(name) {
          this._setNameInput(name);
        }
        /**
         * Add "mat-column-" prefix in addition to "cdk-column-" prefix.
         * In the future, this will only add "mat-column-" and columnCssClassName
         * will change from type string[] to string.
         * @docs-private
         */
        _updateColumnCssClassName() {
          super._updateColumnCssClassName();
          this._columnCssClassName.push(`mat-column-${this.cssClassFriendlyName}`);
        }
      } exports('MatLegacyColumnDef', MatLegacyColumnDef);
      MatLegacyColumnDef.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyColumnDef_BaseFactory;
        return function MatLegacyColumnDef_Factory(t) {
          return (ɵMatLegacyColumnDef_BaseFactory || (ɵMatLegacyColumnDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyColumnDef)))(t || MatLegacyColumnDef);
        };
      }();
      MatLegacyColumnDef.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyColumnDef,
        selectors: [["", "matColumnDef", ""]],
        inputs: {
          sticky: "sticky",
          name: ["matColumnDef", "name"]
        },
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkColumnDef,
          useExisting: MatLegacyColumnDef
        }, {
          provide: 'MAT_SORT_HEADER_COLUMN_DEF',
          useExisting: MatLegacyColumnDef
        }]), i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyColumnDef, [{
          type: Directive,
          args: [{
            selector: '[matColumnDef]',
            inputs: ['sticky'],
            providers: [{
              provide: CdkColumnDef,
              useExisting: MatLegacyColumnDef
            }, {
              provide: 'MAT_SORT_HEADER_COLUMN_DEF',
              useExisting: MatLegacyColumnDef
            }]
          }]
        }], null, {
          name: [{
            type: Input,
            args: ['matColumnDef']
          }]
        });
      })();
      /**
       * Header cell template container that adds the right classes and role.
       * @deprecated Use `MatHeaderCell` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyHeaderCell extends CdkHeaderCell {} exports('MatLegacyHeaderCell', MatLegacyHeaderCell);
      MatLegacyHeaderCell.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyHeaderCell_BaseFactory;
        return function MatLegacyHeaderCell_Factory(t) {
          return (ɵMatLegacyHeaderCell_BaseFactory || (ɵMatLegacyHeaderCell_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyHeaderCell)))(t || MatLegacyHeaderCell);
        };
      }();
      MatLegacyHeaderCell.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyHeaderCell,
        selectors: [["mat-header-cell"], ["th", "mat-header-cell", ""]],
        hostAttrs: ["role", "columnheader", 1, "mat-header-cell"],
        features: [i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyHeaderCell, [{
          type: Directive,
          args: [{
            selector: 'mat-header-cell, th[mat-header-cell]',
            host: {
              'class': 'mat-header-cell',
              'role': 'columnheader'
            }
          }]
        }], null, null);
      })();
      /**
       * Footer cell template container that adds the right classes and role.
       * @deprecated Use `MatFooterCell` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyFooterCell extends CdkFooterCell {} exports('MatLegacyFooterCell', MatLegacyFooterCell);
      MatLegacyFooterCell.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyFooterCell_BaseFactory;
        return function MatLegacyFooterCell_Factory(t) {
          return (ɵMatLegacyFooterCell_BaseFactory || (ɵMatLegacyFooterCell_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyFooterCell)))(t || MatLegacyFooterCell);
        };
      }();
      MatLegacyFooterCell.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyFooterCell,
        selectors: [["mat-footer-cell"], ["td", "mat-footer-cell", ""]],
        hostAttrs: ["role", "gridcell", 1, "mat-footer-cell"],
        features: [i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyFooterCell, [{
          type: Directive,
          args: [{
            selector: 'mat-footer-cell, td[mat-footer-cell]',
            host: {
              'class': 'mat-footer-cell',
              'role': 'gridcell'
            }
          }]
        }], null, null);
      })();
      /**
       * Cell template container that adds the right classes and role.
       * @deprecated Use `MatCell` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyCell extends CdkCell {} exports('MatLegacyCell', MatLegacyCell);
      MatLegacyCell.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyCell_BaseFactory;
        return function MatLegacyCell_Factory(t) {
          return (ɵMatLegacyCell_BaseFactory || (ɵMatLegacyCell_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyCell)))(t || MatLegacyCell);
        };
      }();
      MatLegacyCell.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyCell,
        selectors: [["mat-cell"], ["td", "mat-cell", ""]],
        hostAttrs: ["role", "gridcell", 1, "mat-cell"],
        features: [i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCell, [{
          type: Directive,
          args: [{
            selector: 'mat-cell, td[mat-cell]',
            host: {
              'class': 'mat-cell',
              'role': 'gridcell'
            }
          }]
        }], null, null);
      })();

      /**
       * @license
       * Copyright Google LLC All Rights Reserved.
       *
       * Use of this source code is governed by an MIT-style license that can be
       * found in the LICENSE file at https://angular.io/license
       */
      /**
       * Header row definition for the mat-table.
       * Captures the header row's template and other header properties such as the columns to display.
       * @deprecated Use `MatHeaderRowDef` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyHeaderRowDef extends CdkHeaderRowDef {} exports('MatLegacyHeaderRowDef', MatLegacyHeaderRowDef);
      MatLegacyHeaderRowDef.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyHeaderRowDef_BaseFactory;
        return function MatLegacyHeaderRowDef_Factory(t) {
          return (ɵMatLegacyHeaderRowDef_BaseFactory || (ɵMatLegacyHeaderRowDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyHeaderRowDef)))(t || MatLegacyHeaderRowDef);
        };
      }();
      MatLegacyHeaderRowDef.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyHeaderRowDef,
        selectors: [["", "matHeaderRowDef", ""]],
        inputs: {
          columns: ["matHeaderRowDef", "columns"],
          sticky: ["matHeaderRowDefSticky", "sticky"]
        },
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkHeaderRowDef,
          useExisting: MatLegacyHeaderRowDef
        }]), i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyHeaderRowDef, [{
          type: Directive,
          args: [{
            selector: '[matHeaderRowDef]',
            providers: [{
              provide: CdkHeaderRowDef,
              useExisting: MatLegacyHeaderRowDef
            }],
            inputs: ['columns: matHeaderRowDef', 'sticky: matHeaderRowDefSticky']
          }]
        }], null, null);
      })();
      /**
       * Footer row definition for the mat-table.
       * Captures the footer row's template and other footer properties such as the columns to display.
       * @deprecated Use `MatFooterRowDef` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyFooterRowDef extends CdkFooterRowDef {} exports('MatLegacyFooterRowDef', MatLegacyFooterRowDef);
      MatLegacyFooterRowDef.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyFooterRowDef_BaseFactory;
        return function MatLegacyFooterRowDef_Factory(t) {
          return (ɵMatLegacyFooterRowDef_BaseFactory || (ɵMatLegacyFooterRowDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyFooterRowDef)))(t || MatLegacyFooterRowDef);
        };
      }();
      MatLegacyFooterRowDef.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyFooterRowDef,
        selectors: [["", "matFooterRowDef", ""]],
        inputs: {
          columns: ["matFooterRowDef", "columns"],
          sticky: ["matFooterRowDefSticky", "sticky"]
        },
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkFooterRowDef,
          useExisting: MatLegacyFooterRowDef
        }]), i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyFooterRowDef, [{
          type: Directive,
          args: [{
            selector: '[matFooterRowDef]',
            providers: [{
              provide: CdkFooterRowDef,
              useExisting: MatLegacyFooterRowDef
            }],
            inputs: ['columns: matFooterRowDef', 'sticky: matFooterRowDefSticky']
          }]
        }], null, null);
      })();
      /**
       * Data row definition for the mat-table.
       * Captures the data row's template and other properties such as the columns to display and
       * a when predicate that describes when this row should be used.
       * @deprecated Use `MatRowDef` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyRowDef extends CdkRowDef {} exports('MatLegacyRowDef', MatLegacyRowDef);
      MatLegacyRowDef.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyRowDef_BaseFactory;
        return function MatLegacyRowDef_Factory(t) {
          return (ɵMatLegacyRowDef_BaseFactory || (ɵMatLegacyRowDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyRowDef)))(t || MatLegacyRowDef);
        };
      }();
      MatLegacyRowDef.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyRowDef,
        selectors: [["", "matRowDef", ""]],
        inputs: {
          columns: ["matRowDefColumns", "columns"],
          when: ["matRowDefWhen", "when"]
        },
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkRowDef,
          useExisting: MatLegacyRowDef
        }]), i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyRowDef, [{
          type: Directive,
          args: [{
            selector: '[matRowDef]',
            providers: [{
              provide: CdkRowDef,
              useExisting: MatLegacyRowDef
            }],
            inputs: ['columns: matRowDefColumns', 'when: matRowDefWhen']
          }]
        }], null, null);
      })();
      /**
       * Header template container that contains the cell outlet. Adds the right class and role.
       * @deprecated Use `MatHeaderRow` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyHeaderRow extends CdkHeaderRow {} exports('MatLegacyHeaderRow', MatLegacyHeaderRow);
      MatLegacyHeaderRow.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyHeaderRow_BaseFactory;
        return function MatLegacyHeaderRow_Factory(t) {
          return (ɵMatLegacyHeaderRow_BaseFactory || (ɵMatLegacyHeaderRow_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyHeaderRow)))(t || MatLegacyHeaderRow);
        };
      }();
      MatLegacyHeaderRow.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
        type: MatLegacyHeaderRow,
        selectors: [["mat-header-row"], ["tr", "mat-header-row", ""]],
        hostAttrs: ["role", "row", 1, "mat-header-row"],
        exportAs: ["matHeaderRow"],
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkHeaderRow,
          useExisting: MatLegacyHeaderRow
        }]), i0.ɵɵInheritDefinitionFeature],
        decls: 1,
        vars: 0,
        consts: [["cdkCellOutlet", ""]],
        template: function MatLegacyHeaderRow_Template(rf, ctx) {
          if (rf & 1) {
            i0.ɵɵelementContainer(0, 0);
          }
        },
        dependencies: [i1.CdkCellOutlet],
        encapsulation: 2
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyHeaderRow, [{
          type: Component,
          args: [{
            selector: 'mat-header-row, tr[mat-header-row]',
            template: CDK_ROW_TEMPLATE,
            host: {
              'class': 'mat-header-row',
              'role': 'row'
            },
            // See note on CdkTable for explanation on why this uses the default change detection strategy.
            // tslint:disable-next-line:validate-decorators
            changeDetection: ChangeDetectionStrategy.Default,
            encapsulation: ViewEncapsulation.None,
            exportAs: 'matHeaderRow',
            providers: [{
              provide: CdkHeaderRow,
              useExisting: MatLegacyHeaderRow
            }]
          }]
        }], null, null);
      })();
      /**
       * Footer template container that contains the cell outlet. Adds the right class and role.
       * @deprecated Use `MatFooterRow` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyFooterRow extends CdkFooterRow {} exports('MatLegacyFooterRow', MatLegacyFooterRow);
      MatLegacyFooterRow.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyFooterRow_BaseFactory;
        return function MatLegacyFooterRow_Factory(t) {
          return (ɵMatLegacyFooterRow_BaseFactory || (ɵMatLegacyFooterRow_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyFooterRow)))(t || MatLegacyFooterRow);
        };
      }();
      MatLegacyFooterRow.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
        type: MatLegacyFooterRow,
        selectors: [["mat-footer-row"], ["tr", "mat-footer-row", ""]],
        hostAttrs: ["role", "row", 1, "mat-footer-row"],
        exportAs: ["matFooterRow"],
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkFooterRow,
          useExisting: MatLegacyFooterRow
        }]), i0.ɵɵInheritDefinitionFeature],
        decls: 1,
        vars: 0,
        consts: [["cdkCellOutlet", ""]],
        template: function MatLegacyFooterRow_Template(rf, ctx) {
          if (rf & 1) {
            i0.ɵɵelementContainer(0, 0);
          }
        },
        dependencies: [i1.CdkCellOutlet],
        encapsulation: 2
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyFooterRow, [{
          type: Component,
          args: [{
            selector: 'mat-footer-row, tr[mat-footer-row]',
            template: CDK_ROW_TEMPLATE,
            host: {
              'class': 'mat-footer-row',
              'role': 'row'
            },
            // See note on CdkTable for explanation on why this uses the default change detection strategy.
            // tslint:disable-next-line:validate-decorators
            changeDetection: ChangeDetectionStrategy.Default,
            encapsulation: ViewEncapsulation.None,
            exportAs: 'matFooterRow',
            providers: [{
              provide: CdkFooterRow,
              useExisting: MatLegacyFooterRow
            }]
          }]
        }], null, null);
      })();
      /**
       * Data row template container that contains the cell outlet. Adds the right class and role.
       * @deprecated Use `MatRow` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyRow extends CdkRow {} exports('MatLegacyRow', MatLegacyRow);
      MatLegacyRow.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyRow_BaseFactory;
        return function MatLegacyRow_Factory(t) {
          return (ɵMatLegacyRow_BaseFactory || (ɵMatLegacyRow_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyRow)))(t || MatLegacyRow);
        };
      }();
      MatLegacyRow.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
        type: MatLegacyRow,
        selectors: [["mat-row"], ["tr", "mat-row", ""]],
        hostAttrs: ["role", "row", 1, "mat-row"],
        exportAs: ["matRow"],
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkRow,
          useExisting: MatLegacyRow
        }]), i0.ɵɵInheritDefinitionFeature],
        decls: 1,
        vars: 0,
        consts: [["cdkCellOutlet", ""]],
        template: function MatLegacyRow_Template(rf, ctx) {
          if (rf & 1) {
            i0.ɵɵelementContainer(0, 0);
          }
        },
        dependencies: [i1.CdkCellOutlet],
        encapsulation: 2
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyRow, [{
          type: Component,
          args: [{
            selector: 'mat-row, tr[mat-row]',
            template: CDK_ROW_TEMPLATE,
            host: {
              'class': 'mat-row',
              'role': 'row'
            },
            // See note on CdkTable for explanation on why this uses the default change detection strategy.
            // tslint:disable-next-line:validate-decorators
            changeDetection: ChangeDetectionStrategy.Default,
            encapsulation: ViewEncapsulation.None,
            exportAs: 'matRow',
            providers: [{
              provide: CdkRow,
              useExisting: MatLegacyRow
            }]
          }]
        }], null, null);
      })();
      /**
       * Row that can be used to display a message when no data is shown in the table.
       * @deprecated Use `MatNoDataRow` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyNoDataRow extends CdkNoDataRow {
        constructor() {
          super(...arguments);
          this._contentClassName = 'mat-no-data-row';
        }
      } exports('MatLegacyNoDataRow', MatLegacyNoDataRow);
      MatLegacyNoDataRow.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyNoDataRow_BaseFactory;
        return function MatLegacyNoDataRow_Factory(t) {
          return (ɵMatLegacyNoDataRow_BaseFactory || (ɵMatLegacyNoDataRow_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyNoDataRow)))(t || MatLegacyNoDataRow);
        };
      }();
      MatLegacyNoDataRow.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
        type: MatLegacyNoDataRow,
        selectors: [["ng-template", "matNoDataRow", ""]],
        features: [i0.ɵɵProvidersFeature([{
          provide: CdkNoDataRow,
          useExisting: MatLegacyNoDataRow
        }]), i0.ɵɵInheritDefinitionFeature]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyNoDataRow, [{
          type: Directive,
          args: [{
            selector: 'ng-template[matNoDataRow]',
            providers: [{
              provide: CdkNoDataRow,
              useExisting: MatLegacyNoDataRow
            }]
          }]
        }], null, null);
      })();

      /**
       * @license
       * Copyright Google LLC All Rights Reserved.
       *
       * Use of this source code is governed by an MIT-style license that can be
       * found in the LICENSE file at https://angular.io/license
       */
      /**
       * Column that simply shows text content for the header and row cells. Assumes that the table
       * is using the native table implementation (`<table>`).
       *
       * By default, the name of this column will be the header text and data property accessor.
       * The header text can be overridden with the `headerText` input. Cell values can be overridden with
       * the `dataAccessor` input. Change the text justification to the start or end using the `justify`
       * input.
       *
       * @deprecated Use `MatTextColumn` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyTextColumn extends CdkTextColumn {} exports('MatLegacyTextColumn', MatLegacyTextColumn);
      MatLegacyTextColumn.ɵfac = /* @__PURE__ */function () {
        let ɵMatLegacyTextColumn_BaseFactory;
        return function MatLegacyTextColumn_Factory(t) {
          return (ɵMatLegacyTextColumn_BaseFactory || (ɵMatLegacyTextColumn_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyTextColumn)))(t || MatLegacyTextColumn);
        };
      }();
      MatLegacyTextColumn.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
        type: MatLegacyTextColumn,
        selectors: [["mat-text-column"]],
        features: [i0.ɵɵInheritDefinitionFeature],
        decls: 3,
        vars: 0,
        consts: [["matColumnDef", ""], ["mat-header-cell", "", 3, "text-align", 4, "matHeaderCellDef"], ["mat-cell", "", 3, "text-align", 4, "matCellDef"], ["mat-header-cell", ""], ["mat-cell", ""]],
        template: function MatLegacyTextColumn_Template(rf, ctx) {
          if (rf & 1) {
            i0.ɵɵelementContainerStart(0, 0);
            i0.ɵɵtemplate(1, MatLegacyTextColumn_th_1_Template, 2, 3, "th", 1);
            i0.ɵɵtemplate(2, MatLegacyTextColumn_td_2_Template, 2, 3, "td", 2);
            i0.ɵɵelementContainerEnd();
          }
        },
        dependencies: [MatLegacyHeaderCellDef, MatLegacyColumnDef, MatLegacyCellDef, MatLegacyHeaderCell, MatLegacyCell],
        encapsulation: 2
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyTextColumn, [{
          type: Component,
          args: [{
            selector: 'mat-text-column',
            template: `
    <ng-container matColumnDef>
      <th mat-header-cell *matHeaderCellDef [style.text-align]="justify">
        {{headerText}}
      </th>
      <td mat-cell *matCellDef="let data" [style.text-align]="justify">
        {{dataAccessor(data, name)}}
      </td>
    </ng-container>
  `,
            encapsulation: ViewEncapsulation.None,
            // Change detection is intentionally not set to OnPush. This component's template will be provided
            // to the table to be inserted into its view. This is problematic when change detection runs since
            // the bindings in this template will be evaluated _after_ the table's view is evaluated, which
            // mean's the template in the table's view will not have the updated value (and in fact will cause
            // an ExpressionChangedAfterItHasBeenCheckedError).
            // tslint:disable-next-line:validate-decorators
            changeDetection: ChangeDetectionStrategy.Default
          }]
        }], null, null);
      })();

      /**
       * @license
       * Copyright Google LLC All Rights Reserved.
       *
       * Use of this source code is governed by an MIT-style license that can be
       * found in the LICENSE file at https://angular.io/license
       */
      const EXPORTED_DECLARATIONS = [
      // Table
      MatLegacyTable, MatLegacyRecycleRows,
      // Template defs
      MatLegacyHeaderCellDef, MatLegacyHeaderRowDef, MatLegacyColumnDef, MatLegacyCellDef, MatLegacyRowDef, MatLegacyFooterCellDef, MatLegacyFooterRowDef,
      // Cell directives
      MatLegacyHeaderCell, MatLegacyCell, MatLegacyFooterCell,
      // Row directives
      MatLegacyHeaderRow, MatLegacyRow, MatLegacyFooterRow, MatLegacyNoDataRow, MatLegacyTextColumn];
      /**
       * @deprecated Use `MatTableModule` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyTableModule {} exports('MatLegacyTableModule', MatLegacyTableModule);
      MatLegacyTableModule.ɵfac = function MatLegacyTableModule_Factory(t) {
        return new (t || MatLegacyTableModule)();
      };
      MatLegacyTableModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
        type: MatLegacyTableModule
      });
      MatLegacyTableModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
        imports: [CdkTableModule, MatCommonModule, MatCommonModule]
      });
      (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyTableModule, [{
          type: NgModule,
          args: [{
            imports: [CdkTableModule, MatCommonModule],
            exports: [MatCommonModule, EXPORTED_DECLARATIONS],
            declarations: EXPORTED_DECLARATIONS
          }]
        }], null, null);
      })();

      /**
       * @license
       * Copyright Google LLC All Rights Reserved.
       *
       * Use of this source code is governed by an MIT-style license that can be
       * found in the LICENSE file at https://angular.io/license
       */
      /**
       * Data source that accepts a client-side data array and includes native support of filtering,
       * sorting (using MatSort), and pagination (using paginator).
       *
       * Allows for sort customization by overriding sortingDataAccessor, which defines how data
       * properties are accessed. Also allows for filter customization by overriding filterPredicate,
       * which defines how row data is converted to a string for filter matching.
       *
       * **Note:** This class is meant to be a simple data source to help you get started. As such
       * it isn't equipped to handle some more advanced cases like robust i18n support or server-side
       * interactions. If your app needs to support more advanced use cases, consider implementing your
       * own `DataSource`.
       *
       * @deprecated Use `MatTableDataSource` from `@angular/material/table` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
       * @breaking-change 17.0.0
       */
      class MatLegacyTableDataSource extends _MatTableDataSource {} exports('MatLegacyTableDataSource', MatLegacyTableDataSource);

    })
  };
}));
//# sourceMappingURL=angular-legacy-table.js.map
